.386c

; - RarView -> Archiv-Viewer fr RAR-Archive
; - (c) iCode 1996

; Gebrauch :
;   1st : CALL InitRar                  ; reads and saves rar-archive-data
;   2nd : CALL CHANGE_RAR_DIRECTORY     ; changes directory inside rar-archive
;   3rd : CALL CLOSE_RAR_ARCHIVE        ; terminates processing
;
; Note:
;   Never forget to terminate correctly !!

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    filename         db 'test.rar',0  ;!
    filesize         dd 24796         ;!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    next_value       dw 0h
    transfer_counter dw 0h
    handle           dw 0h
    arcpos           dd 0h
    file_counter     dw 0h
    DirEntry      dw 0h
    number_of_dirs   dw 0h
    FileTable       dw 0h              ; @ Interne File-Liste
    DirTable    dw 0h              ; @ Verzeichnisbaum
    ShellDir         dw 0h              ; @ Shell-formatierte File-Liste
    internal_dir     db 0h
    ArcBuf db 500 dup (0)               ; lokaler File-Header
    PackedFileName db 500 dup (0)             ; File_Name mit Directory-Struktur

InitRar proc                            ; initialisiert RAR Archive Handling
        push cs
        pop ds

        mov ah, 48h                     ; }
        mov bx, 4096                    ; }
        int 21h                         ; }  Getmem(FileTable, FFFF)
        jc @error                       ; }
        mov FileTable, ax               ; }

        mov ah, 48h                     ; }
        mov bx, 4096                    ; }
        int 21h                         ; } Getmem(DirTable, FFFF)
        jc @error                       ; }
        mov DirTable, ax                ; }

        mov ah, 48h                     ; }
        mov bx, 4096                    ; }
        int 21h                         ; } getmem(ShellDir, FFFF)
        jc @error                       ; }
        mov ShellDir, ax                ; }

        mov dx, offset filename         ; }
        mov ax, 3d00h                   ; }
        int 21h                         ; } Assign(Handle, filename)
        jc @error                       ; }
        mov handle, ax                  ; }

      LokalHeader:
        push cs
        pop ds
        pusha
        mov dx, offset ArcBuf               ; }
        mov bx, handle                      ; }
        mov cx, 20h                         ; } blockread(handle,ArcBuf,32)
        mov ah, 3fh                         ; }
        int 21h                             ; }
        jnc NoReadError1
        jmp @error                          ; Fehler beim Lesen !!!
      NoReadError1:
        cmp byte ptr (offset ArcBuf+2), 74h ; } If not LokalHeader then
        jne NoPackedData                    ; } jump down (keine PackedData)

        mov cx, word ptr (offset ArcBuf+5)  ; }
        sub cx, 20h                         ; }
        mov dx, offset ArcBuf + 20h         ; } blockread(handle,ArcBuf+32,
        mov ah, 3fh                         ; }   HeaderSize-20h)
        int 21h                             ; }
        jnc NoReadError2                    ; } (Restlichen Header einlesen)
        jmp @error                          ; }
      NoReadError2:
        popa
        test byte ptr offset ArcBuf+4, 80h  ; folgen dem Header gepackte Daten ??
        je NoPackedData
        mov eax, dword ptr offset ArcBuf+7  ; }
        add arcpos, eax                     ; } add ArcPos, AddSize
      NoPackedData:
        movzx eax, word ptr offset ArcBuf+5 ; }
        add arcpos, eax                     ; } add ArcPos, HeaderSize

        cmp byte ptr offset ArcBuf+2, 74h   ; }
        jne StepForward                     ; } if not FileHeader then next block

        mov di, offset PackedFileName       ; }
        mov si, offset ArcBuf+20h           ; } Filenamen des gepackten Files
        mov ax, cs                          ; }
        mov es, ax                          ; }
        mov cx, word ptr offset ArcBuf+01ah ; } als (Word-)Pascal-String in
        mov ax, cx                          ; } PackedFileName ablegen
        stosw                               ; }
        rep movsb                           ; }

        call FileHeader                     ; entsprechendes Verzeichnis suchen...
        push cs
        pop ds
        inc file_counter                    ; Zhlvariable erhhen...
        jmp StepForward
      StepForward:
        mov eax, arcpos                     ; file-Position in EAX laden
        cmp eax, filesize                   ; mit Datei-Gre vergleichen
        jae FinishedReading
        mov dx, ax                          ; }
        shr eax, 16                         ; }
        mov cx, ax                          ; }
        mov ax, 4200h                       ; } seek(handle, arcpos)
        mov bx, handle                      ; }
        int 21h                             ; }
        jnc NoSeekError1
        jmp @error
      NoSeekError1:
        jmp LokalHeader
      FinishedReading:                      ; Ende der Datei erreicht...
        ret                                 ; Prozedur verlassen...
InitRar endp

FileHeader proc
    test byte ptr ArcBuf+1ch, 10h       ; } If not FileAttrib =Directory then
    jz PackedFile                       ; } continue, else leave
    call directory_found                ;;; HIER OPTIMIEREN !!! (CALL->JMP)
    ret
  PackedFile:
    mov si, offset PackedFileName       ; } DS:SI PackedFileName
    mov es, DirTable                    ; }
    xor di, di                          ; } ES:DI DirTable
    mov bp, si                          ; }
    inc bp                              ; }
    add si, word ptr [si]               ; } DS:SI zeigt jetzt auf das Ende des
    inc si                              ; } gleichen Stringes...
  SearchBackslash:
    cmp byte ptr [si], '\'
    je SubSubDir                        ; Directory ist ein Unter-Unterverzeichnis
    dec si
    cmp si, bp                          ; } String-Anfang erreicht -> kein Back-
    je RootDir                          ; } slash -> Verzeichnis ist im Root-Dir
    jmp SearchBackslash
  RootDir:
    inc si
    mov DirEntry, 0                     ; Root-Eintrge haben Dir-Nummer 0
    call StoreFile                      ;;; HIER OPTIMIEREN ! CALL -> JMP
    ret
  SubSubDir:
    dec si
    mov ax, si
    sub ax, bp
    mov ds:[bp-1], ax
  @search_equal_dir:
    mov es, DirTable                    ; } ES:DI -> 1st Entry of Dir_Entry_Table
    xor di, di                          ; }

    mov cs:DirEntry, 0
    mov si, offset PackedFileName       ; DS:SI -> PackedFileName
  CompareDirectories:
int 3
    inc DirEntry
    mov cx, number_of_dirs
    cmp direntry, cx
    jae XXX
    mov ax, es:[di]
    push di
    push si
    mov cx, es:[di]
    add cx, 3
    repe cmpsb
    jcxz @equal_names
    pop si
    pop di
    add di, ax
    add di, 2
    mov next_value, si
    jmp CompareDirectories
  XXX:
    call directory_found
    int 3
    ret
  @equal_names:
    pop ax
    pop ax              ; stack 'leer' machen
  @copy_packed_file_data:
    call StoreFile
    ret
FileHeader endp

convert_data_to_shell_format proc
    ret
endp

directory_found proc
    mov ax, cs
    mov es, ax
    mov di, offset PackedFileName
    mov ds, cs:DirTable
    xor si, si
    mov cx, cs:number_of_dirs
    cmp cx, 0
    je @done_04
  @loop_04:
    add si, ds:[si]
    add si, 2
    loop @loop_04
  @done_04:
    mov cs:next_value, si
  @create_new_entry:
    ; DS:NEXT_VALUE zeigt auf freien 'Eintrag'
    ; ES:DI zeigt auf PackedFileName
    mov ax, cs
    mov es, ax
    mov di, offset PackedFileName
    mov si, cs:next_value
    inc cs:number_of_dirs
    mov ax, es:[di]
    mov ds:[si], ax
    add di, 2
    add si, 2
    mov cx, ax
  @loop_01:
    mov al, es:[di]
    mov ds:[si], al
    inc di
    inc si
    loop @loop_01
    ret
endp

rar_close_arc proc                      ; Schliet RAR-Archiv
    ret
endp

rar_change_dir proc			; Wechselt internes Verzeichnis
    ret
endp

error db 'Error !!!$'

@error:
    push ds
    mov ax, cs
    mov ds, ax
    mov dx, offset error
    mov ah, 9
    int 21h
    pop ds
 
.exit

StoreFile proc
    mov es, FileTable                   ; }
    mov di, 29                          ; }
    mov ax, file_counter                ; }
    mul di                              ; }
    mov di, ax                          ; } ES:DI Dir-Nr * 29
    mov si, offset ArcBuf               ; } DS:SI Arcbuf

    mov al, ds:[si+1ch]                 ; }
    stosb                               ; } save attribute

    mov si, offset PackedFilename
    mov cx, word ptr [si]
    add si, word ptr [si]
    inc si
    mov bx, si
  Loop1:
    cmp byte ptr [si], '\'
    je Labelx
    dec si
    loop Loop1
  Labelx:
    sub bx, si
    inc si
    mov cx, 8
  SpaceFilename:
    cmp byte ptr [si], '.'
    je PointFound
    movsb
    dec cl
    dec bx
    cmp bx, 0
    jne SpaceFilename
    jmp DateTime
  PointFound:
    mov al, 20h
    rep stosb
    mov al, 20h
    stosb
    inc si
    dec bx
    mov cx, 3
  SpaceSuffix:
    movsb
    dec cx
    dec bx
    cmp bx, 0
    je FillSuffix
    cmp cx, 0
    je FillSuffix
    jmp SpaceSuffix
  FillSuffix:
    mov al, 20h
    rep movsb
  DateTime:
    mov si, offset ArcBuf               ; }
    mov ax, ds:[si+14h]                 ; }
    stosw                               ; } save date and time
    mov ax, ds:[si+16h]                 ; }
    stosw                               ; }

    mov si, offset ArcBuf               ; }
    mov eax, ds:[si+0bh]                ; } save ungepackte Dateigre
    stosd                               ; }

    mov ax, DirEntry                    ; }
    stosw                               ; } Verzeichnisnummer sichern

    mov si, offset ArcBuf               ; }
    mov ax, ds:[si+3h]                  ; } Attribute sichern
    stosw                               ; }

    mov si, offset ArcBuf               ; }
    mov eax, ds:[si+07h]                ; } gepackte Dateigre sichern
    stosd                               ; }
    ret
StoreFile endp

transfer_directory_data_to_shell_format proc
  ; in CX muss (!) die Anzahl der Bytes stehen, sonst geht's net...
    push ds
    pusha
    mov ax, cs:transfer_counter
    mov bx, 25
    mul bx
    mov ds, cs:ShellDir
    mov si, ax
    mov al, 10h
    mov ds:[si], al
    inc si
    mov dl, 8
@vorname_loop:
    mov al, es:[di]
    cmp al, '.'
    je @draw_spaces
    mov [si], al
    inc di
    dec dl
    inc si
    loop @vorname_loop
@draw_spaces:
    mov bh, dl
    shr bx, 8
    inc bx
    mov al, 20h
    cld
  @label_010:
    mov al, 20h
    mov ds:[si], al
    inc si
    dec bx
    cmp bx, 0
    jne @label_010
    mov dl, 3
@nachname_loop:
    cmp cx, 0
    je @label_012
    mov al, es:[di]
    mov [si], al
    inc di
    inc si
    dec dl
    loop @nachname_loop
  @label_012:
    mov bh, dl
    shr bx, 8
  @loop_011:
    mov al, 20h
    mov ds:[si], al
    inc si
    dec bx
    cmp bx, 0
    jne @loop_011
@done_name:
    ; Jetzt kommt die Zeit...
    xor ax, ax
    mov ds:[si], ax
    add si, 2
    mov ds:[si], ax
    add si, 2
    ; Jetzt kommt die Groesse...
    mov ds:[si], ax
    add si, 2
    mov ds:[si], ax
    add si, 2
    ; Jetzt kommt das Pointer-Feld, was wir eigentlich nicht brauchen...
    mov ds:[si], ax
    add si, 2
    ; Jetzt kommen die Archiv-Attribute
    mov ds:[si], ax
    add si, 2
; Funktion verlassen und Register wiederherstellen
    mov es, cs:DirTable
    popa
    pop ds
    inc cs:transfer_counter
    inc cs:next_value
    ret
endp

change_rar_directory proc
; Zuerst die adquaten Verzeichnisse heraussuchen, dies mu leider sein, da RAR
; die Verzeichnisse im Gegensatz zu den Files nicht in der Reihenfolge ihrer
; physikalischen Abhngigkeit ablegt, ein internes Unterverzeichnis eines inter-
; nen Verzeichnisses knnte also ebenso vor dem Uebergeordneten Verz. kommen...
; ES:DI -> DIR_TABLE Eintrag
; DS:SI -> gesuchtes Verzeichnis
    mov es, cs:DirTable
    xor di, di
    mov ax, cs
    mov ds, ax
    mov dx, cs:number_of_dirs
  @loop_dir_compare:
    cmp dx, 0
    je @file_scan
    mov bp, es:[di]
    mov si, offset internal_dir
    mov cx, ds:[si]
    add cx, 1
    push di
    add di, 2
    add si, 2
    repe cmpsb
    jcxz @equal_dir
    pop di
  @go_on_2:
    add di, bp
    add di, 2
    dec dx
    cmp dx, 0
    jne @loop_dir_compare
  @equal_dir:
    push di
  @loop_a:
    mov al, es:[di]
    cmp al, '\'
    je @found_02
    inc di
    jmp @loop_a
  @found_02:
    mov cx, di
    pop ax
    sub cx, ax
    mov di, ax
    call transfer_directory_data_to_shell_format
    pop di
    jmp @go_on_2
  @file_scan:
; DS:SI -> gesuchtes Verzeichnis
; ES:DI -> Eintrag in Verzeichnisbaum
; DX    -> Zhler fr Anzahl der Verzeichnisse, wird runtergezhlt bis == 0
    mov ax, cs
    mov ds, ax
    mov es, cs:DirTable
    xor di, di
    mov dx, cs:number_of_dirs
  @dir_scan_loop:
    mov si, offset internal_dir
    mov cs:DirEntry,0
    mov bp, es:[di]
    mov cx, bp
    push di
    repe cmpsb
    jcxz @equal_directory_entry_found
    pop di
    add di, bp
    inc cs:DirEntry
    dec dx
    cmp dx, 0
    jne @dir_scan_loop
    ret
  @equal_directory_entry_found:
    pop di
  ; in CS:DirEntry steht jetzt die Nummer des Verzeichnisses
  ; jetzt alle files heraussuchen, die diese Nummer besitzen...
    mov cx, cs:number_of_dirs
    mov ax, cs:FileTable
    mov ds, ax
    xor si, si
  @loop_scan_files:
    mov ax, ds:[si+21h]
    cmp ax, cs:DirEntry
    call convert_data_to_shell_format
    jne @go_on_01
    add si, 29
  @go_on_01:
    loop @loop_scan_files
    ret
endp

; ARCVIEW interne Struktur:

; Lnge : 25 byte
;
;  byte-offset 0   =   DOS-Attribut mit
;                        1 readOnly
;                        2 hidden
;                        4 system
;                        8 volume-id
;                       16 directory
;                       32 archive
;          1 - 8   =   Dateiname (erste acht Zeichen) -> aufgefllt mit space
;              9   =   space (32) oder  (176) bei hidden
;        10 - 12   =   Datei-Extension (drei Zeichen) -> aufgefllt mit space
;        13 - 14   =   Datum der letzten nderung -> DOS-Format!
;        15 - 16   =   Zeit der letzten nderung -> DOS-Format!
;        17 - 20   =   Dateigre in byte (dword)
;        21 - 22   =   pointer auf Directory-Liste fr archiv-viewer
;        23 - 24   =   archiv-Attribute
;        25 - 28   =   ungepackte Dateigroesse
;

end
