; kleiner file viewer.

.286c
code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

filename     db 13 dup (0)
oldss        dw 0
oldsp        dw 0
handle       dw 0
filesize     dd 0
bmpstart     dw 0                       ; screen startpos inside the file buffer
xres         dw 0
yres         dw 0
bits         db 0
colours      dw 0

assign_file proc
  push ds
  push cs
  pop ds
  mov dx, offset cs:filename
  mov ax, 3d00h
  int 21h
  jnc @weiter8
  jmp cs:@error
  @weiter8:
  pop ds
  mov cs:handle, ax
  ret
endp

build_screen_8 proc
  mov cx, 0ffffh
  call read
  xor si, si
  mov ax, cs:yres
  mov bx, cs:xres
  mul bx
  mov di, ax
  mov dx, bx
  shr dx, 2
  shl bx, 1
  cld
  @loop_reihe1:
    sub di, bx
    mov cx, dx
    .386c
    rep movsd
    .286c
    cmp di, 0
  jne @loop_reihe1
  ret
endp

switch_plane proc
    push ax
    mov dx, 3c4h
    mov al, 2
    out dx, al
    mov dx, 3c5h
    in al, dx
    and al, 11110000b
    pop bx
    add al, bl
    push ax
    mov dx, 3c4h
    mov al, 2
    out dx, al
    mov dx, 3c5h
    pop ax
    out dx, al
    ret
endp

; Baut Bildschirm auf, Farbtiefe: 4 Bits
build_screen_4 proc
    ; erstes Viertel...
    mov al, 00h
    call switch_plane
    mov cx, 80
    xor di, di
    mov al, 05eh
    rep stosb
    ret
    call read
    mov ax, 640
    mov bx, cs:yres
    mul bx
    shr ax, 2
    mov di, ax
    xor si, si
    mov bx, cs:yres
    cld
  @loop_4_bit_zeile:
    mov cx, cs:xres
    shr cx, 2
    @loop_4_bit_pixel:
      lodsb
      inc si
      and al, 0fh
      stosb
    loop @loop_4_bit_pixel
    mov ax, cs:xres
    shr ax, 2
    sub di, ax
    sub di, ax
    dec bx
    cmp bx, 0
  jne @loop_4_bit_zeile

  ret
endp

init_screen proc
  mov al, cs:bits
  cmp al, 8
  jne @build_4
  @build_8:
    mov ax, 13h
    int 10h
    ret
  @build_4:
    mov ax, 12h
    int 10h
    ret
endp

decide proc
  mov al, cs:bits
  cmp al, 8
  jne @build4
  @build8:
    call build_screen_8
    ret
  @build4:
    call build_screen_4
    ret
endp

getmem proc
  mov ah, 48
  mov bx, 4096
  int 21h
  jnc @weiter4
  jmp @error
  @weiter4:
  mov ds, ax
  ret
endp

read proc
  mov ah, 3fh
  mov bx, cs:handle
  xor dx, dx
  int 21h
  jnc @weiter5
  jmp cs:@error
  @weiter5:
  ret
endp

read_header proc
  xor cx, cx
  xor dx, dx
  call seek
  mov cx, 36h
  call read
  mov ax, ds:[12h]
  mov cs:xres, ax
  mov ax, ds:[16h]
  mov cs:yres, ax
  mov ax, ds:[0ch]
  mov cs:bmpstart, ax
  mov al, ds:[1ch]
  mov cs:bits, al
  mov ax, ds:[2eh]
  mov cs:colours, ax
  ret
endp

set_pal proc                            ; bl=colour, bh, cl, ch = rgb
  mov dx, 3c8h
  mov al, bl
  out dx, al
  mov dx, 3c9h
  mov al, bh
  shr al, 2
  out dx, al
  mov al, cl
  shr al, 2
  out dx, al
  mov al, ch
  shr al, 2
  out dx, al
  ret
endp

def_pal proc
  xor cx, cx
  mov dx, 36h
  call seek
  mov cx, cs:colours
  shl cx, 2
  call read
  xor si, si
  xor bl, bl
  cld
  @loop_colour:
    lodsb
    mov ch, al
    lodsb
    mov cl, al
    lodsb
    mov bh, al
    call set_pal
    inc si
    inc bl
    cmp si, 1024
  jne @loop_colour
  ret
endp

seek proc
  mov ax, 4200h
  mov bx, cs:handle
  int 21h
  jnc @raus1
    jmp cs:@error
  @raus1:
  ret
endp

get_name proc
  push ds
  push es
  push 80h
  pop si
  push cs
  pop ds
  mov cl, ds:[si]
  xor ch, ch
  cmp cx, 1
  ja @weiter18
  pop es
  pop ds
  jmp cs:@error
  @weiter18:
  mov ax, cs
  mov es, ax
  mov di, offset filename
  add si, 2
  dec cx
  cld
  rep movsb
  xor al, al
  mov es:[di], al
  pop es
  pop ds
  ret
endp

get_size proc
  push ds
  push cs
  pop ds
  mov dx, offset filename
  mov cx, 0ffh
  mov ah, 4eh
  int 21h
  mov ax, cs:[09ah]
  mov cs:[word ptr cs:filesize], ax
  mov ax, cs:[09ch]
  mov cs:[word ptr cs:filesize+2], ax
  pop ds
  ret
endp

define_nbr_of_colours proc
  mov ax, cs:colours
  cmp ax, 0
  jne @raus5
  @8bit:
    mov al, cs:bits
    cmp al, 8
    jne @4bit
    mov ax, 100h
    mov cs:colours, ax
    ret
  @4bit:
    cmp al, 4
    jne @raus5
    mov ax, 10h
    mov cs:colours, ax
    ret
  @raus5:
  ret
endp

begin:
        cli
        push ds
        push bp
        mov cs:oldsp, sp
        mov cs:oldss, ss
        mov     ax,cs
        mov     ss,ax
@stk1:  mov     sp,(offset done) + 510
        sti
        mov     ax,cs
        mov     ds,ax
        mov     es,ax           ; Adresse des zu ndernden Blocks in es
@stk2:  mov     bx,(offset done) + 600    ; neue Blocklnge < kleiner als alte(64k)
        shr     bx,4            ; durch 16 teilen => Angabe in Paragraphen
        mov     ah,4ah          ; dos-resize-blocklen-call
        int     21h

  push 0a000h
  pop es
  ; ***********************************************************************
  ; Diese Prozedur kann wieder weg, sobald die API funktioniert...
  call get_name
  call get_size
  call getmem
  call assign_file
  call read_header
  call define_nbr_of_colours
  call init_screen
  call def_pal
  call decide
  xor ax, ax
  int 16h

  ;mov ax, 3
  ;int 10h

  @quit:
  mov sp, cs:oldsp
  mov ss, cs:oldss
  pop bp
  pop ds
  mov ah, 4ch
  int 21h

@error:
    mov dx, offset error0
    cmp ax, 2
    jne @l1
    mov dx, offset error2
    @l1:
    cmp ax, 3
    jne @l2
    mov dx, offset error3
    @l2:
    cmp ax, 4
    jne @l3
    mov dx, offset error4
    @l3:
    cmp ax, 5
    jne @l4
    mov dx, offset error5
    @l4:
    cmp ax, 6
    jne @l5
    mov dx, offset error6
    @l5:
    cmp ax, 7
    jne @l6
    mov dx, offset error7
    @l6:
    cmp ax, 8
    jne @l7
    mov dx, offset error8
    @l7:
    cmp ax, 9
    jne @l8
    mov dx, offset error9
    @l8:
    cmp ax, 15h
    jne @l9
    mov dx, offset error15
    @l9:
    cmp ax, 1bh
    jne @la
    mov dx, offset error1b
    @la:
    cmp ax, 1eh
    jne @lb
    mov dx, offset error1e
    @lb:
    cmp ax, 1fh
    jne @lc
    mov dx, offset error1f
    @lc:
    mov ah,9
    int 21h
    call @quit

    error0 db 'Fehler, $'
    error2 db 'Datei nicht gefunden !$'
    error3 db 'Pfad nicht gefunden !$'
    error4 db 'Zu viele Dateien geoeffnet !$'
    error5 db 'Zugriff verweigert !$'
    error6 db 'Ungueltiges Handle !$'
    error7 db 'Memory Control Block zerstoert !$'
    error8 db 'Zu wenig Speicher !$'
    error9 db 'Memory Block Adresse ungueltig !$'
    error15 db 'Ungueltiges Laufwerk !$'
    error1b db 'Sektor nicht gefunden !$'
    error1e db 'Allgemeiner Lesefehler !$'
    error1f db 'Allgemeiner Fehler !$'

    ; eigene Fehlermeldungen :
    ; Spaeter API Check...


endp

done    equ     this byte

        db      512     dup (0)

code    ends
        end     entry

