{$A+,B-,D+,E+,F+,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}
var
  filehandle : word;
  s : string;
  char : array [0..255, 0..13] of byte;
  nbr : byte;
  done : boolean;
  colour1 : word;
  filename : string;

procedure readchar; assembler;
asm
    push bp
    push ds

    mov ax, 1130h
    mov bh, 2
    int 10h
    push es
    pop ds
    mov si, bp

    pop ax
    pop bp
    push ax

    mov es, ax
    mov di, offset char
    mov cx, 14*256
    cld
    rep movsb

    pop ds
end;

procedure draw_lines(xstart: word; col:byte); Assembler;
  asm
    push 0a000h
    pop es
  { Horizontale Linien zeichnen }
    xor cl, cl				{ cl:= 'Y' }
  @YLoop:
    xor ch, ch				{ ch:='X' }
    mov al, 11
    mul cl				{ Y*11 -> AX }
    add ax, 25				{ Vertikale Zentrierung }
    mov bx, 320				
    mul bx				{ Mit 320 multiplizieren }
    mov di, ax
    add di, xstart
  @XLoop:
    mov al, col
    stosb
    inc ch
    cmp ch, 89
    jb @XLoop
    inc cl
    cmp cl, 15
    jb @YLoop

  { Vertikale Linien zeichnen }
    xor ch, ch				{ CH:='X' }
  @XLoop2:
    xor cl, cl				{ CL:='Y' }
    mov al, 11
    mul ch
    mov di, ax
    add di, xstart
    add di, 25*320			{ vertikale Zentrierung }
  @YLoop2:
    mov al, col
    stosb
    add di, 319
    inc cl
    cmp cl, 155
    jb @YLoop2
    inc ch
    cmp ch, 9
    jb @XLoop2
end;

procedure putbigpixel(Start : word; col:byte); assembler;
  asm
    push 0a000h
    pop es
    mov di, start
    mov al, col
    mov dl, 10
  @YLoop:
    mov cx, 10
    push di
  @Xloop:
    stosb
    loop @XLoop
    pop di
    add di, 320
    dec dl
    cmp dl, 0
    jne @YLoop
end;

procedure draw_char(xstart:word; col:byte; n:byte); Assembler;
  { kleinen Buchstaben ausgeben }
  asm
    mov cx, xstart
    xor dl, dl
  @loop:
    cmp cx, 0
    je @lb02
    add dl, 13
    loop @loop
  @lb02:
    mov ah, 2
    xor bh, bh
    mov dh, 2
    int 10h
    xor bh, bh
    mov al, n
    mov ah, 0ah
    mov cx, 1
    int 10h
  { groen Buchstaben ausgeben }
    push 0a000h
    pop es
    mov si, offset char
    mov ax, 100
    mul xstart
    mov di, ax
    mov al, 14
    add di, 26*320+1

    mul n
    add si, ax
    mov cx, 14
  @XLoop:
    lodsb
    mov ah, 128
    push di
  @BitLoop:
    test al, ah
    jz @bit_not_set
    pusha
    push di
    mov al, col
    xor ah, ah
    push ax
    call putbigpixel
    popa
  @bit_not_set:
    add di, 11
    shr ah, 1
    cmp ah, 0
    jne @BitLoop
    pop di
    add di, 320*11
    loop @XLoop
end;

procedure draw_title; assembler;
asm
    mov ah, 9
    mov dx, offset s
    inc dx
    int 21h
end;

procedure del_char(xstart:word); Assembler;
asm;
    mov di, 25*320+320+1
    add di, xstart
    mov bl, 14
  @YLoop:
    mov cx, 8
    push di
  @XLoop:
    pusha
    push di
    push 0
    call putbigpixel
    popa
    add di, 11
    loop @xloop
    pop di
    add di, 320*11
    dec bl
    cmp bl, 0
    jne @YLoop
end;

procedure show_mouse; assembler;
asm
  mov ax, 1
  int 33h
end;

procedure hide_mouse; assembler;
asm
  mov ax, 2
  int 33h
end;

procedure clear_buffer; assembler;
asm
  push 40h
  pop es
  mov ax, es:[01ah]
  mov es:[1ch], ax
end;

procedure assign_file; assembler;
asm;
  mov ax, 3d02h
  mov dx, offset filename+1
  int 21h
  mov filehandle, ax
end;

procedure save; Assembler;
asm;
  call assign_file
  mov ah, 40h
  mov bx, filehandle
  mov cx, 256*14
  mov dx, offset char
  int 21h
end;

procedure load; Assembler;
asm;
  call assign_file
  mov ah, 3fh
  mov bx, filehandle
  mov cx, 256*14
  mov dx, offset char
  int 21h
end;

procedure build_full_screen; assembler;
asm
      call hide_mouse
      push 0
      call del_char;
      push 100
      call del_char;
      push 200
      call del_char;
      push 0
      push 5
      mov al, nbr
      xor ah, ah
      dec ax
      push ax
      call draw_char;
      push 1
      push 5
      mov al, nbr
      xor ah, ah
      push ax
      call draw_char
      push 2;
      push 5
      mov al, nbr
      xor ah, ah
      inc ax
      push ax
      call draw_char
      call show_mouse
end;

procedure mouse_pressed; Assembler;
var
  x1, y1 : byte;
  on : boolean;
asm
    mov on, 0
    cmp cx, 201
    jb @raus
    cmp cx, 374
    ja @raus
    cmp dx, 26
    jb @raus
    cmp dx, 177
    ja @raus
    jmp @go
  @raus:
    add sp, 6
    ret
  @go:
    sub cx, 200
    mov ax, cx
    mov bl, 22
    div bl
    mov x1, al

    sub dx, 25
    mov ax, dx
    mov bl, 11
    div bl
    mov y1, al

      call hide_mouse
      mov si, offset char
      mov al, 14
      mul nbr
      add si, ax
      mov al, y1
      xor ah, ah
      add si, ax
      mov di, si
      push ds
      pop es
      lodsb				{ AL=Wert }
      mov ah, 128
      mov cl, x1
      shr ah, cl
      push ax
      and al, ah
      cmp al, 0
      je @lb05
      mov on, 1
    @lb05:

      pop ax
      mov bh, ah
      xor ah, 255
      and al, ah
      cmp on, 0
      jne @set_bit
      add al, bh
    @set_bit:
      stosb
      { Pixel abbilden }
      mov di, 25*320+100

      mov ax, 320*11
      mov bl, y1
      xor bh, bh
      mul bx
      add di, ax

      mov ax, 320
      add di, ax
      mov al, 11
      mul x1
      inc ax
      add di, ax
      push di
      cmp on, 0
      je @lb02
      push 0
      jmp @lb01
    @lb02:
      push colour1
    @lb01:
      call putbigpixel
      jmp @ende
    @ende:
      call show_mouse
end;

begin;
  filename := 'standard.sff'+chr(0);
  s := 'Character Editor Version 1.0$';
  asm
    mov colour1, 5
    mov ax, 13h
    int 10h
    xor ax, ax
    int 33h
    cmp ax, 0ffffh
    je @go_on
    mov ah, 4ch
    int 21h
  @go_on:
    mov nbr, 65
    call draw_title
    push 0
    push 1
    call draw_lines
    push 100
    push 14
    call draw_lines
    push 200
    push 1
    call draw_lines
    call readchar
    call show_mouse;
    call build_full_screen;

  @loop:
    mov ah, 1
    int 16h
    jz @check_mouse
    xor ah, ah
    int 16h
    cmp ah, 77
    jne @lb01
    inc nbr
    call build_full_screen
    jmp @end
  @lb01:
    cmp ah, 75
    jne @lb02
    dec nbr
    call build_full_screen
    jmp @end
  @lb02:
    cmp al, 's'
    jne @lb03
    call save
    jmp @end
  @lb03:
    cmp al, 'l'
    jne @lb04
    call load
    call build_full_screen
    jmp @end
  @lb04:
  @lb05:
    cmp al, 27
    jne @end
    mov done, 1
    jmp @end
  @check_mouse:
    mov ax, 3
    int 33h
    cmp bx, 0
    je @loop
    call mouse_pressed
  @wait_for_release:
    mov ax, 6
    xor bx, bx
    int 33h
    and ax, 1
    cmp ax, 0
    jne @wait_for_release
  @end:
    call clear_buffer
    cmp done, 1
    jne @loop
    mov ax, 3h
    int 10h
  end;
end.
