.model tiny
.code
.startup

jmp @begin

filehandle dw 0h
s          db 'Shell System Character Editor 1.0$';
filename   db 'standard.sff',0;
char       db 256*16 dup (90h)

nbr        db 65
done       db 0h
colour1    db 0h

draw_char proc                          ; bp=xstart; gs=col; fs=Nummer
  ; kleinen Buchstaben ausgeben
    mov cx, bp
    xor dl, dl
  @loop:
    cmp cx, 0
    je @lb02
    add dl, 13
    loop @loop
  @lb02:
    mov ah, 2
    xor bh, bh
    mov dh, 2
    int 10h
    xor bh, bh
    mov bl, 70h
    .386c
    mov ax, fs
    .286c
    mov ah, 09h
    mov cx, 1
    int 10h
  ; groen Buchstaben ausgeben }
    push 0a000h
    pop es

    mov si, offset char
    mov ax, 100
    mul bp
    mov di, ax
    mov ax, 16
    add di, 26*320+1
    .386c
    mov dx, fs
    .286c
    mul dx
    add si, ax
    mov cx, 15
  @XLoop4:
    lodsb
    mov ah, 128
    push di
  @BitLoop:
    test al, ah
    jz @bit_not_set
    pusha
    mov bp, di
    .386c
    mov si, gs
    .286c
    pusha
    call putbigpixel
    popa
    popa
  @bit_not_set:
    add di, 11
    shr ah, 1
    cmp ah, 0
    jne @BitLoop
    pop di
    add di, 320*11
    loop @XLoop4
    ret
endp

readchar proc
    push ds
    mov ax, 1130h
    mov bh, 6

    int 10h
    push es
    pop ds
    mov si, bp

    push cs
    pop es
    mov di, offset char
    mov cx, 16*256
    cld
    rep movsb
    pop ds
    ret
endp

draw_lines proc                         ; BP=XStart, SI=Colour
    push 0a000h
    pop es
  ; Horizontale Linien zeichnen 
    xor cl, cl				; cl:= 'Y' 
  @YLoop:
    xor ch, ch				; ch:='X' 
    mov al, 11
    mul cl				; Y*11 -> AX 
    add ax, 25				; Vertikale Zentrierung 
    mov bx, 320				
    mul bx				; Mit 320 multiplizieren 
    mov di, ax
    add di, bp
  @XLoop:
    mov ax, si
    stosb
    inc ch
    cmp ch, 89
    jb @XLoop
    inc cl
    cmp cl, 15
    jb @YLoop
  ; Vertikale Linien zeichnen 
    xor ch, ch				; CH:='X' 
  @XLoop2:
    xor cl, cl				; CL:='Y' 
    mov al, 11
    mul ch
    mov di, ax
    add di, bp
    add di, 25*320			; vertikale Zentrierung 
  @YLoop2:
    mov ax, si
    stosb
    add di, 319
    inc cl
    cmp cl, 155
    jb @YLoop2
    inc ch
    cmp ch, 9
    jb @XLoop2
    ret
endp

putbigpixel proc                        ; BP=Start, SI=Colour
    push 0a000h
    pop es
    mov di, bp
    mov ax, si
    mov dl, 10
  @YLoop3:
    mov cx, 10
    push di
  @Xloop3:
    stosb
    loop @XLoop3
    pop di
    add di, 320
    dec dl
    cmp dl, 0
    jne @YLoop3
    ret
endp

draw_title proc
    mov ah, 9
    mov dx, offset s
    int 21h
    ret
endp

del_char proc                           ; BP:=xstart
    mov di, 25*320+320+1
    add di, bp
    mov bl, 14
  @YLoop5:
    mov cx, 8
    push di
  @XLoop5:
    pusha
    mov bp, di
    xor si, si
    call putbigpixel
    popa
    add di, 11
    loop @xloop5
    pop di
    add di, 320*11
    dec bl
    cmp bl, 0
    jne @YLoop5
    ret
endp

show_mouse proc
  mov ax, 1
  int 33h
  ret
endp

hide_mouse proc
  mov ax, 2
  int 33h
  ret
endp

clear_buffer proc
  push 40h
  pop es
  mov ax, es:[01ah]
  mov es:[1ch], ax
  ret
endp

assign_file proc
  mov ax, 3d02h
  mov dx, offset filename
  int 21h
  mov cs:filehandle, ax
  ret
endp

save proc
  push cs
  pop ds
  mov ah, 3ch
  xor cx, cx
  mov dx, offset filename
  int 21h
  mov cs:filehandle, ax
  mov bx, ax
  mov ah, 40h
  mov cx, 256*16
  mov dx, offset char
  int 21h
  mov bx, cs:filehandle
  mov ah, 3eh
  int 21h
  ret
endp

load proc
  call assign_file
  mov ah, 3fh
  mov bx, cs:filehandle
  mov cx, 256*16
  mov dx, offset char
  int 21h
  ret
endp

build_full_screen proc
      call hide_mouse
      xor bp, bp
      call del_char
      mov bp, 100
      call del_char
      mov bp, 200
      call del_char
      xor bp, bp
      dec cs:nbr
      mov al, cs:colour1
      xor ah, ah
      .386c
      mov gs, ax
      .286c
      mov al, cs:nbr
      xor ah, ah
      .386c
      mov fs, ax
      .286c
      call draw_char
      inc cs:nbr
      mov bp, 1
      push 5
      mov al, cs:nbr
      xor ah, ah
      .386c
      pop gs
      mov fs, ax
      .286c
      call draw_char
      inc cs:nbr
      mov bp, 2
      mov al, cs:nbr
      xor ah, ah
      push 5
      .386c
      pop gs
      mov fs, ax
      .286c
      call draw_char
      dec cs:nbr
      call show_mouse
      ret
endp

mouse_pressed proc
    jmp @go
    x1 db 0h
    y1 db 0h
    on db 0h
  @go:
    mov cs:on, 0
    cmp cx, 201
    jb @raus
    cmp cx, 374
    ja @raus
    cmp dx, 26
    jb @raus
    cmp dx, 177
    ja @raus
    jmp @go1
  @raus:
    ret
  @go1:
    sub cx, 200
    mov ax, cx
    mov bl, 22
    div bl
    mov cs:x1, al

    sub dx, 25
    mov ax, dx
    mov bl, 11
    div bl
    mov cs:y1, al

    call hide_mouse
    mov si, offset char
    mov al, 16
    mul cs:nbr
    add si, ax
    mov al, cs:y1
    xor ah, ah
    add si, ax
    mov di, si
    push ds
    pop es
    lodsb                             ; AL=Wert 
    mov ah, 128
    mov cl, x1
    shr ah, cl
    push ax
    and al, ah
    cmp al, 0
    je @lb05
    mov cs:on, 1

  @lb05:

    pop ax
    mov bh, ah
    xor ah, 255
    and al, ah
    cmp cs:on, 0
    jne @set_bit
    add al, bh
  @set_bit:
    stosb
    ; Pixel abbilden 
    mov di, 25*320+100

    mov ax, 320*11
    mov bl, y1
    xor bh, bh
    mul bx
    add di, ax

    mov ax, 320
    add di, ax
    mov al, 11
    mul cs:x1
    inc ax
    add di, ax
    mov si, di
    cmp cs:on, 0
    je @lb03
    xor si, si
    jmp @lb01
  @lb03:
    mov al, cs:colour1
    xor ah, ah
    mov si, ax
  @lb01:
    mov bp, di
    call putbigpixel
    jmp @ende
  @ende:
    call show_mouse
    ret
endp

@begin:
  push cs
  pop ds
    mov cs:colour1, 5
    mov ax, 13h
    int 10h
    xor ax, ax
    int 33h
    cmp ax, 0ffffh
    je @go_on
    mov ah, 4ch
    int 21h
  @go_on:
    mov cs:nbr, 65
    call draw_title
    xor bp, bp
    mov si, 1
    call draw_lines
    mov bp, 100
    mov si, 14
    call draw_lines
    mov bp, 200
    mov si, 1
    call draw_lines
    call readchar
    call show_mouse
    call build_full_screen
  @loop3:
    mov ah, 1
    int 16h
    jz @check_mouse
    xor ah, ah
    int 16h
    cmp ah, 77
    jne @lb04
    inc cs:nbr
    call build_full_screen
    jmp @end
  @lb04:
    cmp ah, 75
    jne @lb08
    dec cs:nbr
    call build_full_screen
    jmp @end
  @lb08:
    cmp al, 's'
    jne @lb06
    call save
    jmp @end
  @lb06:
    cmp al, 'l'
    jne @lb07
    call load
    call build_full_screen
    jmp @end
  @lb07:
    cmp al, 27
    jne @end
    mov cs:done, 1
    jmp @end
  @check_mouse:
    mov ax, 3
    int 33h
    cmp bx, 0
    je @loop3
    call mouse_pressed
  @wait_for_release:
    mov ax, 6
    xor bx, bx
    int 33h
    and ax, 1
    cmp ax, 0
    jne @wait_for_release
  @end:
    call clear_buffer
    cmp cs:done, 1
    jne @loop3
    mov ax, 3h
    int 10h
    mov ah, 4ch
    int 21h
end
