; 
;  program scanDir  reads directory entries directly from disk without dos
;
;  aim: faster operation than dos and win95-long-filename support
;  author: vic boone  iCode 1996
; 
;  zunchst nur Festplattenansteuerung / spter auch Disketten

code    segment para use16
        assume  cs:code, ds:code
        org     100h
        .386
entry:  jmp     begin

shellID         db      'iCode@SHELL-SYSTEM'
appHeader       db      33
appName         db      17, 'iCode-Diskmanager'
appVer          db      0, 9
appAuthor       db      9,'vic boone'
appDate         db      13,10,96

errMsg1         db      ' Das Festplattenlaufwerk 1 lt sich nicht ansprechen.',13,10,36
errMsg2         db      ' Von Festplattenlaufwerk 1 konnte nicht gelesen werden.',13,10,36
errMsg3         db      ' Die Partitionstabelle von Laufwerk 1 hat ein illegales Format.',13,10,36

str1            db      34, 'Partitionstabelle von Festplatte 1'
str2            db      65, 'Boot  Partitionstyp  Kopf, Zyl, Sekt - Kopf, Zyl, Sekt   Gre'
str3            db      66, '                                     -                         '
str4            db      26, 'Bootsektor von Partition 1'
str5            db      15, 'Herstellername:'
str6            db      17, 'Bytes pro Sektor:'
str7            db      21, 'Sektoren pro Cluster:'
str8            db      20, 'Anzahl der Sektoren:'
str9            db      21, 'Reservierte Sektoren:'
str10           db      16, 'Anzahl der FATs:'
str11           db      17, 'Sektoren pro FAT:'
str12           db      21, 'Eintrge in der root:'
str13           db      17, 'Media-Deskriptor:'
str14           db      18, 'Sektoren pro Spur:'
str15           db      18, 'Lese/Schreibkpfe:'

buttonStr1      db      2, '~',09h,'Ok'
buttonStr2      db      3, '~',09h,'FAT'
buttonStr3      db      4, '~',09h,'root'

typStr1         db                 'nicht belegt    ' ; no = 0
                db                 '12b-Fat/Prim.   '
                db                 'XENIX           '
                db                 'XENIX           '
                db                 '16b-Fat/Prim.   '
                db                 'extended-DOS    '
                db                 'DOS 4.0 >32MB   '
entrydb         db                 'ConcurrentDOS   ' ; no = 0dbh
unKnownStr      db                 'nicht bekannt   '
tempStr         db      '           '

actDrive        db      80h     ; bzw. 81 - 87h fr weitere Platten
actpos          db      0
actbutton       db      0
partBuf         db      512 dup ('*')
bootBuf         db      2048 dup ('*')

initDrive       proc
        mov     ah, 0
        mov     dh, actDrive
        int     13h
        jnc     @initDriveOk
        mov     ah, 0
        mov     dh, actDrive
        int     13h
        jnc     @initDriveOk
        mov     ah, 0
        mov     dh, actDrive
        int     13h
        jc      @initDriveErr
      @initDriveOk:
        ret
      @initDriveErr:
        mov     ah, 9
        mov     dx, offset errMsg1
        mov     di, dx
        mov     al, actDrive
        sub     al, 79
        mov     byte ptr ds:[di+26], al
        int     21h
        stc
        ret
initDrive       endp

readBootSector  proc
        mov     ch, 0
        mov     cl, 1
        mov     dh, 0
        mov     dl, actDrive
        push    cs
        pop     es
        mov     bx, offset partBuf
        mov     ax, 0201h  ; 1 Sektor / fkts. nr in ah = 2
        int     13h
        jnc     @readBootSectorOK
        mov     ax, 0201h
        int     13h
        jnc     @readBootSectorOK
        mov     ax, 0201h
        int     13h
        jnc     @readBootSectorOK
        mov     ah, 9
        mov     dx, offset errMsg2
        mov     di, dx
        mov     al, actDrive
        sub     al, 79
        mov     byte ptr ds:[di+26], al
        int     21h
        stc
        ret
      @readBootSectorOK:

        ; nachdem der partitionssektor gelesen wurde, machen wir uns jetzt an
        ; die boot-Sektoren der einzelnen Partitionen

        mov     si, offset partBuf
        cmp     word ptr ds:[si+1feh], 0aa55h
        je      @correctPart
        mov     ah, 9
        mov     dx, offset errMsg3
        mov     di, dx
        mov     al, actDrive
        sub     al, 79
        mov     byte ptr ds:[di+37], al
        int     21h
        stc
        ret
      @correctPart:
        add     si, 01beh

      ; entry1
        cmp     byte ptr ds:[si+4],0
        je      @ne1
        push    cs
        pop     es
        mov     bx, offset bootBuf
        mov     dh, ds:[si+1]   ; Werte aus der Partitionstablle
        mov     cx, ds:[si+2]
        mov     dl, actDrive
        mov     ax, 0201h       ; fkts.nr = 2 & secAnzahl = 1
        int     13h
      ; entry2
       @ne1:
        add     si, 16
        cmp     byte ptr ds:[si+4],0
        je      @ne2
        push    cs
        pop     es
        mov     bx, offset bootBuf
        add     bx, 512
        mov     dh, ds:[si+1]   ; Werte aus der Partitionstablle
        mov     cx, ds:[si+2]
        mov     dl, actDrive
        mov     ax, 0201h       ; fkts.nr = 2 & secAnzahl = 1
        int     13h
      ; entry3
       @ne2:
        add     si, 16
        cmp     byte ptr ds:[si+4],0
        je      @ne3
        push    cs
        pop     es
        mov     bx, offset bootBuf
        add     bx, 1024
        mov     dh, ds:[si+1]   ; Werte aus der Partitionstablle
        mov     cx, ds:[si+2]
        mov     dl, actDrive
        mov     ax, 0201h       ; fkts.nr = 2 & secAnzahl = 1
        int     13h
      ; entry4
       @ne3:
        add     si, 16
        cmp     byte ptr ds:[si+4],0
        je      @ne4
        push    cs
        pop     es
        mov     bx, offset bootBuf
        add     bx, 1536
        mov     dh, ds:[si+1]   ; Werte aus der Partitionstablle
        mov     cx, ds:[si+2]
        mov     dl, actDrive
        mov     ax, 0201h       ; fkts.nr = 2 & secAnzahl = 1
        int     13h
       @ne4:

        ret
readBootSector  endp

; in:  ah = 0-3:no  /  al = 1:on/0:off
showBootEntry   proc

        push    ax
        push    cs
        pop     es
        mov     di, offset str3
        inc     di
        shr     ax, 4
        mov     si, offset partBuf
        add     si, 1beh
        add     si, ax        ; auf Partitionseintrag gehen
      ; Auswertung / 1 status
        cmp     byte ptr ds:[si], 80h
        je      @bootJa
        mov     dword ptr es:[di], 'nien'
        jmp     @next1
       @bootJa:
        mov     dword ptr es:[di], ' aj '
       @next1:
        add     di, 7
        mov     al, byte ptr ds:[si+4]
        xor     ah, ah
        cmp     al, 6
        ja      @bootUnknown
        push    si
        mov     si, offset typStr1
        shl     ax, 4
        add     si, ax
        mov     cx, 13
        rep     movsb
        pop     si
        jmp     @next2
       @bootUnknown:
        cmp     al, 0dbh
        jne     @realU
        push    si
        mov     si, offset entrydb
        mov     cx, 13
        rep     movsb
        pop     si
        jmp     @next2
       @realU:
        push    si
        mov     si, offset unknownStr
        mov     cx, 13
        rep     movsb
        pop     si
       @next2:
        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+1]  ; start-head
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+3]  ; start-zyl
        mov     dh, byte ptr ds:[si+2]
        shr     dh, 6
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+2]  ; start-sec
        and     dl, 1+2+4+8+16+32   ; die obersten beiden bits lschen
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si
       @next3:

        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+5]  ; end-head
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+7]  ; end-zyl
        mov     dh, byte ptr ds:[si+6]
        shr     dh, 6
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

        add     di, 2
        xor     edx, edx
        mov     dl, byte ptr ds:[si+6]  ; end-sec
        and     dl, 1+2+4+8+16+32       ; die obersten beiden bits lschen
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

       @next4:
        add     di, 3
        mov     edx, dword ptr ds:[si+0ch] ; secNum = 512 byte
        shr     edx, 11         ; *9 / 1024*1024 = MB
        mov     bl, 0
        push    di
        mov     di, offset tempStr
        mov     ah, 12
        int     32h
        pop     di
        push    si
        mov     si, offset tempStr
        add     si, 6
        mov     cx, 4
        rep     movsb
        pop     si

        inc     di
        mov     word ptr es:[di], 'bM'
       @konvertDone:
        pop     ax

        mov     bx, 001bh     ; stdAttr
        cmp     al, 1
        jne     @showBootEntryPaint
        mov     bx, 00f1h     ; high-lighted
      @showBootEntryPaint:
        mov     dx, 0708h
        add     dl, ah
        mov     si, offset str3
        mov     ah, 6
        int     32h

        ret
showBootEntry   endp

showBootSectorDatas     proc
        push    cs
        pop     ds
        mov     cx, 050dh
        mov     dx, 054bh
        mov     si, offset str1
        mov     al, actDrive
        sub     al, 79
        mov     ds:[si+34], al
        mov     bx, 071fh       ; style = 7 / attr = 1fh
        mov     ah, 1
        int     32h

        mov     bx, 001bh     ; stdAttr
        mov     dx, 0706h
        push    cs
        pop     ds
        mov     si, offset str2
        mov     ah, 6
        int     32h

        mov     ax, 0001h
        call    showBootEntry
        mov     ax, 0100h
        call    showBootEntry
        mov     ax, 0200h
        call    showBootEntry
        mov     ax, 0300h
        call    showBootEntry

        call    showBootKeyLoop

        mov     ah, 2           ; done + restore
        int     32h

        ret
showBootSectorDatas     endp

showBootKeyLoop proc
      @kLp:
        mov     ah, 1   ; if keypressed then...
        int     16h
        jnz     @kLp
        mov     ah, 0   ; ... readkey
        int     16h

        cmp     al, 27
        jne     @nk1
        jmp     @doneKeyLoop
      @nk1:
        cmp     al, 13
        jne     @nk2
        call    showBootInfo
        jmp     @kLp
      @nk2:
      ; 72 oben und 80 unten
        cmp     al, 0
        je      @ek
        cmp     al, 224
        je      @ek
        jmp     @kLp
      @ek:
        cmp     ah, 72
        jne     @ek1
        push    cs
        pop     ds
        cmp     actPos, 0
        jne     @okd1
        jmp     @kLp
       @okd1:
        mov     ah, actpos
        mov     al, 0
        call    showBootEntry
        dec     actPos
        mov     ah, actpos
        mov     al, 1
        call    showBootEntry
        jmp     @kLp
      @ek1:
        cmp     ah, 80
        jne     @ek2
        push    cs
        pop     ds
        cmp     actPos, 3
        jb      @okd2
        jmp     @kLp
       @okd2:
        mov     ah, actpos
        mov     al, 0
        call    showBootEntry
        inc     actPos
        mov     ah, actPos
        mov     al, 1
        call    showBootEntry
        jmp     @kLp
      @ek2:
        jmp     @kLP
      @doneKeyLoop:
        ret
showBootKeyLoop endp

showBootInfoLoop        proc
      @skLp:
        mov     ah, 1   ; if keypressed then...
        int     16h
        jnz     @skLp
        mov     ah, 0   ; ... readkey
        int     16h

        cmp     al, 27
        jne     @snk1
        push    cs
        pop     ds
        mov     ah, actButton
        mov     al, 0
        call    showBootInfoEntry
        mov     ax, 0002
        call    showBootInfoEntry
        jmp     @sdoneKeyLoop
      @snk1:
        cmp     al, 9
        jne     @snk2
        push    cs
        pop     ds
        mov     ah, actButton     ; disable
        mov     al, 0
        call    showBootInfoEntry
        cmp     actButton, 2      ; look for next-one
        je      @sdx1
        inc     actButton
       @sdx2:
        mov     ah, actButton
        mov     al, 1
        call    showBootInfoEntry
        jmp     @skLp
       @sdx1:
        mov     actButton, 0
        jmp     @sdx2
      @snk2:
        cmp     al, 13
        jne     @snk3
        mov     ah, actButton
        mov     al, 2
        call    showBootInfoEntry
        jmp     @sDoneKeyLoop
      @snk3:
      ; 72 oben und 80 unten
        cmp     al, 0
        je      @sek
        cmp     al, 224
        je      @sek
        jmp     @skLp
      @sek:
        jmp     @skLP
      @sDoneKeyLoop:

        ret
showBootInfoLoop        endp

bootOfs dw      0

showBootInfoEntry proc
        mov     cl, 10h
        mov     bx, 04f0h
        cmp     al, 0
        je      @sbnd
        cmp     al, 1
        jne     @sbnt
        mov     bx, 04e0h
        jmp     @sbnd
       @sbnt:
        mov     bx, 06e0h

      @sbnd:
        cmp     ah, 0
        jne     @sbi1
        mov     dx, 1a24h
        mov     si, offset buttonStr1
        jmp     @sbd
      @sbi1:
        cmp     ah, 2
        je      @sbi2
        mov     dx, 2630h
        mov     si, offset buttonStr2
        jmp     @sbd
      @sbi2:
        mov     dx, 323ch
        mov     si, offset buttonStr3
      @sbd:
        mov     ah, 5
        int     32h

        ret
showBootInfoEntry endp

cov proc
        xor     bl, bl
        push    cs
        pop     es
        mov     di, offset tempStr
        mov     byte ptr es:[di], 10
        inc     di
        mov     ah, 12
        int     32h
        ret
cov endp

cop proc
        mov     bx, 001fh     ; attr
        mov     ah, 6
        mov     si, offset tempStr
        int     32h
        ret
cop endp

showBootInfo    proc
        push    cs
        pop     ds
        mov     cx, 0213h
        mov     dx, 183fh
        mov     si, offset str4
        mov     al, actPos
        add     al, 49
        mov     ds:[si+26], al
        mov     bx, 071fh       ; style = 7 / attr = 1fh
        mov     ah, 1
        int     32h

        mov     dl, 4
        mov     si, offset str5

      @cOutLoop:
        mov     bx, 001bh     ; stdAttr
        mov     dh, 1ah
        mov     ah, 6
        push    si
        push    dx
        int     32h
        pop     dx
        pop     si
        mov     al, ds:[si]
        xor     ah, ah
        add     si, ax
        inc     si

        inc     dl
        cmp     dl, 15
        jb      @cOutLoop

     ; 1 Herstellername und Version   /   -stringfeld
        push    cs            ; ofs-Bestimmung
        pop     es
        mov     si, offset bootBuf
        xor     ax, ax
        mov     al, actpos
        shl     ax, 9
        add     si, ax
        mov     bootOfs, si
        mov     di, offset tempStr   ; strCopy
        mov     byte ptr es:[di],8
        inc     di
        add     si, 3
        mov     cx, 2
        rep     movsd

        mov     bx, 001fh     ; attr
        mov     dx, 3504h
        mov     ah, 6
        mov     si, offset tempStr
        int     32h

     ; 2 Bytes pro Sektor
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+0bh]
        call    cov
        mov     dx, 3305h
        call    cop

     ; 3 Sektoren pro Cluster
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dl, ds:[si+0dh]
        call    cov
        mov     dx, 3306h
        call    cop

     ; 5 Gesamtanzahl der Sektoren ?!
        mov     si, offset partBuf
        add     si, 1beh
        mov     al, actpos
        xor     ah, ah
        shl     ax, 4
        add     si, ax
        mov     edx, ds:[si+0ch]
        call    cov
        mov     dx, 3307h
        call    cop

     ; 5 Anzahl reservierter Sektoren
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+0eh]
        call    cov
        mov     dx, 3308h
        call    cop

     ; 6 Anzahl der Fats
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+10h]
        call    cov
        mov     dx, 3309h
        call    cop

     ; 7 Sektoren pro Fat
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+16h]
        call    cov
        mov     dx, 330ah
        call    cop

     ; 8 Eintrge in der root
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+11h]
        call    cov
        mov     dx, 330bh
        call    cop

     ; 9 Mediadeskriptor
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dl, ds:[si+15h]
        call    cov
        mov     dx, 330ch     ; -> besser hex-Ausgabe
        call    cop

     ; 10 Sektoren pro Spur
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+18h]
        call    cov
        mov     dx, 330dh
        call    cop

     ; 11 Schreib/Lesekpfe
        mov     si, bootOfs   ; val
        xor     edx, edx
        mov     dx, ds:[si+1ah]
        call    cov
        mov     dx, 330eh
        call    cop

     ; ok - Button ausgeben...

        push    cs
        pop     ds
        mov     ah, 0

       @loopD:
        push    ax
        cmp     actButton, ah
        je      @drAct
        mov     al, 0
        call    showBootInfoEntry
        jmp     @nextD
       @drAct:
        mov     al, 1
        call    showBootInfoEntry
       @nextD:
        pop     ax
        inc     ah
        cmp     ah, 3
        jb      @loopD

      ; -  keyLoop  -
        call    showBootInfoLoop

        mov     ah, 2           ; done + restore
        int     32h
        ret
showBootInfo    endp

begin:
        mov     bx, offset lastByte
        add     bx, 1024        ; stack 1024 byte
        shr     bx, 4
        push    cs
        pop     es
        mov     ah, 4ah
        int     21h
        mov     ax, 0d00h       ; Blinken aus
        int     32h
        mov     ah, 8           ; cursor aus
        int     32h

        call    initDrive
        call    readBootSector
        call    showBootSectorDatas

        mov     ah, 9           ; cursor an
        int     32h
        mov     ax, 4c00h
        int     21h

lastByte equ this byte

code    ends
        end     entry
