
;ͻ
;                                                                             
;            FILEINFO.INC   Genialstes File-Tool aller Zeiten           
;                                                                             
;                          benoetigt Shell-System-API                         
;                                                                             
;                          Code : 1996 iCode [Falcon]                         
;                                                                             
;ͼ




; Dieses Programm muss, um mit einem einzigen Code-Segment auszukommen, nach-
; laden koennen. Die Nachzuladenden Dateien besitzen die Endungen '.APP' und
; werden bei Offset 100h in den Speicher geladen. Der davor liegende Speicher
; wird NICHT als PSP behandelt, er dient lediglich fuer die Anpassung der
; direkten Adressierung. Um etwas Code und Zeit zu sparen, bleibt die zu
; untersuchende Datei geoeffnet, und das Handle wird in einem Word uebergeben,
; welches bei CS:0094h liegt. Auch die Dateigroesse wird von dem Hauptpro-
; gramm uebergeben, sie liegt bei CS:94h.



        .386c




        code segment byte use16
        assume cs:code, ds:code, use16
        org 100h
        entry: jmp realStart



include loadproc.inc
include support.inc

infos         db  0                     ; Weitere Infos Flag


FName         db 08,'test.exe'
ApiCheck      db 12,'shell system'

headline      db 21,'Shell System Fileinfo'

CommonString1 db 06,' Bytes'
CommonString6 db 12,'  Checksumme'

fileName      db 256 dup (0)
FileNameZ     db 256 dup (0)            ; hlt Filenamen in ASCIIZ-Format
ovlHandle     dw 0                      ; Handle fuer Overlay-Datei


exename       db 7,'exe.app'




scanExecutable proc

  ; Ein Overlay laden.

        mov si, offset OverlayEXE
        call ovlLoad

        ret
scanExecutable endp




drawFilename proc
        mov di, offset writeBuffer
        movzx ax, byte ptr offset writeBuffer
        inc ax
        add di, ax
        mov si, offset fileName
        movzx cx, byte ptr [si]
        add byte ptr offset writeBuffer, cl
        inc si
        rep movsb
        ret
drawFilename endp

drawFileLength proc
        mov di, offset writeBuffer
        movzx ax, byte ptr offset writeBuffer
        inc ax
        add di, ax
        mov eax, dword ptr fileSize
        call addNumber
        ret
drawFileLength endp



checkFiletype proc

  ; Ist die Datei eine EXE-Datei ? Moegliche Varianten sind 'MZ', 'ZM', 'MP',
  ; 'P2' und 'P3'.

        xor eax, eax
        call seek
        mov cx, 2
        mov bx, 1
        call readData
        pushf
        xor cl, cl
        popf
        jc Header
        mov cl, 1
        mov ax, word ptr filebuffer
        cmp ax, 'ZM'
        je exeHeader                    ; 'MZ' -> EXE-File
        mov bl, 2
        cmp ax, 'MZ'
        je exeHeader                    ; 'ZM' -> EXE-File
        mov bl, 3
        xor cl, cl
        cmp ax, 'PM'
        je exeHeader                    ; 'MP' -> old Phar Lap executable
        mov bl, 4
        cmp ax, '2P'
        je exeHeader                    ; 'P2' -> new Phar Lap 286 exe
        mov bl, 5
        cmp ax, '3P'                    
        je exeHeader                    ; 'P3' -> new Phar Lap 386 exe

        xor bl, bl
        jmp header

      exeHeader:
        cmp filesize, 20h
        jae header
        xor bx, bx
        xor cl, cl

      Header:
        mov infos, cl
        mov fileType, bx

  ; Falls die Datei unbekannt ist oder so, wird der Link 'Weitere Infos' de-
  ; aktiviert, d.h. als Offset wird 0 eingetragen

        cmp infos, 1
        je linkOk
        mov si, offset tabMain
        mov cx, 4
        call killLink
      linkOk:
        ret
checkFiletype endp

drawFiletype proc
        mov si, offset unbekannt

  ; MZ-EXE ?
        cmp fileType, 1
        jne $+5
        mov si, offset ExecutableString1

  ; ZM-EXE ?
        cmp fileType, 2
        jne $+5
        mov si, offset ExecutableString2    ; SI @'ZM-Executable'

  ; MP-EXE ?
        cmp fileType, 3
        jne $+5
        mov si, offset ExecutableString3    ; SI @'old phar lap executable'

  ; P2-EXE ?
        cmp fileType, 4
        jne $+5
        mov si, offset ExecutableString4    ; SI @'new phar lap 286er'

  ; P3-EXE ?
        cmp fileType, 5
        jne $+5
        mov si, offset ExecutableString5    ; SI @'new phar lap 3286er'

        mov di, offset writeBuffer
        movzx cx, byte ptr [di]
        inc cl
        add di, cx
        mov cl, byte ptr [si]
        inc si
        rep movsb

        ret
drawFiletype endp

ovlLoad proc
        call loadProc
        or ax, ax
        jnz @ovlError
        mov cs:ovlHandle, ds
        mov eax, dword ptr cs:filesize
        mov ds:dword ptr [90h], eax
        mov ax, cs:word ptr filehandle
        mov ds:word ptr [94h], ax


        push cs
        push offset odone

        push ds
        push 100h
        retf

      oDone:
        push cs
        pop  ds
int 3
        mov es, ovlHandle
        call freeProc
        push cs
        pop  ds
        push cs
        pop  es
        ret
ovlLoad endp



classifyString1    db 08, 'Dateityp'

ExecutableString1  db 13, 'MZ-executable'
ExecutableString2  db 13, 'ZM-executable'
ExecutableString3  db 23, 'old Phar Lap executable'
ExecutableString4  db 25, 'Phar Lap 286er executable'
ExecutableString5  db 25, 'Phar Lap 386er executable'









; Jetzt kommt der Entry-Point von 'FILEINFO.COM'


realStart:

; erstmal Speicher freigeben, sonst gibt's spaeter Probleme

        mov sp, offset EndOfCode + 1010
        mov bx, offset EndOfCode + 1100
        shr bx, 4
        mov ah, 4ah
        int 21h

; checken, ob die SHELL im Hintergrund aktiv ist (API-Check)

        xor ah, ah
        int 32h
        mov di, offset ApiCheck
        mov cx, 13
        repe cmpsb
        jcxz apiOK
        mov ax, 4c01h
        int 21h
      apiOK:
        push cs
        pop ds

  ; API ist installiert. Jetzt den Dateinamen in einem String sichern. Spaeter
  ; befindet er sich ja ausserhalb dieses Segments.

        mov di, offset fileName
        mov si, offset fName
        movzx cx, byte ptr [si]
        inc cx
        rep movsb

  ; Jetzt den Dateinamen in ASCIIZ (fuer DOS) konvertieren.

        mov si, offset fileName
        mov di, offset FileNameZ
        movzx cx, byte ptr [si]
        inc si
        rep movsb
        mov byte ptr es:[di], 0

  ; Jetzt mittels Find-First die Dateigroesse des zu untersuchenden Files heraus-
  ; finden und in 'FILESIZE' sichern

        mov dx, offset FileNameZ
        mov cx, 0ffh
        mov ah, 4eh
        int 21h
        jc @FileSizeError
        mov eax, ds:dword ptr 09ah
        mov filesize, eax

  ; Die zu untersuchende Datei oeffnen, und das Handle in 'FILEHANDLE' sichern.

        mov ax, 3d00h
        mov dx, offset FileNameZ
        int 21h
        jc @FileOpenError
        mov FileHandle, ax

  ; Das Blinken fuer Hintergrund-Farben ausschalten


        mov ax, 0d00h
        int 32h

  ; Cursor ausschalten

        mov ah, 8
        int 32h

  ; Den Bildschirm aufbauen. Fenster und Buttons zeichnen.
        mov maxy, 5

        mov ah, 1
        mov bl, colour1
        mov bh, 7
        mov cx, 0811h
        mov dx, 014eh
        mov si, offset headline
        int 32h

  ; Jetzt Informationen ueber den Filetyp einholen.

        call checkFiletype

  ; Jetzt die Tastaturverwaltung aufrufen. Diese liegt in der Datei
  ; 'SUPPORT.INC'. Sie erwartet diverse Parameteruebergaben.

        mov si, offset tabMain
        call menu





  @AllDone:                             ; Verlassen dieses Progs !!!!!
        mov ah, 3eh                     ; ah=3eh -> Datei schlieen
        mov bx, FileHandle              ; BX=Handle
        int 21h                         ; DOS-Api Aufruf
        jc @FileCloseError

      @Exit:

  ; Fenster loeschen

        mov ah, 2
        int 32h

  ; Cursor einschalten

        mov ah, 9
        xor cx, cx
        int 32h

  ; Programm verlassen

        mov ah, 4ch
        int 21h




overlayEXE db 07,'exe.app'


tabMain:
           dw  5                        ; Anzahl Items
           dw  0                        ; startPos
           dw  0                        ; scrollPos
           db 09,'Dateiname'
           dw offset drawFilename
           dw 0

           db 11,'Dateilaenge'
           dw offset drawFilelength
           dw 0

           db 08,'Dateityp'
           dw offset drawFiletype
           dw 0

           db 0
           dw offset doNothing
           dw 0

           db 23,' Weitere Informationen'
           dw offset doNothing
           dw offset scanExecutable



 

      EndOfCode:

code ends
end entry


