.386c

  TextStringSeg dw 0000h                ; hlt Segment des Text-Strings
  TextStringOfs dw 0000h                ; hlt Offset des Text-Strings
  FileName      db 128 dup (0)          ; hlt Filenamen in ASCIIZ-Format
  FileSize      dd 00000000h            ; hlt Datei-Gre
  FileBuffer    db 512 dup (0)          ; Puffer fr einzulesende Bytes
  TempBuffer    db 256 dup (0)          ; Puffer fr temporrer Krempel
  FileHandle    dw 0000h                ; hlt FileHandle
  FilePos       dd 00000000h            ; Position innerhalb der Datei

  OutputHandle  dw 0000h                ; FileHandle fr FILEINFO.TXT
  QuickFlag     db 1h                   ; ==1, wenn QuickView aktiv

; Konverter Variablen
  SignFlag      db 00h                  ; ==1, wenn negativer Wert

; executable scan:
  CodeSize      dd 00000000h            ; Gre des Codes ohne Overlays


GetFileInfo proc                        ; ES:DI @TextString, DS:SI @Filename
    mov cs:TextStringSeg, es            ; String-Adresse sichern (Offset)
    mov cs:TextStringOfs, di            ; String-Adresse sichern (Segment)

    call ConvertToAsciiz                ; FileName konvertieren
    call GetFileSize                    ; Datei-Gre bestimmen

    cmp cs:QuickFlag, 1                 ; Quick-View aktiviert ?
    je $+5
    call InitOutputfile                 ; nur bei nicht Quick-View ntig

    mov ax, 3d00h                       ; ah=3dh -> file ffnen
    push cs
    pop ds
    mov dx, offset FileName             ; DS:DX -> ASCIIZ-Filename
    int 21h                             ; DOS-API Aufruf
    jc @FileOpenError
    mov FileHandle, ax

    call ConvertFileSize                ; File-Gre in String ablegen
    call ScanExecutable                 ; auf ausfhrbare Datei checken

  @AllDone:                             ; Verlassen dieses Progs !!!!!
    cmp QuickFlag, 1                    ; Quick-View aktiviert ?
    je $+5
    call CloseOutputFile                ; nur bei nicht Quick-View ntig.

    mov ah, 3eh                         ; ah=3eh -> Datei schlieen
    mov bx, FileHandle                  ; BX=Handle
    int 21h                             ; DOS-Api Aufruf
    jc @FileCloseError
    ret
  @OutputFileError2:
    mov dx, offset ErrorMsg6            ; DS:DX @ErrorMsg6
    jmp $+25
  @OutputFileError1:
    mov dx, offset ErrorMsg5            ; DS:DX @ErrorMsg5
    jmp $+20
  @FileSizeError:
    mov dx, offset ErrorMsg3            ; DS:DX @ErrorMsg3
    jmp $+15
  @fileCloseError:
    mov dx, offset ErrorMsg4            ; DS:DX @ErrorMsg4
    jmp $+10
  @FileOpenError:
    mov dx, offset ErrorMsg1            ; DS:DX @ErrorMsg1
    jmp $+5
  @FileReadError:
    mov dx, offset ErrorMsg2            ; DS:DX @ErrorMsg2
    push cs
    pop ds
    mov ah, 9                           ; AH=9 -> String ausgeben
    int 21h                             ; DOS-API Aufruf
    mov ah, 4ch                         ; ah=4ch -> Programm beenden
    int 21h                             ; DOS-API Aufruf
GetFileInfo endp

InitOutputFile proc
    mov ah, 3ch                         ; ah=3ch -> Create File
    xor cx, cx                          ; CX=Flags
    push cs
    pop ds
    mov dx, offset OutputFileName       ; DS:DX @FileName
    int 21h                             ; DOS-API Aufruf
    jnc $+7
    add sp, 2
    jmp @OutputFileError1               ; Fehlertext ausgeben
    mov OutputHandle, ax                ; File-Handle sichern
    ret
InitOutputFile endp

CloseOutputFile proc
    mov ah, 3eh                         ; ah=3eh -> Close File
    mov bx, OutputHandle                ; BX=Handle
    int 21h                             ; DOS-API Aufruf
    jnc $+7
    add sp, 2
    jmp @OutputFileError2               ; fehlertext ausgeben
    ret
CloseOutputFile endp

AddText proc                            ; DS:SI @Pascal-String
    cmp cs:QuickFlag, 0                 ; Auf Screen oder in eine Datei ?
    je @WriteToFile
    mov es, cs:TextStringSeg
    mov di, cs:TextStringOfs            ; ES:DI @Textbuffer
    mov bp, di                          ; DI sichern, geht kaputt
    mov cl, es:[di]
    xor ch, ch                          ; in CX die alte Stringlnge
    add di, cx                          ; ES:DI @Ende des Textbuffer
    inc di                              ; " +1
    xor ch, ch
    mov cl, ds:[si]                     ; CX=Lnge des zu addierenden Stringes
    cld
    inc si                              ; Lngenbyte berspringen
    rep movsb                           ; String kopieren
    mov cx, di                          ; CX=neue Position im String
    sub cx, bp                          ; davon die alte Pos abziehen...
    dec cx                              ; ...dekrementieren...
    mov es:[bp], cl                     ; ...und als Lngenbyte sichern
    ret
  @WriteToFile:
    mov ah, 40h                         ; ah=40 -> WriteToFile
    mov bx, outputhandle                ; bx=handle
    xor ch, ch
    mov cl, ds:[si]                     ; cl=number of bytes
    inc si                              ; Lngenbyte berspringen
    mov dx, si                          ; DS:DX @Buffer
    int 21h                             ; DOS-API Aufruf
    ret
AddText endp

AddNumber proc                          ; Wert in EAX
    mov cs:SignFlag, 0
    test eax, 80000000h                 ; oberstes Bit gesetzt ? (Vorzeichen)
    jz $+14
    mov cs:SignFlag, 1                  ; Vorzeichen-Flag setzen...
    and eax,  7fffffffh                 ; ...und das Vorzeichen rausfiltern
    mov edx, eax
    mov ah, 12                          ; ah=12 -> KOnvertier Routine DEC2Str
    mov bx, dx                          ; BX=Low word
    shr edx, 16                         ; DX=high word
    push cs
    pop es
    mov di, offset TempBuffer           ; ES:DI @StringBuffer
    int 32h                             ; Shell-System API Aufruf
    push cs
    pop ds
    mov si, offset TempBuffer           ; DS:SI @Lngenstring
    inc si                              ; Lngenbyte berspringen
    mov cx, si
    lodsb                               ; Byte laden           
    cmp al, 20h                         ; Leerzeichen ?              
    jne $+4                             ;     
    jmp $-5                             ; --------------------------
    mov dx, si                          ; 
    sub dx, cx
    dec dx
    sub si, 2
    mov dh, 10
    sub dh, dl
    mov ds:[si], dh
    cmp cs:SignFlag, 1
    je NegativerWert
    call AddText
    ret
  NegativerWert:
    mov al, ds:[si]                     ; Lngenbyte laden...
    inc al                              ; ...erhhen...
    mov ah, 2dh                         ; ...'-'addieren...
    dec si
    mov ds:[si], ax                     ; ...und sichern
    call AddText                        ; Nummer 'ausgeben'
    ret
AddNumber endp

ConvertFileSize Proc
    cmp cs:QuickFlag, 1
    je @QuickFileSize
    mov si, offset CommonString2
    call AddText
    mov eax, FileSize
    call AddNumber
    mov si, offset CommonString1
    call AddText
    mov si, offset CR
    call AddText
    ret
  @QuickFileSize:
    mov eax, FileSize
    call AddNumber
    mov si, offset CommonString1
    call AddText
    mov si, offset komma
    call AddText
    ret
ConvertFileSize endp

ScanExecutable proc
    cmp filesize, 31                    ; Datei gro genug ???
    ja $+3
    ret
    mov bx, FileHandle                  ; BX=FileHandle
    mov ah, 3fh                         ; ah=3fh -> Datei lesen
    mov cx, 20h                         ; CX=Anzahl Bytes
    mov dx, offset FileBuffer           ; DS:DX @Buffer
    int 21h                             ; DOS-API Aufruf
    jc @FileReadError
    xor ebx, ebx
    mov bx, ax
    add FilePos, ebx                    ; FilePos erhhen
    mov ax, ds:word ptr filebuffer
    cmp ax, 5a4dh                       ; 'MZ' -> EXE-File
    je MzHeader
    cmp ax, 4d5ah
    je ZmHeader                         ; 'ZM' -> EXE-File
    cmp ax, 504dh
    je MpHeader                         ; 'MP' -> old Phar Lap executable
    cmp ax, 3250h
    je P2Header                         ; 'P2' -> new Phar Lap 286 exe
    cmp ax, 3350h
    je P3Header                         ; 'P3' -> new Phar Lap 386 exe
    ret
  P3Header:
    mov si, offset ExecutableString5
    jmp $+20
  P2Header:
    mov si, offset ExecutableString4
    jmp $+15
  MpHeader:
    mov si, offset ExecutableString3
    jmp $+10
  MzHeader:
    mov si, offset ExecutableString1
    jmp $+5
  ZmHeader:
    mov si, offset ExecutableString2
    push si
    cmp cs:QuickFlag, 1
    je $+8
    mov si, offset CommonString3        ; DS:SI @'Dateityp :'
    call AddText
    pop si
    call AddText

    cmp cs:QuickFlag, 1
    je @QuickScanExecutable

    mov si, offset ExecutableString10   ; 'Codegre : '
    call AddText
    xor eax, eax
    xor ebx, ebx
    mov ax, cs:word ptr filebuffer+4    ; Anzahl an 512-Byte Blocks
    mov bx, cs:word ptr filebuffer+2    ; Anzahl Bytes in letztem Block
    shl eax, 9                          ; *512
    cmp bx, 0
    je $+11
    sub eax, 512
    add eax, ebx
    mov codesize, eax
    call AddNumber
    mov si, offset ExecutableString11   ; 'Overlays: '
    call AddText
    mov ebx, filesize
    cmp ebx, CodeSize
    jae $+21
    mov ebx, CodeSize
    sub ebx, filesize
    add ebx, 80000000h
    jmp $+7
    sub ebx, CodeSize
    mov eax, ebx
    call AddNumber
    mov si, offset ExecutableString15   ; DS:SI @'Header : '
    call AddText
    mov si, offset CommonString5        ; DS:SI @'OK'
    mov CodeSize, eax
    cmp eax, FileSize                   ; Header zerstrt ?
    jbe $+5                             ; berspringe zwei Opcodes
    mov si, offset CommonString4        ; DS:SI @'Zerstrt'
    call AddText
    ret
  @QuickScanExecutable:
    xor eax, eax
    xor ebx, ebx
    mov ax, cs:word ptr filebuffer+4    ; Anzahl an 512-Byte Blocks
    mov bx, cs:word ptr filebuffer+2    ; Anzahl Bytes in letztem Block
    shl eax, 9                          ; *512
    cmp bx, 0
    je $+11
    sub eax, 512
    add eax, ebx
    cmp eax, filesize
    ja $+3
    ret
    mov si, offset ExecutableString9    ; DS:SI @'Header zerstrt'
    call AddText
    ret
ScanExecutable endp

ConvertToAsciiz Proc
    push cs
    pop es
    mov di, offset FileName             ; ES:DI @FileName (ASCIIZ)
    xor ch, ch
    mov cl, ds:[si]                     ; Stringlnge in CX
    inc si
    cld
    rep movsb                           ; String in ASCIIZ-String kopieren
    mov byte ptr es:[di], 0             ; String mit 0 terminieren
    ret
ConvertToAsciiz endp

GetFileSize proc                        ; Liest Gre der Datei
    push cs
    pop ds
    mov dx, offset FileName             ; DS:DX @FileName
    mov cx, 11111111b                   ; Attribute: Alle
    mov ah, 4eh                         ; ah=4eh -> Directory-Eintrag finden
    int 21h                             ; DOS-API Aufruf
    jc @FileSizeError
    mov eax, ds:dword ptr 09ah
    mov filesize, eax
    ret
GetFileSize endp

; Konstante fr Zugriff auf Output-Datei
OutputFileName db 'C:\FILEINFO.TXT', 0

; Konstanten fr Error-Messages
ErrorMsg1 db 0dh,0ah,'-> Fehler bei ffnen der Datei',0dh,0ah,'$'
ErrorMsg2 db 0dh,0ah,'-> Fehler bei Lesen aus Datei',0dh,0ah,'$'
ErrorMsg3 db 0dh,0ah,'-> Datei existiert nicht',0dh,0ah,'$'
ErrorMsg4 db 0dh,0ah,'-> Fehler beim Schlieen der Datei',0dh,0ah,'$'
ErrorMsg5 db 0dh,0ah,'-> Fehler beim ffnen der Ausgabe-Datei',0dh,0ah,'$'
ErrorMsg6 db 0dh,0ah,'-> Fehler beim Schlieen der Output-Datei',0dh,0ah,'$'

; Konstanten fr allgemeine Textausgaben
CommonString1 db 6,' Bytes'
CommonString2 db 10h,'Dateigre :    '
CommonString3 db 10h,'Dateityp   :    '
CR            db 2,0dh,0ah
Komma         db 2,', '
CommonString4 db 10,'zerstrt',0dh,0ah
CommonString5 db 4,'OK',0dh,0ah


; Konstanten fr Textausgaben bei ausfhrbaren Dateien
ExecutableString1  db 13, 'MZ-executable'
ExecutableString2  db 13, 'ZM-executable'
ExecutableString3  db 23, 'old Phar Lap executable'
ExecutableString4  db 25, 'Phar Lap 286er executable'
ExecutableString5  db 25, 'Phar Lap 386er executable'
ExecutableString9  db 19,', zerstrter Header'
ExecutableString11 db 18h, ' Bytes',0dh,0ah,'Overlay    :    '
ExecutableString10 db 12h, 0dh,0ah,'Codegre  :    '
ExecutableString15 db 18h, ' Bytes',0dh,0ah,'Header     :    '



