
{ bersetzt die help-source-codes in shell-help-format-files }

uses dos;

{$I io.inc}

type indexStruc = record
                no  : word;       { nummer des Bereiches }
                ofs : longint;    { ofs des Bereichs in file }
                len : word;       { Lnge des Bereichs }
     end;

     mrkStruc        = array[1..2000] of string[31];
     pMrkStruc       = ^mrkStruc;
     ofsStruc        = array[1..2000] of longint;
     pOfsStruc       = ^ofsStruc;

var sf        : file;
    sFileName : string;

    hf, idf   : file;
    hFileName : string;
    iFileName : string;

    index1    : indexStruc;
    mrkList   : pMrkStruc;
    mrkC      : word;
    ofsList   : pOfsStruc;
    lenList   : pOfsStruc;
    p         : word;

    cc, endCC : word;
    srcBuf    : pByteBuf;
    done      : boolean;
    writeBuf  : pByteBuf;
    wc        : word;
    wRes, res : word;

    inSt      : string;
    keyMode   : boolean;
    doneCh    : boolean;
    inEntry   : boolean;

    markS, linkS : string;
    markOfsC     : longint;       { aktueller offset im file -> ab contmark }
    markOfs      : longint;       { Beginn des Markentextes }
    titelS       : string;
    i            : word;

{ konvertiert in GroBuchstaben-String }
function ups (st : string) : string;
var  ws : string;
     i  : byte;
begin
     ws[0] := st[0];
     for i := 1 to length(st) do
      ws[i] := upCase(st[i]);
     ups := ws;
end;

{ speichert ofs einer Marke in Liste -> sucht dazu Marken-Eintrag }
procedure saveMarkOfs ( mr : string; mOfs, mLen : longint );
var  ws : string;
     ix : word;
begin
     if mrkC = 0 then exit; { keine Eintrge enthalten }
     ix := 1;  ws := ups ( mr );

     repeat { Verweistabelle durchlaufen und nach Gleichheiten suchen }
           if mrkList^[ix] = ws then
            begin
                 ofsList^[ix] := mOfs;
                 lenList^[ix] := mLen;
                 exit;
            end;
           inc (ix);
     until (ix = mrkC+1);
end;

{ fgt eine Marke in die mrkList ein }
procedure addMark ( mr : string );
begin
     if mrkC >= 1999 then
      begin
           writeln ('>>  Die Datei enthlt zuviele Marken. Bitte segmentieren sie.');
           halt;
      end;

     inc (mrkC);
     mrkList^[mrkC] := ups (mr);
     write ('');
end;

{ verknpft die Marken miteinander / offsetbildung }
function checkMark (mark : string) : boolean;
var  ix : word;
     ws : string;
begin
     if mrkC = 0 then exit; { keine Eintrge enthalten }
     checkMark := false;
     write (''); ix := 1;  ws := ups (mark);

     repeat { verweistabelle durchlaufen und nach Gleichheiten suchen }
           if mrkList^[ix] = ws then begin checkMark := true; p := ix; exit; end;
           inc (ix);
     until (ix = mrkC+1);
end;

{ die Funktion liefert einen Verweisstring fr .hlp zurck, wie in help.com fordert }
function verweis ( lenScr : byte; mark : string ) : string;
var  ws : string;
begin
     p := 0;

     if checkMark ( mark ) then
      begin
           ws := #255; { erstes Zeichen }
           ws[2] := char(lenScr); { dann Lnge }
           ws[3] := char(lo(p-1)); { referenz nr. }
           ws[4] := char(hi(p-1));
           ws[5] := #0; { offset im anderen Bereich }
           ws[6] := #0;
           ws[0] := #6;
           verweis := ws;
      end
     else
      begin
           writeln ('>>  Konnte Marke '+mark+' nicht finden. ');
      end;
end;

procedure addToWriteBuf (ch : byte);
begin
     writeBuf^[wc] := ch;
     inc (wc);

     if wc = sizeOf (byteBuf) +1 then
      begin
           writeFile (hf, writeBuf^, sizeOf (pByteBuf), wRes);
           wc := 0;
      end;
end;

{ durchluft den Text und prft nach Markierungen }
procedure check1;
var  ts : string;
     i  : byte;
begin
     doneCh := false;

     repeat
          { Schlsselwortbeginn }
           IF srcBuf^[cc] = byte('%') then
            IF keyMode = false Then
             begin
                  keyMode := true;
                  inSt := '';
             end
            else
             begin
                  keyMode := false;
                  if inSt <> '' then if inEntry = false then inEntry := true
                  else inEntry := false;

                  IF inSt<>'' then inSt := ups(inSt);

                  IF inSt = 'MARK' then
                   begin
                        markS := '';
                        inEntry := true;
                   end;
                  IF inSt = 'CONTMARK' then
                   begin
                        addMark (markS);
                        keyMode := false;
                        inSt := '';
                   end;
            end
           else
            begin
                { KeyWort - Auffllung }
                 If keyMode Then
                  begin
                       inSt := inSt + char(srcBuf^[cc]);
                  end
                 else
                  if inEntry then { innerhalb eines Eintrages -> interpretieren }
                   begin
                        IF inSt = 'MARK' then
                         begin
                              { if srcBuf^[cc] <> 32 then } markS := markS + char(srcBuf^[cc]);
                         end;
                   end;
            end;

         inc (cc);
     until (cc = endCC) or (doneCh);
end;

{ durchluft den Text und verknpft die Markierungen }
procedure check2;
var  ts : string;
     i  : byte;
begin
     doneCh := false;

     repeat
          { Schlsselwortbeginn }
           IF srcBuf^[cc] <> 255 then { reserved -> do not use }
           IF srcBuf^[cc] = byte('%') then
            IF keyMode = false Then
             begin
                  keyMode := true;
                  inSt := '';
             end
            else
             begin
                  keyMode := false;
                  if inSt = '' then addToWriteBuf (byte('%'))
                  else if inEntry = false then inEntry := true
                  else inEntry := false;

                  IF inSt<>'' then inSt := ups(inSt);

                  IF inSt = 'TITLE' then begin inEntry := true; titelS := ''; end;
                  IF inSt = 'LINK' then begin inEntry := true; linkS := ''; end;
                  IF inSt = 'MARK' then begin inEntry := true; markS := ''; end;

                  IF inSt = 'ENDLINK' then { link eingelesen }
                   begin
                        ts := verweis ( length(titelS), linkS );
                        for i := 1 to length(ts) do
                         addToWriteBuf ( byte(ts[i]) );
                        for i := 1 to length(titelS) do
                         addToWriteBuf ( byte(titelS[i]) );

                        markOfsC := markOfsC + length (ts) + length (titelS);
                   end;
                  IF inSt = 'CONTMARK' then
                   Begin
                        markOfs  := filePos ( hf ) + wc;
                        markOfsC := 32;
                        fillchar (ts, 35, 32);
                        ts := char(length (markS)+1) + copy (markS, 1, 30);
                        for i := 1 to 32 do
                         addToWriteBuf ( byte(ts[i]) );
                   end;
                  IF inSt = 'ENDMARK' then
                   Begin
                        markOfsC := markOfsC + 2;
                         addToWriteBuf ( 13 );  addToWriteBuf ( 10 );
                        saveMarkOfs ( markS, markOfs, markOfsC );
                   end;
            end
           else
            begin
                { KeyWort - Auffllung }
                 If keyMode Then
                  begin
                       inSt := inSt + char(srcBuf^[cc]);
                  end
                 else
                  if not inEntry then { ansonsten gleich kopieren }
                   begin
                        inc (markOfsC);
                        addToWriteBuf (srcBuf^[cc]);
                   end
                  else { innerhalb eines Eintrages -> interpretieren }
                   begin
                        IF inSt = 'LINK' then
                         begin
                              { if srcBuf^[cc] <> 32 then } linkS := linkS + char(srcBuf^[cc]);
                         end;
                        IF inSt = 'TITLE' then
                         begin
                              titelS := titelS + char(srcBuf^[cc]);
                         end;
                        IF inSt = 'MARK' then
                         begin
                              { if srcBuf^[cc] <> 32 then } markS := markS + char(srcBuf^[cc]);
                         end;
                   end;
            end;

         inc (cc);
     until (cc = endCC) or (doneCh);
end;

procedure checkParams;
var  sr    : searchRec;
     dirS  : dirStr;
     extS  : extStr;
     nameS : nameStr;
begin
     if paramcount <> 1 then
      begin
           writeln (#13#10' >> Das Programm bentigt einen Dateinamen als Parameter.');
           halt;
      end;

     sFileName := paramStr (1);
     findfirst (sFileName, 1+2+4+32, sr);
     if dosError <> 0 then
      begin
           writeln (#13#10' >> Die angegebene Datei '+sFileName+' ist nicht vorhanden.');
           halt;
      end;

     fsplit (sFileName, dirS, nameS, extS);
     hFileName := nameS + '.HLP';  iFileName := nameS + '.IDX';
end;

begin
     writeln ('shell-system help-compiler ver 0.9    iCode june1996 ');
     checkParams;  writeln;

     {getMem (indexList, sizeOf (IndexStrucList));}
     getMem (mrkList, sizeOf (MrkStruc));
     getMem (srcBuf, sizeOf (byteBuf));
     getMem (writeBuf, sizeOf (byteBuf));
     getMem (ofsList, sizeof (ofsStruc));
     getMem (lenList, sizeof (ofsStruc));

  { source-code auslesen und in hlp-schreiben }
     openFile (sf, sFileName);  createFile (hf, hFileName);

     write ('Lauf 1 "Marken suchen": ');
     done := false;  wc := 0;  keyMode := false;  inSt := '';  inEntry := false;
     mrkC := 0;
     repeat
           readFile (sf, srcBuf^, sizeOf (byteBuf), res);

           endCC := res;  cc := 0;
           check1;

           if res < sizeOf(byteBuf) then done := true;
     until eof(sf) or (done);
     writeln;
     {$I-} seek (sf, 0); {$I+} errCheck;

     write ('Lauf 2 "Links mit Marken verkpfen": ');
     done := false;  wc := 0;  keyMode := false;  inSt := '';  inEntry := false;
     p := 0;
     repeat
           readFile (sf, srcBuf^, sizeOf (byteBuf), res);

           endCC := res;  cc := 0;
           check2;

           if res < sizeOf(byteBuf) then done := true;
     until eof(sf) or (done);
     writeln;

     addToWriteBuf(13);  addToWriteBuf(10);
     IF wc <> 0 then writeFile (hf, writeBuf^, wc-1, wRes);
     closeFile (hf);  closeFile (sf);

  { idx-file erzeugen }
     write ('Lauf 3 "Marken in index.file schreiben": ');
     createFile (idf, iFileName);

     for i := 1 to mrkC do
      begin
           index1.no := i-1;
           index1.ofs := ofsList^[i];
           index1.len := lenList^[i];

           writeFile (idf, index1, 8, wRes);

           write ('');
      end;

     index1.no := $FFFF;
     index1.ofs := $FFFFFFFF;
     index1.len := $FFFF;

     writeFile (idf, index1, 8, wRes);
     writeln; closeFile (idf);

     freeMem (lenList, sizeof (ofsStruc));
     freeMem (ofsList, sizeof (ofsStruc));
     freeMem (writeBuf, sizeOf (byteBuf));
     freeMem (srcBuf, sizeOf (byteBuf));
     freeMem (mrkList, sizeOf (MrkStruc));
    { freeMem (indexList, sizeOf (IndexStrucList));}
end.