
;ͻ
;                                                                             
;                   HELP.ASM   Hilfe-System fr Shell-System            
;                                                                             
;                       bentigt die Shell-System-API                         
;                                                                             
;                          Code : 1996 iCode [Falcon]                         
;                                                                             
;ͼ




.386c



code      segment byte use16
assume    cs:code, ds:code, use16
org       100h
entry:    jmp begin


colour1   db 01bh                       ; Farbe des Hauptfensters
colour2   db 01bh                       ; Farbe des Textes
colour3   db 0f1h                       ; Buttonfarbe
colour4   db 0e4h                       ; gewhlter Button
colour5   db 078h                       ; deaktivierter Button
colour6   db 01eh                       ; keyWord
colour7   db 00fh                       ; aktives keyWord
colour8   equ 0h                        ; Hotkey

number          dw      0000h

Startpos        dw      0000h           ; Startpos auf dem Screen
Endpos          dw      0000h           ; Endpos auf dem Screen
MemSeg          dw      0000h           ; Textpuffer

HistorySeg      dw      0000h           ; } History-Segment und History-Pointer,
History         dw      0000h           ; } zeigt auf freien Eintrag

IdxFileName     db      'c:\shell\help\shell.idx',0
FileHandle      dw      0000h
fileSize        dw      0000h
TextFileName    db      'c:\shell\help\shell.hlp',0

Choice          db      0               ; 255=key;0-...=link
KeyChoice       db      01h             ; Nummer der Taste
JumpNumber      db      00h             ; Anzahl der Links

; jetzt folgt eine Art 'Record'
ThemeNbr        dw      0000h
ThemeStart      dd  00000000h
ThemeSize       dw      0000h

headLine        db 20h dup(0)

Jump0           db 7 dup(0)
Jump1           db 7 dup(0)
Jump2           db 7 dup(0)
Jump3           db 7 dup(0)
Jump4           db 7 dup(0)
Jump5           db 7 dup(0)
Jump6           db 7 dup(0)
Jump7           db 7 dup(0)
Jump8           db 7 dup(0)
Jump9           db 7 dup(0)

ZeroString db 0h
HelpString db 20,'Shell System Hilfe: '

Button1 db 6,'~',colour8,'Zurck'
Button2 db 7,'~',colour8,'Abbruch'
Button3 db 5,'~',colour8,'Hilfe'



HistoryBack proc                        ; zurck-taste
        push cs
        pop ds
        mov gs, HistorySeg
        mov di, History

        cmp di, 5
        jb NoHistory

        mov dx, 0c1ch
        mov cl, 19                      
        mov si, offset Button1
        mov ah, 5
        mov bl, colour4
        mov bh, 6
        int 32h                         ; Button1 animieren

        sub di, 5
        sub History, 5                  ; } Eintrag rauskicken

        mov ax, gs:[di]
        mov Number, ax
        mov ax, gs:[di+2]
        mov startPos, ax
        mov al, gs:[di+4]
        mov Choice, al
        call ReadTheme

      NoHistory:

        ret
HistoryBack endp

SearchEnd proc
        mov si, ThemeSize
        mov startpos, si
        mov cx, 10
      SL:
        call SearchLastLine
        loop sl
        ret
SearchEnd endp

DrawJumps proc
        push 0b800h
        pop es
        push cs
        pop ds
        mov si, offset jump0
        xor dl, dl
      DrawJumpLoop:
        lodsb
        cmp al,0
        je JobDone
        movzx cx, al
        lodsw
        lodsw
        lodsw
        mov di, ax
        inc di
      ColourLoop:
        mov al, colour6
        cmp cs:choice, dl
        jne $+5
        mov al, colour7
        mov byte ptr es:[di], al
        add di, 2
        loop ColourLoop
        inc dl
        jmp DrawJumpLoop
      JobDone:
        ret
DrawJumps endp

SearchLastLine proc
        mov si, StartPos                ; }
        cmp si, 0
        je ThemeStartFound
        sub si, 3                       ; }
        jc themeStartfound
        push cs                         ; }
        pop ds                          ; } Initialisierung der Register
        mov fs, MemSeg                  ; }
      SearchLabel:
        cmp byte ptr fs:[si], 0ah
        je LastLineFound
        dec si
        jz ThemeStartFound
        jmp SearchLabel
      LastLineFound:
        inc si
        mov startPos, si
        ret
      ThemeStartFound:
        xor si, si
        mov StartPos, si
        ret
SearchLastLine endp

SearchNextLine proc
        mov si, StartPos                ; }
        push cs                         ; }
        pop ds                          ; } Initialisierung der Register
        mov fs, MemSeg                  ; }
        mov ax, endpos
        cmp ax, ThemeSize
        jae ThemeEndReached
      SearchLoop:
        mov al, fs:[si]
        cmp al, 0dh
        je FoundNextLine
        inc si
        cmp si, ThemeSize
        je ThemeEndReached
        jmp SearchLoop
      FoundNextLine:
        add si, 2
        mov Startpos, Si
        xor al, al                      ; Rckgabewert: AL=0 -> O.K.
        ret
      ThemeEndReached:
        mov al, 1                       ; Rckgabewert: AL=1 -> Kein Text mehr
        ret
SearchNextLine endp

AddJump proc
        inc cs:JumpNumber
        pusha
        push es
        mov ax, cs
        mov ds, ax
        mov es, ax

        mov ax, di
        mov di, offset Jump0
      JumpSearchLoop:
        cmp byte ptr [di], 0
        je freeJumpfound
        add di, 7
        jmp JumpSearchLoop
      FreeJumpFound:
        push fs
        pop ds
        mov cx, 5
        rep movsb
        stosw
        push cs
        pop ds
        pop es
        popa
        ret
AddJump endp

clearJumps proc
        mov cs:JumpNumber, 0
        push cs
        pop es
        mov di, offset jump0
        mov cx, 10*7
        xor al, al
        rep stosb
        ret
clearJumps endp

DrawScreen proc
        call clearJumps
        push 0b800h
        pop es
        mov di, 654
        mov fs, MemSeg
        mov si, Startpos

        mov cx, 14                      ; Maximal vierzehn Zeilen Text
      SignLoop:
        mov al, fs:[si]                 ; } 
        inc si                          ; } Byte laden
        cmp al, 0ffh
        jne NoHyperJump
        call AddJump
        add si, 5
        jmp SignLoop
      NohyperJump:
        cmp al, 0dh
        jne DrawSign
        cmp byte ptr fs:[si], 0ah
        jne drawSign
        inc si                          ; }
        call ClearRestOfLine            ; }
        mov ax, di                      ; }
        mov bl, 160                     ; }
        div bl                          ; } Eine Zeile weiter springen
        mov ah, 160                     ; }
        mul ah                          ; }
        mov di, ax                      ; }
        add di, 174                     ; }
        cmp si, ThemeSize
        jae ThemeEnd
        loop SignLoop                   ;
        jmp ThemeEnd
      DrawSign:
        mov ah, colour2                 ; }
        stosw                           ; } Zeichen ausgeben
        jmp SignLoop
      ThemeEnd:
        mov endpos, si
        call ClearRestOfWindow
        ret
drawScreen endp

ClearRestOfWindow proc
      ClearLoop:
        call ClearRestOfLine
        add di, 160
        cmp di, 2870
        ja WindowCleared
        jmp ClearLoop
      WindowCleared:
        ret
ClearRestOfWindow endp

ShowState proc
        push 0b800h                     ; }
        pop es                          ; }
        mov di, 0628                    ; } Register initialisieren

        mov ax, 14                      ; }
        mul EndPos                      ; }
        mov bx, ThemeSize               ; } AX:=EndPos*10/ThemeSize
        div bx                          ; }
        mov dl, al

        mov al, ''
        mov ah, colour1
        rol ah, 4
        stosw
        add di, 158
        mov cl, 1
      BalkenLoop:
        mov al, ''
        cmp cl, dl
        jne $+4
        mov al, ''
        mov ah, colour1
        rol ah, 4
        stosw
        add di, 158
        inc cl
        cmp cl, 15
        jb BalkenLoop
        mov al, ''
        mov ah, colour1
        rol ah, 4
        stosw
        ret
ShowState endp

ClearRestOfLine proc
        pusha
        mov ax, di
        mov bl, 160
        div bl
        mov al, 146
        sub al, ah
        movzx cx, al
        shr cl, 1
        mov al, 20h
        mov ah, colour1
        rep stosw
        popa
        ret
ClearRestOfLine endp

ChangeText proc
        push cs                         ; }
        pop ds                          ; } Register initialisieren

        mov gs, HistorySeg              ; }
        mov di, History                 ; }

        mov ax, number                  ; }
        mov gs:[di], ax                 ; }
        mov ax, startPos                ; } In History-Tabelle sichern
        mov gs:[di+2], ax               ; }
        mov al, Choice
        mov gs:[di+4], al
        add History, 5

        mov si, offset jump0            ; }
        mov al, 7                       ; } SI:=offset jump0 + Choice*7
        mul choice                      ; }
        add si, ax                      ; }

        inc si                          ; } Bildschirmlnge interessiert ja nicht

        lodsw                           ; }
        mov number, ax                  ; } Nummer des Textes laden

        pusha                           ; }
        call ReadTheme                  ; }
        popa                            ; }

        lodsw                           ; }
        mov startpos, ax                ; } Startposition im File lesen

        mov choice, 0 ;;;*** Testweise

        ret
ChangeText endp

readTheme proc
        mov ax, 3d00h                   ; }
        mov dx, offset IdxFileName      ; }
        int 21h                         ; } assign(fileHandle, FileName);
        mov FileHandle, ax              ; }
        jnc NoAssignError               ; }
        jmp AssignError
      NoAssignError:

        mov bp, number                  ; }
      ReadNextEntry:                    ; }
        mov ah, 3fh                     ; }
        mov bx, FileHandle              ; }
        mov cx, 8                       ; } Es wird versucht, im IDX-File den
        mov dx, offset ThemeNbr         ; } zu der Blocknummer passenden Ein-
        int 21h                         ; } trag zu finden, normalerweise sol-
        jnc NoThemeError                ; } lte dies auch funkltionieren, es
        jmp ThemeError                  ; } seie denn, das help-file ist futsch.
      NoThemeError:                     ; }
        cmp ThemeNbr, bp                ; }
        jne ReadNextEntry               ; }

      FoundEntry:
        mov ah, 3eh                     ; }
        mov bx, FileHandle              ; }
        int 21h                         ; } close(FileHandle);
        jnc NoCloseError                ; }
        jmp CloseError
      NoCloseError:
        sub ThemeSize, 20h

        mov ax, 3d00h                   ; }
        mov dx, offset TextFileName     ; }
        int 21h                         ; } assign(fileHandle, FileName);
        mov FileHandle, ax              ; }
        jnc NoAssignError2              ; }
        jmp AssignError
      NoAssignError2:
        mov ax, 4200h
        mov bx, FileHandle
        mov cx, word ptr ThemeStart+2
        mov dx, word ptr ThemeStart
        int 21h
        jnc NoSeekError
        jmp SeekError
      NoSeekError:

        mov ah, 3fh
        mov bx, FileHandle
        mov cx, 20h
        mov dx, offset HeadLine
        int 21h
        jc ReadError

        mov ah, 3fh                     ; }
        mov bx, FileHandle              ; }
        mov cx, ThemeSize               ; } blockread(textFile, MemSeg, Size);
        xor dx, dx                      ; }
        mov ds, MemSeg                  ; }
        int 21h                         ; }
        jc ReadError                    ; }
        push cs                         ; }
        pop ds                          ; }

        mov ah, 3eh                     ; }
        mov bx, FileHandle              ; }
        int 21h                         ; } close(TextFile)
        jc CloseError                   ; }

        call DrawHeadline

        ret
readTheme endp

DrawHeadLine proc
        push 0b800h
        pop es
        mov di, 386
        mov al, 0cdh
        mov ah, colour1
        mov cx, 32
        rep stosw

        mov ah, 6
        mov dh, 32
        mov dl, 2
        mov bl, colour1
        xor bh, bh
        mov si, offset HeadLine
        int 32h
        ret
DrawHeadLine endp

DrawButtons proc
        push cs                         ; }
        pop ds                          ; } Register initialisieren

        mov ah, 5                       ; }
        mov dx, 0c1ch                   ; }
        mov cl, 19                      ; } Button1 zeichnen
        mov bh, 04
        mov bl, colour3                 ; }
        cmp KeyChoice, 0                ; }
        jne ewd                         ; }
        cmp choice, 255
        jne ewd
        mov bl, colour4                 ; }
      ewd:                              ; }
        cmp History, 4                  ; }
        ja $+6                          ; }
        mov bl, colour5                 ; }
        mov si, offset Button1          ; }
        int 32h                         ; }

        mov ah, 5                           ; }
        mov dx, 1f2fh                       ; }
        mov cl, 19                          ; } Button2 zeichnen
        mov bh, 04
        mov bl, colour3                    ; }
        cmp keyChoice, 1
        jne lbj
	cmp choice, 255
	jb lbj
        mov bl, colour4
    lbj:
        mov si, offset Button2              ; }
        int 32h                             ; }

        mov ah, 5                       ; }
        mov dx, 3242h                   ; }
        mov cl, 19                      ; } Button3 zeichnen
        mov bh, 04
        mov bl, colour3                   ; }
        cmp keyChoice, 2                ; }
        jne lki                         ; }
        cmp choice, 255
        jne lki
        mov bl, colour4                 ; }
      lki:
        mov si, offset Button3          ; }
        int 32h                         ; }

        ret
drawButtons endp



HelpHelp proc
        mov dx, 3242h                   ; }
        mov cl, 19                      ; } Button3 animieren
        mov si, offset Button3          ; }
        mov ah, 5
        mov bl, colour4
        mov bh, 6
        int 32h

        mov ah, 1
        mov ch, 5
        mov cl, 20
        mov dh, 10
        mov dl, 70
        mov bl, colour1
        mov bh, 7
        mov si, offset HelpHelpString
        int 32h

        mov ah, 6
        mov dh, 40
        mov dl, 10
        mov si, offset HelpString1
        mov bh, 1
        mov bl, colour2
        int 32h

        mov ah, 6
        mov dh, 40
        mov dl, 11
        mov si, offset HelpString2
        mov bh, 1
        mov bl, colour2
        int 32h

        mov ah, 5                           ; }
        mov dx, 232dh                       ; }
        mov cl, 16                          ; }
        xor bh, bh                          ; }
        mov bl, colour4
        mov si, offset ok                   ; }
        int 32h                             ; }

      CharLoop:
        xor ah, ah
        int 16h


        mov ah, 5                           ; }
        mov dx, 232dh                       ; }
        mov cl, 16                          ; }
        mov bh, 2                           ; }
        mov bl, colour4
        mov si, offset ok                   ; }
        int 32h                             ; }

        mov ah, 2
        int 32h

        ret

HelpHelpString  db 28,'Shell System.Hilfe zur Hilfe'
HelpString1     db 28,'Taste:             Funktion:'
HelpString2     db 28,'                  Scrollen'
ok db 2,'OK'
HelpHelp endp

begin:
    ; erstmal den unbenutzten Speicher freigeben
    ; (Im allgemeinen zeigen alle Segment-Register auf CS !!)

        mov     sp,(offset end_of_code) + 1010
        mov     bx,(offset end_of_code) + 1100
        shr     bx,4
        mov     ah,4ah
        int     21h

    ; Speicher fr den Textpuffer allokieren

        mov ah, 48h
        mov bx, 4000
        int 21h
        jnc NoMemError
        jmp MemError
      NoMemError:
        mov MemSeg, ax

    ; Speicher fr die History allokieren

        mov ah, 48h
        mov bx, 4000
        int 21h
        jnc NoMemError2
        jmp MemError
      NoMemError2:
        mov HistorySeg, ax

    ; Cursor ausschalten

        mov     cx,3200h
        mov     ah,1
        int     10h

    ; Blinken ausschalten

        mov ax, 0d00h
        int 32h

    ; Hauptfenster zeichnen

        mov ah, 1
        mov cx, 0216h
        mov dx, 054bh
        mov bl, colour1
        mov bh, 7
        mov si, offset HelpString
        int 32h

    ; Angefprdertes Hilfethema in Textpuffer einlesen

        call readTheme

    ; Schaltflchen darstellen

        call DrawButtons

    ; Jetzt folgt der Hauptloop

        include userio.inc

      LeaveHelp:

        mov bl, colour4
        mov bh, 6
        mov dx, 1f2fh                   ; }
        mov cl, 19                      ; }
        mov si, offset Button2          ; } Button animieren
        mov ah, 5
        int 32h

        mov ah, 2                       ; }
        int 32h                         ; } Hauptfenster lschen

        mov cx, 0607h                   ; } 
        mov ah, 1                       ; } Cursor=on
        int 10h                         ; }

	mov ah, 4ch
	int 21h

      AssignError:
        mov ah, 4ch
        int 21h

      MemError:
        mov ah, 4ch
        int 21h

      ReadError:
        mov ah, 4ch
        int 21h

      ThemeError:
        mov ah, 4ch
        int 21h

      CloseError:
        mov ah, 4ch
        int 21h

      SeekError:
        mov ah, 4ch
        int 21h

; Struktur der Jump-Tabelle (7 Bytes pro Eintrag) :
;
;       Byte   !   Gre   !   Bedeutung
;
;       0          Byte        Lnge auf dem Bildschirm
;       1          Word        Nummer des Hilfetextes in IDX-File
;       3          Word        Start-Offset in diesem Hilfetext
;       5          Word        Bildschirmposition des Querverweises (save DI)
;
;
; Struktur der History-Tabelle (5 Bytes pro Eintrag) :
;
;       Byte   !   Gre   !   Bedeutung
;
;       0          Word        Nummer des Hilfetextes
;       2          Word        Offset im Hilfetext
;       4          Byte        Choice

end_of_code db 0h

code ends
end entry