; kleiner file viewer.

.286c
code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin


handle       dw 0
xres         db 32
yres         db 32
filesize     dw 766
filename     db 'atcopy.ico',0
buffer       db 1000 dup (0)

set_pal proc                            ; bl=colour, bh, cl, ch = rgb
  mov dx, 3c8h
  mov al, bl
  out dx, al
  mov dx, 3c9h
  mov al, bh
  shr al, 2
  out dx, al
  mov al, cl
  shr al, 2
  out dx, al
  mov al, ch
  shr al, 2
  out dx, al
  ret
endp

def_pal proc
  mov ax, cs
  mov ds, ax
  mov si, offset buffer + 62
  xor bl, bl
  cld
  @loop_colour:
    lodsb
    mov ch, al
    lodsb
    mov cl, al
    lodsb
    mov bh, al
    call set_pal
    inc si
    inc bl
    cmp bl, 16
  jne @loop_colour
  ret
endp

build_screen proc
    mov ax, 0a000h
    mov es, ax
    mov ax, cs
    mov ds, ax
    mov si, offset buffer
    add si, 126
    mov ax, 320
    mov bl, cs:yres
    dec bl
    xor bh, bh
    mul bx
    mov di, ax

    xor dh, dh
    mov dl, cs:xres
    mov bl, cs:yres
    cld
  @build_row:
    push di
    mov bh, cs:xres
  @build_point:
    lodsb
    mov ah, al
    and ax, 0ff0h
    shr al, 4
    stosw
    sub bh, 2
    cmp bh, 0
    jne @build_point
    pop di
    sub di, 320
    dec bl
    cmp bl, 0
    jne @build_row
    ret
endp

assign_file proc
  mov ax, cs
  mov ds, ax
  mov dx, offset cs:filename
  mov ax, 3d00h
  int 21h
  mov cs:handle, ax
  ret
endp

switch_plane proc
    push ax
    mov dx, 3c4h
    mov al, 2
    out dx, al
    mov dx, 3c5h
    in al, dx
    and al, 11110000b
    pop bx
    add al, bl
    push ax
    mov dx, 3c4h
    mov al, 2
    out dx, al
    mov dx, 3c5h
    pop ax
    out dx, al
    ret
endp

init_screen proc
  mov ax, 13h
  int 10h
  ret
endp

read_file proc
  mov ax, cs
  mov ds, ax
  mov dx, offset buffer
  mov ah, 3fh
  mov cx, cs:filesize
  mov bx, cs:handle
  int 21h
  ret
endp

get_name proc
  mov si, 80h
  mov ax, cs
  mov ds, ax
  mov cl, ds:[si]
  xor ch, ch
  mov ax, cs
  mov es, ax
  mov di, offset filename
  add si, 2
  dec cx
  cld
  rep movsb
  xor al, al
  mov es:[di], al
  ret
endp

get_size proc
  mov ax, cs
  mov ds, ax
  mov dx, offset filename
  mov cx, 0ffh
  mov ah, 4eh
  int 21h
  mov ax, cs:[09ah]
  mov cs:[word ptr cs:filesize], ax
  mov ax, cs:[09ch]
  mov cs:[word ptr cs:filesize+2], ax
  ret
endp

begin:
  ;call get_name
  ;call get_size
  call assign_file
  call read_file
  call init_screen
  call def_pal
  call build_screen
  xor ax, ax
  int 16h
  mov ax, 3
  int 10h

@quit:
  mov ah, 4ch
  int 21h

endp

code    ends
        end     entry

