.486p

biosItems equ 8

memConst equ 8

fpu dw 0h

biosInfo proc
        push cs
        pop  ds
        push cs
        pop  es
        mov startPos, 0
        mov scrollPos, 0

        mov cx, 0317h
        mov dx, 064ch
        mov bl, colour1
        mov bh, 7
        mov si, offset biosTitle
        mov ah, 1
        int 32h

      biosKeyLoop:

  ; SI gem startPos auf die Stringtabelle zeigen lassen

        mov si, offset biosNametab
        movzx cx, startPos
        or cx, cx
        jz doneLoop2
      loop2:
        movzx ax, byte ptr [si]
        inc ax
        add si, ax
        loop loop2
      doneLoop2:

  ; BP gem startPos auf die CALL-Tabelle zeigen lassen

        movzx bp, startpos
        shl bp, 1
        add bp, offset biosCalltab

  ; Jetzt den kompletten Bildschirm aufbauen

        xor cx, cx
        mov dx, 0807h

      biosScreenLoop:

  ; Den Puffer lschen
        pusha
        mov byte ptr offset bufferString, 67
        mov al, 32
        mov cx, 80
        mov di, offset bufferString+1
        rep stosb
        popa

  ; Den Programmnamen in Puffer kopieren

        push cx
        movzx cx, byte ptr [si]
        inc si
        mov di, offset bufferString+2
        rep movsb
        pop cx

  ; Die Funktion zum Check aufrufen

        pusha
        mov di, offset bufferString+1+50
        call word ptr [bp]
        popa

  ; Den ganzen Puffer als String ausgeben. Leuchtbalken bercksichtigen.

        push si
        mov ah, 6
        movzx bx, colour1
        cmp cl, scrollPos
        jne $+5
        rol bl, 4
        mov si, offset bufferString
        int 32h
        pop si

        add bp, 2
        inc dl
        inc cl
        cmp cl, biosItems
        jb biosScreenloop

        xor ah, ah
        int 16h

        cmp al, 27
        je biosEsc
        mov items, biosItems
        call checkKeys
        jmp biosKeyLoop

      biosEsc:

        mov ah, 2
        int 32h
        ret
biosInfo endp

outValue proc
        xor dx, dx
        mov bx, ax
        mov ah, 12
        int 32h
        mov es:byte ptr [di+3], ' '
        add di, 12
        ret
outValue endp

checkMem proc
        int 12h
        call outValue
        ret
checkMem endp

checkAvailableMem proc
        mov ax, memAvail
        shr ax, 6
        add ax, memConst
        mov dx, word ptr row2
        call outValue
        ret
checkAvailableMem endp


checkCPU proc
  ; INT 6 auf eigene Proc verbiegen :*)
        push 0
        pop  es
        mov eax, es:dword ptr [24d]
        mov vect6, eax
        mov es:word ptr [24d], offset int6
        mov es:word ptr [26d], cs
        push cs
        pop  es

        mov buf1, 0
        xadd dx, dx                     ; 486er - Code
        inc buf1
        db 0fh, 30h                     ; Pentium-Code
        inc buf1
      cpuCheckEnd:
        mov si, offset cpuStringTab+1
        movzx ax, buf1
        shl ax, 3
        add si, ax
        movzx cx, byte ptr [si-1]
        rep movsb
  ; Int 6 zurcksetzen :*)
        push 0
        pop  es
        mov eax, dword ptr vect6
        mov es:dword ptr [24d], eax
        push cs
        pop  es
        ret
        vect6 dd 0
    cpuStringTab:
        db 6,'i80386 '
        db 6,'i80486 '
        db 7,'Pentium'
checkCPU endp

checkFpu proc
  ; Int 7 auf eigene Proc verbiegen :*)
        push 0
        pop  es
        mov eax, es:dword ptr [28d]
        mov vect7, eax
        mov es:word ptr [28d], offset int7
        mov es:word ptr [30d], cs
        push cs
        pop  es

        mov al, '-'
        finit
        mov al, ''
      fpucheckEnd:
        stosb

  ; Int 7 zurcksetzen :*)
        push 0
        pop  es
        mov eax, dword ptr vect7
        mov es:dword ptr [28d], eax
        push cs
        pop  es
        ret
        vect7 dd 0
checkFpu endp

int6 proc
        mov al, 20h
        out 20h, al
        pop ax
        push offset cpucheckEnd
        iret
int6 endp

int7 proc
        mov al, 20h
        out 20h, al
        pop ax
        push offset fpucheckEnd
        iret
int7 endp

outWord proc
        mov cx, 4
      byteLoop:
        rol ax, 4
        mov bl, al
        and bl, 0fh
        add bl, '0'
        cmp bl, 58
        jb @donex
        add bl, 7
      @donex:
        mov es:[di], bl
        inc di
        loop byteLoop
        mov al, 'h'
        stosb
        ret
outWord endp


checkSystemBios proc
    push 0f000h
    pop  ds
    xor si, si
    mov di, offset bufferString+30

    mov cx, 50
    rep movsb
    push cs
    pop  ds
    ret
checkSystemBios endp

checkVgaBios proc
    push 0c000h
    pop  ds
    xor si, si
    mov di, offset bufferString+30

    mov cx, 50
    rep movsb
    push cs
    pop  ds
    ret
checkVgaBios endp

checkBiosCreation proc
    push 0ffffh
    pop ds
    mov si, 5

    mov cx, 8
    rep movsb

    push cs
    pop  ds
    ret
checkBiosCreation endp

checkVgaBiosLength proc
    push 0c000h
    pop ds
    movzx ax, ds:byte ptr [2]
    shl ax, 9
    push cs
    pop  ds
    call outWord
    ret
checkVgaBiosLength endp

biosCalltab:
  dw offset checkSystemBios
  dw offset checkBiosCreation
  dw offset checkVgaBios
  dw offset checkVgaBiosLength
  dw offset checkCpu
  dw offset checkFpu
  dw offset checkMem
  dw offset checkAvailableMem

biosNametab:
  db 16,'System-BIOS F000'
  db 16,'BIOS-Herstellung'
  db 13,'VGA-Bios C000'
  db 14,'Lnge in Bytes'
  db 07,'CPU-Typ'
  db 11,'Coprozessor'
  db 19,'Konventionelles RAM'
  db 19,'    davon Verfgbar'


modeString1      db 12,', Real Modus'
modeString2      db 19,', Geschtzter Modus'

biosTitle db 11,'Mainboard :'
