{$M 4096,0,0} {$G+}
program mem;

uses crt,dos;

type mcb   = record
           id      : char;
           segPSP  : word;
           len     : word;  { in paragraphen }
           res     : array[0..10] of byte;
           end;
     pMcb  = ^mcb;
     tPtr  = record
           ofs, seg : word;
           end;
     oInfo = record  { MCB -> eigenes Format }
           seg     : word;
           ofs     : word;
           len     : word;  { in kb }
           typ     : word;  { env / psp / data }
           owner   : string[12];
           end;
     tInfo = array[1..1000] of oInfo;
     pInfo = ^tInfo;
     byteT = array[0..10] of byte;
     byteC = ^byteT;

var mes1         : string;
    loVer, hiVer : byte;
    api          : boolean;

    hma          : boolean;
    xms          : boolean;
    ems          : boolean;
    umb          : boolean;
    mgr          : pointer;
    xmsVer       : word;
    xmsRev       : word;

    memDone      : boolean;
    dlgDone      : boolean;
    ch           : char;
    actMenu      : byte;
    gMcb         : pMcb;
    first        : pMcb;
    gInfo        : pInfo;

{ Prft, ob API-Funktionen verfgbar sind }
procedure testApi;
begin
     asm
        push  es
        mov   ax,ds
        mov   es,ax
        mov   di,offset mes1
        xor   bx,bx

        push  ds
        mov   ah,0
        int   032h

        or    bh, 0
        je    @nope  { nicht installiert }

        xor   ch,ch
        mov   cl,byte ptr ds:[si]
        rep   movsw

      @nope:
        pop   ds
        pop   es
        mov   loVer,bl
        mov   hiVer,bh
     end;

     IF hiVer = 0 THEN
      BEGIN
           gotoXY (0, whereY);
           ClrEol;
           writeln ('mem.exe bentigt das shell system api. Bitte starten Sie shell.exe');
           halt (1);
      END;
end;

procedure drwWindow (x1,y1,x2,y2, color, style : byte; titel : string); assembler;
asm
        push ds
        mov  ch,y1
        mov  cl,y2
        mov  dh,x1
        mov  dl,x2
        mov  bl,color
        mov  bh,style

        mov  ax,word (pointer(titel)+2)
        mov  ds,ax
        mov  si,word (pointer(titel))

        mov  ax,0100h
        int  032h
        pop  ds
end;

procedure closeWindow; assembler;
asm
    {push ds}
    mov  ah,2
    int  032h
    {pop ds}
end;

procedure drwButton (x1, y, x2, attr, style : byte; titel : string); assembler;
asm
        push ds

        mov  cl,y
        mov  dh,x1
        mov  dl,x2
        mov  bl,attr
        mov  bh,style

        mov  ax,word (pointer(titel)+2)
        mov  ds,ax
        mov  si,word (pointer(titel))

        mov  ah,5
        int  032h
        pop  ds
end;

{ Gibt Text ber Api aus }
procedure drwText (x,y,attr,style : byte; text : string); assembler;
asm
        push    ds
        push    bp
        mov     dh,x
        mov     dl,y
        mov     bl,attr
        mov     bh,style

        mov     ax,word (pointer(text)+2)
        mov     ds,ax
        mov     si,word (pointer(text))
        mov     ah,6
        int     32h
        pop     bp
        pop     ds
end;

procedure cursorOff; assembler;
asm
   mov ah,8
   int 32h
end;

procedure cursorOn; assembler;
asm
   mov ah,9
   xor cx,cx
   int 32h
end;

{ wandelt dezimal-word in hex-string um }
function hexOut ( wrd : word ) : string;
const hexCode : array[0..15] OF CHAR = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var  bt1, bt2 : byte;
     outStr   : string;
begin
     outStr[0] := #0;

     bt1 := wrd AND $00FF;  { low }
     bt2 := (wrd AND $FF00) SHR 8;  { high }

     outStr := hexCode[(bt2 AND $F0) SHR 4] + hexCode[bt2 AND $F];
     outStr := outStr + hexCode[(bt1 AND $F0) SHR 4] + hexCode[bt1 AND $F];

     hexOut := outStr;
end;

function spaceOut ( inStr : string; len : byte ) : string;
var  outStr : string;
     x      : byte;
begin
     outStr[0] := #0;

     IF byte (inStr[0]) > len THEN
      BEGIN
           outStr := copy (inStr, 1, len-1) + '+';
      END
     ELSE
      BEGIN
           fillChar ( outStr[1], 255, 32 );
           outStr[0] := char (len);

           FOR x := 1 TO byte (inStr[0]) DO
            outStr[len - byte (inStr[0]) +x ] := inStr[x];
      END;

     spaceOut := outStr;
end;

procedure menuDraw (nr, show : byte); {show: $71=on / $1E=off }
begin
     case nr of
     1: drwText (6,4, show, 0,  ' Kurzbersicht         ');
     2: drwText (6,5, show, 0,  ' Geladene Programme    ');
     3: drwText (6,6, show, 0,  ' XMS-Belegung          ');
     4: drwText (6,7, show, 0,  ' EMS-Belegung          ');
     5: drwText (6,9, show, 0,  ' Zurck...             ');
     end;
end;

procedure briefInfo;
var   konv_avail, hma_avail, umb_avail, xms_avail, ems_avail : word;
      konv_bi, hma_bi, umb_bi, xms_bi, ems_bi                : word;

      inst,free : string;
      tmp       : word;
begin
     konv_bi := 0; konv_avail := 0;

     { 1. Informationen einholen }
       { a) konventionell holen }
       asm
          mov   ah,48h
          mov   bx,0ffffh
          int   21h
          mov   konv_avail,bx
       end;

       { b) hma holen }
       IF hma THEN
        BEGIN
             hma_bi := 64; hma_avail := 64;

             asm
                mov     ah,1
                mov     dx,01h
                call    [mgr]
                or      al,0
                jne     @hmaOk
                cmp     bl,91h
                jne     @hmaDone
                mov     hma_avail,0
                jmp     @hmaDone
               @hmaOk:
                mov     ah,2
                call    [mgr]
               @hmaDone:
             end;
        END
       ELSE BEGIN hma_avail := 0; hma_bi := 0; END;

     { 2. Informationen darstellen }
     drwWindow (9, 5, 71, 17, $1f, 7, 'Kurzbersicht');
     drwText (11, 6, $1e, 0, 'Speichertyp                             inst.    frei  ');
     drwText (11, 7, $1e, 0, '');
     drwText (11, 8, $1e, 0, 'Konventioneller Speicher (0-640 kb)                     ');
     drwText (11, 9, $1e, 0, 'Oberer Speicher (640-1024 kb)                           ');
     drwText (11,10, $1e, 0, 'Hoher Speicher (1024-1088 kb)                           ');
     drwText (11,11, $1e, 0, '');
     drwText (11,12, $1e, 0, 'XMS-Speicher (1088-16384 kb)                            ');
     drwText (11,13, $1e, 0, 'EMS-Speicher (1088-16384 kb)                            ');
     drwText (11,14, $1e, 0, '');
     drwText (11,15, $1e, 0, 'Gesamter freier DOS-Speicher                            ');

     textColor (10); textBackground (1);

     str (konv_bi, inst); str ( konv_avail shr 6, free);
      gotoxy (51,9);
      write (inst+' kb':8);
      gotoxy (61,9);
      IF konv_avail <> 0 THEN write (free+' kb':9) ELSE write ('   --');

     str (hma_bi, inst); str ( hma_avail, free);
      gotoxy (51,11);
      IF hma_bi <> 0 THEN write (inst+' kb':8) ELSE write ('   --');
      gotoxy (61,11);
      IF hma_avail <> 0 THEN write (free+' kb':9) ELSE write ('   --');

     { 3. EventAbfrage }
     dlgDone := false;
     REPEAT
           IF keyPressed THEN
            BEGIN
                 ch := readkey;
                 dlgDone := true;
            END;

     UNTIL dlgDone;

     closeWindow;
end;

procedure programs;
var  doneInfo : boolean;
     maxEntry : word;
     actEntry : word;
     posY     : byte;
     info     : pInfo;

  procedure drawEntry (no : word; pos, mode : byte);
  const typeDef : array[0..2] of string[14] = ('       data','    program','environment');
  var  nrStr  : string;
       outSt  : string;
       lenStr : string;
  begin
       outSt := ' ';

       str (no, nrStr);
       IF nrStr[0]=#1 THEN nrStr := '  '+nrStr;
       IF nrStr[0]=#2 THEN nrStr := ' '+nrStr;
       str (gInfo^[no].len * 16, lenStr);

       outSt := ' ' + nrStr + '  ' + hexOut (gInfo^[no].seg) + ':' +
        hexOut (gInfo^[no].ofs) + '  ' + spaceOut (lenStr, 10) + '  ' +
        typeDef[gInfo^[no].typ] + '  ' + gInfo^[no].owner + ' ';

       drwText (10, 6+pos, mode, 0, outSt);
  end;

  procedure showPage (first : word; act : word);
  var  x  : byte;
       go : byte;
  begin
       IF (first > maxEntry - 12) AND (maxEntry>12) THEN first := maxEntry - 12;

       go := first +12; IF maxEntry<12 THEN BEGIN go := maxEntry; first := 1; END;

       FOR x := first TO go DO
        IF x = act THEN drawEntry (x, x-first+1, $71)
        ELSE drawEntry (x, x-first+1, $1e);
  end;

  procedure readInformation;
  var  error : boolean;
       x     : byte;
       typ   : byte;
       owner : string[12];

   procedure checkEnv;
   var  get : byteC;
        x   : byte;
   begin
        typ := 2; {env}

        tPtr(get).seg := tPtr (gMcb).seg +1;
        tPtr(get).ofs := tPtr (gMcb).ofs;

        IF get^[0] <> byte('C') THEN typ := 0;
        IF get^[1] <> byte('O') THEN typ := 0;
        IF get^[2] <> byte('M') THEN typ := 0;
        IF get^[3] <> byte('S') THEN typ := 0;
        IF get^[4] <> byte('P') THEN typ := 0;
        IF get^[5] <> byte('E') THEN typ := 0;
        IF get^[6] <> byte('C') THEN typ := 0;
   end;

   procedure checkProg;
   var  get : byteC;
   begin
        tPtr(get).seg := tPtr (gMcb).seg +1;
        tPtr(get).ofs := tPtr (gMcb).ofs;

        IF (get^[0] = $cd) AND (get^[1] = $20) THEN typ := 1; {prog}
   end;

   procedure checkOwner;
   var  x  : byte;
        sc : byte;
   begin
        sc := 0;

        FOR x:=1 TO 8 DO
         BEGIN
              IF (gMcb^.res[2+x] > 32) AND (gMcb^.res[2+x] < 91) THEN owner[x -sc] := char (gMcb^.res[2+x])
              ELSE INC (sc);
         END;
   end;

  begin
       { DOS - int21h ah=52h -> liefert infoBlock in es:bx zurck }
       asm
          mov ah,52h
          int 21h

          mov ax,es
          dec ax
          mov es,ax
          add bx,12

          mov word ptr gMcb,0
          mov ax, word ptr es:[bx+2]
          mov word ptr gMcb+2,ax
       end;

       first := gMcb;  error := false;  maxEntry := 0;
       repeat
             inc (maxEntry);
             tPtr (gMcb).seg := tPtr (gMcb).seg + gMcb^.len +1; {+ mcb selbst }
       until (gMcb^.ID = 'Z') OR (error); { ende }

       { Speicher reservieren }
       asm
           mov ax,maxEntry
           mov bx,21
           mul bx
           mov bx,ax
           shr bx,4       { In Paragraphen umwandeln }
           inc bx         { immer einer mehr! }

           mov ah,48h
           int 21h       { ...und Speicher reservieren }
           mov word ptr gInfo,0
           mov word ptr gInfo+2,ax
       end;

       error := false;  gMcb := first; { anschlieend Speicher beschreiben }
       FOR x := 1 TO maxEntry+1 DO
        begin
             gInfo^[x].len := gMcb^.len;
             gInfo^[x].seg := tPtr (gMcb).seg +1;
             gInfo^[x].ofs := tPtr (gMcb).ofs;

             checkEnv; { Speichertyp ermitteln }
             IF typ = 0 THEN checkProg;
             gInfo^[x].typ := typ;

             fillchar (owner,9,32); owner[0] := #8;
             IF typ <> 0 THEN checkOwner;
             IF owner = '        ' THEN owner := '   --   ';
             gInfo^[x].owner := owner;

             tPtr (gMcb).seg := tPtr (gMcb).seg + gMcb^.len +1; {+ mcb selbst }
        end;
  end;

begin
     { 1. Fenster darstellen}
     drwWindow (9, 6, 67, 21, $1f, 7, 'geladene Programme');

     { 2. Informationen holen und in Fenster ausgeben }
     readInformation;   actEntry := 1; posY := 1;
     inc (maxEntry,2);
     showPage (1, 1);

     { 3. Ereignisloop }
     dlgDone := false;
     REPEAT
           IF keyPressed THEN
            BEGIN
                 ch := readkey;

                 CASE ch OF
                 #27: dlgDone := true;
                 #80: {unten}
                  BEGIN
                       IF (maxEntry < 14) OR (posY <> 13) THEN
                        BEGIN
                             drawEntry (actEntry, posY, $1e);
                             INC (actEntry);
                             IF posY < 13 THEN INC (posY);
                             IF (actEntry = maxEntry+1) THEN BEGIN actEntry :=1; posY := 1; END;
                             drawEntry (actEntry, posY, $71);
                        END
                       ELSE IF (maxEntry > 13) AND (posY = 13) THEN
                        BEGIN
                             INC (actEntry);
                             IF actEntry = maxEntry +1 THEN
                              BEGIN
                                   actEntry :=1; posY :=1;
                                   showPage (1,1);
                              END
                             ELSE
                              showPage (actEntry-12, actEntry);
                        END;
                  END;
                 #72: {oben}
                  BEGIN
                       IF (maxEntry < 14) OR (posY <> 1) THEN
                        BEGIN
                             drawEntry (actEntry, posY, $1e);
                             DEC (actEntry);
                             IF posY > 1 THEN DEC (posY);
                             IF (actEntry = 0) THEN BEGIN actEntry := maxEntry; posY := maxEntry END;
                             drawEntry (actEntry, posY, $71);
                        END
                       ELSE IF (maxEntry > 13) AND (posY = 1) THEN
                        BEGIN
                             DEC (actEntry);
                             IF actEntry = 0 THEN
                              BEGIN
                                   posY := 13; actEntry := maxEntry;
                                   showPage (actEntry-12, actEntry);
                              END
                             ELSE
                              showPage (actEntry, actEntry);
                        END;
                  END;
                 END;
            END;

     UNTIL dlgDone;

     { 4. Ende -> Fenster lschen}

     asm
           push es
           mov  ax,word ptr gInfo+2
           mov  es,ax
           mov  ah,49h
           int  21h       { ...und Speicher freigeben }
           pop  es
     end;

     closeWindow;
end;

begin
     testApi; { bricht ab, wenn kein API instaliert }

     { HMA/XMS/EMS/realRam Vorhandensein prfen }
     hma := false; xms := false; ems := false; umb := false;
     asm
        mov     ax,4300h        { Inst.-Check xms-mgr }
        int     2fh
        cmp     al,80h
        jne     @noXMS
        mov     hma,1           { hma := true }

        push    es
        mov     ax,4310h        { pointer holen fr far-calls }
        int     2fh
        mov     word ptr mgr,bx
        mov     ax,es
        mov     word ptr mgr+2,ax
        pop     es

        mov     ah,0
        call    [mgr]
        mov     xmsVer,ax
        mov     xmsRev,bx
        mov     hma,dl
      @noXMS:
     end;

     { 1. Men aufbauen }
     drwWindow (5, 3, 30, 11, $1f, 7, 'memory.info');
     drwText (6,4, $71, 0,  ' Kurzbersicht         ');
     drwText (6,5, $1e, 0,  ' Geladene Programme    ');
     drwText (6,6, $1e, 0,  ' XMS-Belegung          ');
     drwText (6,7, $1e, 0,  ' EMS-Belegung          ');
     drwText (6,8, $1f, 0, '  ');
     drwText (6,9, $1e, 0, ' Zurck...             ');

     { 2. Variablen Init }
     memDone := false; actMenu := 1;

     { 3. Event-Handler }
     REPEAT
           IF keyPressed THEN { Tastenereignisse }
            BEGIN
                 ch := readkey;

                 case ch of
                 #27: memDone := true;
                 #80: {unten}
                  BEGIN
                       menuDraw (actMenu, $1e);
                       INC (actMenu);
                       IF actMenu = 6 THEN actMenu := 1;
                       menuDraw (actMenu, $71);
                  END;
                 #72: {oben}
                  BEGIN
                       menuDraw (actMenu, $1e);
                       DEC (actMenu);
                       IF actMenu = 0 THEN actMenu := 5;
                       menuDraw (actMenu, $71);
                  END;
                 #13:
                  BEGIN
                       IF actMenu = 1 THEN briefInfo;
                       IF actMenu = 2 THEN programs;
                       IF actMenu = 5 THEN memDone := true;
                  END;
                 {ELSE write (byte (ch),' ');}
                 end;
            END;

     UNTIL memDone;

     { 4. Menu schlieen }
     closeWindow;
end.
 
