
portItems equ 8

portAdr   dw  0
xbyte2    db  0
xbyte3    db  0

jmp_table   dw  offset uart_8250_or_16450
            dw  offset uart_unknown
            dw  offset uart_16550
            dw  offset uart_16550a

portInfo proc
        push cs
        pop  ds
        push cs
        pop  es
        mov startPos, 0
        mov scrollPos, 0

        mov cx, 0317h
        mov dx, 064ch
        mov bl, colour1
        mov bh, 7
        mov si, offset portsTitle
        mov ah, 1
        int 32h

      PortKeyLoop:

  ; SI gem startPos auf die Stringtabelle zeigen lassen

        mov si, offset PortNametab
        movzx cx, startPos
        or cx, cx
        jz doneLoop5
      loop5:
        movzx ax, byte ptr [si]
        inc ax
        add si, ax
        loop loop5
      doneLoop5:

  ; BP gem startPos auf die CALL-Tabelle zeigen lassen

        movzx bp, startpos
        shl bp, 1
        add bp, offset PortCalltab

  ; Jetzt den kompletten Bildschirm aufbauen

        xor cx, cx
        mov dx, 0807h

      PortScreenLoop:

  ; Den Puffer lschen
        pusha
        mov byte ptr offset bufferString, 67
        mov al, 32
        mov cx, 80
        mov di, offset bufferString+1
        rep stosb
        popa

  ; Den Programmnamen in Puffer kopieren

        push cx
        movzx cx, byte ptr [si]
        inc si
        mov di, offset bufferString+2
        rep movsb
        pop cx

  ; Die Funktion zum Check aufrufen

        pusha
        mov di, offset bufferString+1+30
        call word ptr [bp]
        popa

  ; Den ganzen Puffer als String ausgeben. Leuchtbalken bercksichtigen.

        push si
        mov ah, 6
        movzx bx, colour1
        cmp cl, scrollPos
        jne $+5
        rol bl, 4
        mov si, offset bufferString
        int 32h
        pop si

        add bp, 2
        inc dl
        inc cl
        cmp cl, PortItems
        jb PortScreenloop

        xor ah, ah
        int 16h

        cmp al, 27
        je PortEsc
        mov items, PortItems
        call checkKeys
        jmp PortKeyLoop

      PortEsc:

        mov ah, 2
        int 32h
        ret
PortInfo endp

checkLpt1 proc
        push 40h
        pop  ds
        mov  ax, ds:[8]
        or ax, ax
        jz noLpt1
        call outWord
        jmp doneLpt1
      noLpt1:
        mov al, '-'
        stosb
      doneLpt1:
        push cs
        pop  ds
        ret
checkLpt1 endp

checkLpt2 proc
        push 40h
        pop  ds
        mov  ax, ds:[10]
        or ax, ax
        jz noLpt2
        call outWord
        jmp doneLpt2
      noLpt2:
        mov al, '-'
        stosb
      doneLpt2:
        push cs
        pop  ds
        ret
checkLpt2 endp

checkLpt3 proc
        push 40h
        pop  ds
        mov  ax, ds:[12]
        or ax, ax
        jz noLpt3
        call outWord
        jmp doneLpt3
      noLpt3:
        mov al, '-'
        stosb
      doneLpt3:
        push cs
        pop  ds
        ret
checkLpt3 endp

checkLpt4 proc
        push 40h
        pop  ds
        mov  ax, ds:[14]
        or ax, ax
        jz noLpt4
        call outWord
        jmp doneLpt4
      noLpt4:
        mov al, '-'
        stosb
      doneLpt4:
        push cs
        pop  ds
        ret
checkLpt4 endp

checkCom1 proc
        push 40h
        pop  ds
        mov ax, ds:word ptr [0]
        push cs
        pop  ds
        mov  portAdr, ax
        pusha
        or ax, ax
        jz noCom1
        call outWord
        add di, 10
        call checkUart
        jmp doneCom1
      noCom1:
        mov al, '-'
        stosb
      doneCom1:
        popa
        ret
checkCom1 endp

checkCom2 proc
        push 40h
        pop  ds
        mov ax, ds:word ptr [2]
        push cs
        pop  ds
        mov  portAdr, ax
        pusha
        or ax, ax
        jz noCom2
        call outWord
        add di, 10
        call checkUart
        jmp doneCom2
      noCom2:
        mov al, '-'
        stosb
      doneCom2:
        popa
        ret
checkCom2 endp

checkCom3 proc
        push 40h
        pop  ds
        mov ax, ds:word ptr [4]
        push cs
        pop  ds
        mov  portAdr, ax
        pusha
        or ax, ax
        jz noCom3
        call outWord
        add di, 10
        call checkUart
        jmp doneCom3
      noCom3:
        mov al, '-'
        stosb
      doneCom3:
        popa
        ret
checkCom3 endp

checkCom4 proc
        push 40h
        pop  ds
        mov ax, ds:word ptr [6]
        push cs
        pop  ds
        mov  portAdr, ax
        pusha
        or ax, ax
        jz noCom4
        call outWord
        add di, 10
        call checkUart
        jmp doneCom4
      noCom4:
        mov al, '-'
        stosb
      doneCom4:
        popa
        ret
checkCom4 endp








checkUart proc
        mov dx, portAdr
        add  dx, 2                      ; dx := dx + 2
        in   al, dx                     ; al := port [dx]

        mov xbyte2, al                  ; xbyte2 := al
        mov al, 0c1h                    ; al := $C1
        out dx, al                      ; port [dx] := al
        in  al, dx                      ; al := port [dx]
        and al, 0c0h                    ; al := (al AND $C0)
        mov cl, 5                       ; cl := 5
        shr al, cl                      ; al := (al shr 5) (5 for word jmp)
        xor ah,ah                       ; ah := 0     v1.1
        mov bp, ax                      ; bp := ax (al)
        mov al, xbyte2                  ; al := xbyte2
        out dx, al                      ; port [dx] := al
        jmp CS:[jmp_table+bp]           ;       v1.1

      uart_8250_or_16450:
        mov dx, portAdr                 ; dx := xword
        add dx, 7                       ; dx := dx + 7
        in  al, dx                      ; al := port [dx]
        mov xbyte2, al                  ; xbyte2 := al
        mov al, 0fah                    ; al := $FA
        out dx, al                      ; port [dx] := al
        in  al, dx                      ; al := port [dx]
        cmp al, 0fah                    ; if (al <> $FA)
        jne uart_16450                  ; then uart is 16450
        mov al, 0afh                    ; al := $AF
        out dx, al                      ; port [dx] := al
        in  al, dx                      ; al := port [dx]
        cmp al, 0afh                    ; if (al <> $AF)
        jne uart_8250                   ; then uart is 8250
        mov al, xbyte2                  ; else al := xbyte2
        out dx, al                      ; port [dx] := al
        jmp short uart_16450            ; uart is 16450

      uart_8250:
        call  uartExit
        db  4,'8250'                    ; display "8250"

      uart_16450:
        call  uartExit
        db  5,'16450'                   ; display "16450"

      uart_unknown:
        call  uartExit
        db  9,'unbekannt'               ; display "unknown"

      uart_16550:
        call  uartExit
        db  5,'16550'                   ; display "16550"

      uart_16550a:
        call  uartExit
        db  6,'16550A'                  ; display "16550A"

      uartExit:
        mov si, offset uartString1+1
        movzx cx, byte ptr [si-1]
        rep movsb
        pop si                          ; msg address      v1.1
        inc di
        movzx cx, byte ptr [si]
        inc si
        rep movsb
        ret
checkUart endp

portCalltab:
  dw offset checkCom1
  dw offset checkCom2
  dw offset checkCom3
  dw offset checkCom4
  dw offset doNothing
  dw offset checkLpt1
  dw offset checkLpt2
  dw offset checkLpt3
  dw offset checkLpt4

portNameTab:
  db 17,'Serieller Port 1:'
  db 17,'Serieller Port 2:'
  db 17,'Serieller Port 3:'
  db 17,'Serieller Port 4:'
  db  1,' '
  db 18,'Paralleler Port 1:'
  db 18,'Paralleler Port 2:'
  db 18,'Paralleler Port 3:'
  db 18,'Paralleler Port 4:'


uartString1 db 10,'Uart-Chip:'

portsTitle db 017,'Verfgbare Ports:'
