code segment use16
assume cs:code, ds:code
org 100h
.386c
entry: jmp begin

; new handler for providing functions of interrupt 16h trough interrupt 32h
; coded 1996 by iCode
; all rights reserved

; Benutzung :
;
;     InstallFastKey installiert die Routine.
;
;     CloseFastkey deinstalliert die Routine.
;
;     Interrupt32-Funktion XY liefert in al den Scan-Code zurck. 0 == Nothing.


Char       db  65h    ; hlt Scancode des Keys
numChar    db  0      ; Hufigkeit des Drckens ( erster Druck = 1 )


accTable   dw  0, 100, 20, 10, 3, 3, 3, 3
           ; Beschleunigungsgeschwindigkeiten fr Tastatureingabe

; initialisiert int9-Handler -> Einhngen
InstallFastKey proc
        push 0
        pop es
        mov eax, es:dword ptr [9*4]
        mov dword ptr OldInt9, eax
        mov ax, cs
        shl eax,16                      ; ins hi-word shiften
        mov ax, offset cs:int9          ; offset ins lo-word
        mov dword ptr es:[9*4], eax     ; und in realmode-idt schreiben
        ret
InstallFastKey endp

; deinitialisiert int9-Handler
CloseFastKey proc
        mov eax, dword ptr cs:OldInt9
        push 0
        pop es
        mov es:dword ptr [9*4], eax
        ret
CloseFastKey endp

; bergibt scancode in al an Aufrufer ( 0 = keine Taste )
readKey proc
        mov  al, cs:char
        jnz  @pausing
        ret

      @pausing:
        push ds
        push si
        push cx
        push ax

        mov  ax, 0b800h
        mov  es, ax
        mov  di, 4
        mov  al, cs:numChar
        stosb

        mov  si, offset accTable
        mov  cl, cs:numChar
        shl  cl, 1
        xor  ch, ch
        add  si, cx
        mov  cx, word ptr cs:[si]

        call clearKeyBuf

        pop  ax
        pop  cx
        pop  si
        pop  ds
        ret
readKey endp

clearKeyBuf proc
        cli
        push  40h
        pop   es

        mov   ax, word ptr es:[1ch]
        mov   word ptr es:[1ah], ax
        sti

        ret
clearKeyBuf endp

hexTabS db  '0123456789ABCDEF'
lineC   dw  0

showKey proc
        pusha

        push    ax
        push    cs
        pop     ds
        mov     ax, 0b800h
        mov     es, ax
        mov     di, lineC
        add     lineC, 160
        pop     ax

        push    ax
        xor     ah, ah
        shr     al, 4
        mov     si, offset hexTabS
        add     si, ax
        movsb
        pop     ax

        push    ax
        xor     ah, ah
        and     al, 0fh
        mov     si, offset hexTabS
        add     si,ax
        inc     di
        movsb
        pop     ax

        popa
        ret
showKey endp

; interrupt 9 - Handler
int9    proc
        cli
        push ax
        in   al, 60h          ; Zeichen von Port lesen

        call showKey

        cmp  al, 080h
        jb   PushedDown
        mov  cs:char, 0
        mov  cs:numChar, 0    ; acceleration reset ( to 0 )
        jmp  GoOn
      pushedDown:

        mov  cs:char, al
        cmp  cs:numChar, 5    ; beschleunigungsgrenze -> danach fullspeed
        ja   goOn
        inc  cs:numChar

      goOn:
        pop  ax
        ; db   09ah
        db 0eah
        oldint9 dd 0h
int9    endp

begin:

call installFastKey

@again:
  call readkey
  cmp  al,1
  jne  @again


call closeFastKey
mov ah,4ch
int 21h

code ends
end entry



