.386c

; new handler for providing functions of interrupt 16h trough interrupt 32h
; coded 1996 by iCode
; all rights reserved

; Benutzung :
;
;   - InstallFastKey installiert die Routine.
;
;   - CloseFastkey deinstalliert die Routine.
;
;   - readkey (Interrupt32) - Funktion XY liefert in al den Scan-Code zurck.
;            0 = keine Taste gedrckt


Char       db  65h    ; hlt Scancode des Keys
numChar    db  0      ; Hufigkeit des Drckens ( erster Druck = 1 )
flags      dw  0      ; enthlt bits fr strg/alt/win95-Taste etc.
          ; 1 = alt    2 = left-strg    4 = right-strg    8 = altGr
          ; 16 = left-shift   32 = right-shift   64 = links-win95
          ; 128 = rechts-win95    256 = win95-Task   512 = numLock
          ; 1024 = capsLock   2048 = scrollLock

maxAcc     equ 12
accTable   dw  50, 47, 43, 39, 35, 31, 27, 24, 21, 19, 16, 13, 11, 5, 100
           ; Beschleunigungsgeschwindigkeiten fr Tastatureingabe

; initialisiert int9-Handler -> Einhngen
InstallFastKey proc
        push 0
        pop es
        mov eax, es:dword ptr [9*4]
        mov dword ptr OldInt9, eax
        mov ax, cs
        shl eax,16                      ; ins hi-word shiften
        mov ax, offset cs:int9          ; offset ins lo-word
        mov dword ptr es:[9*4], eax     ; und in realmode-idt schreiben
        ret
InstallFastKey endp

; deinitialisiert int9-Handler
CloseFastKey proc
        mov eax, dword ptr cs:OldInt9
        push 0
        pop es
        mov es:dword ptr [9*4], eax
        ret
CloseFastKey endp

; bergibt scancode in al an Aufrufer ( 0 = keine Taste )
; in: ah = func. nr shell-system / 18
;     al = unterfct.nr.  1 = selbststndig beschleunigen / bremsen
;                        2 = Verzgerungszeit in cx liefern
readKey proc
        cmp  al, 1       ; zwei Abfragemodi
        je   @accelMode

        mov  al, cs:char ; aktueller Buffer-Char in al
        or   al, 0       ; wenn <> 0 dann Pausenlnge zurckliefern
        jnz  @pausingNoA
        mov  cx, 0       ; keine Taste, keine Bremsung ntig
        ret

      @pausingNoA:
        push ax
        push si

        mov  si, offset accTable
        mov  cl, cs:numChar
        shl  cl, 1
        xor  ch, ch
        add  si, cx
        mov  cx, word ptr cs:[si]

        pop  si
        pop  ax
        ret

      @accelMode:
        mov  al, cs:char
        or   al, 0
        jnz  @pausing
        ret

      @pausing:
        push ds
        push si
        push cx
        push ax

        mov  si, offset accTable
        mov  cl, cs:numChar
        shl  cl, 1
        xor  ch, ch
        add  si, cx
        mov  cx, word ptr cs:[si]
        call pause

        pop  ax
        pop  cx
        pop  si
        pop  ds
        ret
readKey endp

clearKeyBuf proc
        cli
        push  40h
        pop   es

        mov   ax, word ptr es:[1ch]
        mov   word ptr es:[1ah], ax
        sti
        ret
clearKeyBuf endp

resetCharacter proc
        cli
        mov cs:char, 0
        sti
        ret
resetCharacter endp

; interrupt 9 - Handler
int9    proc
        push ax
        push es
        push 40h
        pop  es
        mov  ax, word ptr es:[1ch]  ; KeyBoard - Buffer lschen
        mov  word ptr es:[1ah], ax
        pop  es
        in   al, 60h          ; Zeichen von Port lesen

        cmp  al, 080h
        jb   pushedDown
        cmp  al, 0e0h         ; spezielles Zeichen bei einigen Sondertasten?!
        je   goOn             ; deswegen weitere Abfrage

        ; bestimmte Kombinationstasten prfen
        cmp  al, 0B8h
        jne  @goN1
        and  word ptr flags, 65535-1
        jmp  goOn
      @goN1:
        cmp  al, 09dh
        jne  @goN2
        and  word ptr flags, 65535-2
        jmp  goOn
      @goN2:

        mov  cs:char, 0       ; wenn break - code, dann auf 0 setzen
        mov  cs:numChar, 0    ; acceleration reset ( to 0 presses )
        jmp  goOn
      pushedDown:

        ; bestimmte Kombinationstasten prfen
        cmp  al, 38h
        jne  @goR1
        or   word ptr flags, 1
        jmp  goOn
      @goR1:
        cmp  al, 1dh
        jne  @goR2
        or   word ptr flags, 2
        jmp  goOn
      @goR2:

        cmp  cs:char, al      ; Vergleich vorangegange -> aktuelle Taste
        je   @incNumChar      ; wenn selbe Taste wie Vorgnger, dann accel++
        mov  cs:numChar, 1    ; accel reset ( 0 presses )
        mov  cs:char, al
        jmp  goOn

       @incNumChar:             ; bei selber Taste -> acceleration
        cmp  cs:numChar, maxAcc ; beschleunigungsgrenze -> danach nur noch fullspeed
        ja   goOn
        inc  cs:numChar

      goOn:

;        push dx
;        mov dx, 20h
;        mov al, 20h
;        out dx, al
;        pop dx
        pop ax
;        iret

        ; db   09ah
        db 0eah
        oldint9 dd 0h
int9    endp

