
.386c


;ͻ
;                                                                             
;                 INPUT.INC   API-Funktion fr Shell-System             
;                                                                             
;                           beinhaltet Eingabezeile                           
;                                                                             
;                          Code : 1996 iCode [Falcon]                         
;                                                                             
;ͼ

;   InitInputLine
;   -------------
;     Eingabe:
;       BL    :   Lnge der Eingabezeile auf dem Bildschirm
;       BH    :   Farbe der Eingabezeile auf dem Bildschirm
;       CL    :   maximale Stringlnge im Puffer
;       CH    :   Fllzeichen (zum berschreiben von gelschten Zeichen)
;       DL    :   Y-Position / Reihe auf dem Bildschirm
;       DH    :   X-Position / Spalte auf dem Bildschirm
;       DS:SI :   Pointer auf den String-Puffer
;    Ausgabe:
;       AX    :   Handle  ( Segment der Variablen-Tabelle )
;
;   InsertCharacter
;   ----------
;     Eingabe:
;       AL    :   80h = Steuerzeichen nicht auswerten
;       BX    :   Handle
;       CL    :   ASCII-Code (bei == 0 liegt Bedeutung bei Scan-Code)
;       CH    :   Scancode
;
;
;  updateInputLine
;  ---------------
;    Eingabe:
;       AL    :   Neuer Farbwert    ( 0FFh=alten beibehalten )
;       BX    :   Handle
;       CL    :   Neue X-Koordinate ( 0FFh=alte beibehalten )
;       CH    :   Neue Lnge der Eingabezeile auf dem Bildschirm (0ffh=alte)
;
;  CloseInputLine
;  --------------
;    Eingabe:
;       BX    :   Handle












; Format des Datenblockes, der in dem Handle-Segment abgelegt wird :

;       Offset      :       Lnge       :       Bedeutung
;
;            0               Word               Offset des String-Puffers
;            2               Word               Segment des String-Puffers
;            4               Byte               Puffergre
;            5               Byte               Startposition
;            6               Byte               Cursorposition
;            7               Byte               Bildschirmlnge der Zeile
;            8               Byte               Fllzeichen
;            9               Byte               Y-Position Bildschirm
;           10               Byte               X-Position Bildschirm
;           11               Byte               Farbe fr Eingabezeile

bufferOfs  equ 0
bufferSeg  equ 2
bufferSize equ 4
startPos   equ 5
cursorPos  equ 6
screenLength equ 7
fillByte   equ 8
y          equ 9
x          equ 10
colour     equ 11




inputHandle  dw 0h







; Anmerkungen: Nahezu whrend der gesamten Laufzeit der folgenden Routinen
; zeigt ES:0000 auf das Segment mit der Tabelle und DS:SI auf den String-
; puffer im Codesegment des aufrufenden Programmes.














; Die folgende Prozedur scrollt ein Wort nach rechts. Sie wird aufgerufen, falls
; der Benutzer Ctrl-Rechts drckt.

scrollWordRight proc

    ; Schauen, ob Scrolling nach rechts mglich ist

        mov al, es:[cursorPos]
        add al, es:[startPos]
        cmp al, [si]
        jb $+3
        ret

    ; Rechts ist also Platz. Jetzt nchstes Wort suchen.

        movzx cx, [si]
        or    cl, cl
        jz    scrollWordRightDone
        movzx ax, es:[cursorPos]
        add   al, es:[startPos]
        push  si
        add   si, ax
        inc   si
    @_searchLoop3:
        cmp byte ptr [si], ' '
        jbe  foundRightNextSpace
        inc si
        mov bp, si
        pop si
        call scrollRight
        push si
        mov si, bp
        loop @_searchLoop3
      foundRightNextSpace:
        or cl, cl
        jz foundRightNextWord
    @_searchLoop4:
        cmp byte ptr [si], ' '
        ja foundRightNextWord
        inc si
        mov bp, si
        pop si
        call scrollRight
        push si
        mov si, bp
        loop @_searchLoop4
      foundRightNextWord:
        pop si

      scrollWordRightDone:

        ret
scrollWordRight endp





















; Die folgende Prozedur scrollt ein Wort nach links. Sie wird aufgerufen, falls
; der Benutzer Ctrl-Left drckt.

scrollWordLeft proc

    ; Schauen, ob scrolling nach links mglich ist

        movzx cx, byte ptr es:[startPos]
        add   cl, es:[cursorPos]
        or    cl, cl
        jz    scrollWordLeftDone

    ; Ja, es ist mglich. Jetzt den Wortanfang suchen.

        push si
        add  si, cx
        dec  cx
        call scrollLeft
    @_searchLoop1:
        cmp byte ptr [si], ' '
        ja  foundLeftNextWord
        dec si
        call scrollLeft
        loop @_searchLoop1
      foundLeftnextWord:
        or cl, cl
        jz foundLeftNextSpace
    @_searchLoop2:
        cmp byte ptr [si-1], ' '
        jbe foundLeftNextSpace
        dec si
        call scrollLeft
        loop @_searchLoop2
      foundLeftNextSpace:
        pop si

    scrollWordLeftDone:

        ret
scrollWordLeft endp















; Die folgende Prozedur wird aufgerufen, falls der Benutzer die Backspace-Taste
; benutzt. Sie lscht das Zeichen, welches sich links von (startpos+scrollpos)
; befindet.

backSpace proc

    ; Testen, ob sich der Cursor eventuell ganz links befindet

        mov al, es:[startPos]
        add al, es:[cursorPos]
        jnz posUnequalZero
        ret
    posUnequalZero:

  ; Testen, ob gescrollt werden kann

        cmp byte ptr es:[startPos], 0
        jne leftScrollingPossible

        dec byte ptr es:[cursorPos]
        jmp goDelete

    leftScrollingPossible:

        dec byte ptr es:[startPos]

    goDelete:

        call eraseCharacter
        ret
backSpace endp















; Die folgende Prozedur gibt die eingabezeile neu auf dem Bildschirm aus. Sie
; ist dann von Nutzen, wenn der Bildschirm neu aufgebaut werden mu. Zustz-
; lich gestattet sie es dem aufrufenden Programm, die Farbe der Eingabezeile
; zu ndern. Dazu mu dieses Programm den Farbwert in "AL" ablegen. Enthlt AL
; den Wert 0, so wird der gespeicherte Farbwert genutzt.


updateInputline proc
        pusha
        push es
        mov  es, bx
        push word ptr es:[bufferSeg]
        pop  ds
        mov  si, es:[bufferOfs]

    ; Den neuen Farbwert sichern, falls erwnscht

        cmp al, 0ffh
        je noNewColour
        mov es:[colour], al
    noNewColour:
        cmp cl, 0ffh
        je noNewX
        mov es:[x], cl
    noNewX:
        cmp ch, 0ffh
        je noNewScreenLength
        mov es:[screenLength], ch
    noNewScreenLength:

    ; jetzt den Bildschirm neu aufbauen
;;;int 3
        call redrawAll
        pop es
        popa
        ret
updateInputline endp


















; Die folgende Prozedur fgt ein Zeichen in den String ein. Sie wird aufgerufen,
; wenn das aufrufende Programm einen ASCII- oder Scan-Code sendet.




















; Die folgende Prozedur verschiebt den Cursor nach rechts. Gegebenenfalls
; wird gescrollt.

scrollLeft proc

    ; Erstmal schauen, ob links noch Platz ist

        mov al, es:[startPos]
        add al, es:[cursorPos]
        jnz linksIstPlatz
        ret

    linksIstPlatz:

    ; Jetzt schauen, ob gescrollt werden mu oder nicht

        cmp es:byte ptr [cursorPos], 0
        je NeedLeftScrolling

        dec es:byte ptr [cursorPos]
        ret

    NeedLeftScrolling:

        dec es:byte ptr [startPos]
        ret
scrollLeft endp






















eraseCharacter proc

    ; Schauen, ob rechts vom Cursor noch Zeichen sind

        mov  al, [si]
        sub  al, es:[startPos]
        sub  al, es:[cursorPos]
        jnz  nochZeichenDa
        ret

    nochZeichenDa:

  ; Es kann also ein Buchstabe gelscht werden, Jetzt die Stringlnge dekre-
  ; mentieren.

        dec byte ptr [si]

  ; Jetzt alle Buchstaben nach dem zu lschenden Zeichen um eines nach vorne
  ; rcken und anschlieend ein Byte (das Fllbyte) schreiben
        push si
        movzx cx, [si]
        movzx ax, es:[startPos]
        add   al, es:[cursorPos]
        add   si, ax
        add   si, 2
        sub   cx, ax
        push  es
        push  ds
        pop   es
        mov   di, si
        dec   di
        or    cl, cl
        jz noCharsToMove
        rep   movsb
      noCharsToMove:
        pop   es
        pop   si
        mov   al, es:[fillByte]
        mov   [di], al
        ret
eraseCharacter endp



















; Die folgende Prozedur initialisiert die Input-Line. Sie allokiert Speicher,
; und sich die vom aufrufenden Programm bergebenen Variablen.

initInputLine proc
        push es
        pusha

    ; 16 Bytes Speicher fr das Handle allokieren
        pusha
        mov ah, 48h
        mov bx, 1
        int 21h
        mov es, ax
        popa

    ;  Die Werte kopieren

        mov es:[bufferOfs], si
        mov es:[bufferSeg], ds
        mov es:[bufferSize], cl
        mov es:word ptr [startPos], 0
        mov es:[screenLength], bl
        mov es:[fillByte], ch
        mov es:word ptr [y], dx
        mov es:[colour], bh

    ; Jetzt die Eingabezeile das allererste Mal aufbauen

        call redrawAll

        popa
        mov ax, es
        pop es
        ret
initInputLine endp














; Die folgende Prozedur wird vom Programm aufgerufen, sobald entweder ein Zeichen
; eingefgt werden soll, oder ein Steuercode ausgewertet werden soll.

insertCharacter proc
        pusha
        push ds
        push es
        mov  es, bx
        push word ptr es:[bufferSeg]
        pop  ds
        mov  si, es:[bufferOfs]


  ; Unterscheiden, ob ein Zeichen eingefgt werden soll, oder ob ein Steuercode
  ; ausgewertet werden soll

        cmp al, 80h
        je  asciiKey
        or  cl, cl
        jz  controlKey
        cmp cl, 8
        je  controlKey
        jmp asciiKey

  controlKey:

        cmp  cl, 8
        jne  @_pos1
        call backSpace
        jmp  doneKey

    @_pos1:
        cmp  ch, 71
        jne  @_right
        call pos1
        jmp  doneKey

    @_right:
        cmp  ch, 77
        jne  @_delete
        call scrollRight
        jmp  doneKey

    @_delete:
        cmp  ch, 83
        jne  @_left
        call eraseCharacter
        jmp  doneKey

    @_left:
        cmp  ch, 75
        jne  @_ctrl_left
        call scrollLeft
        jmp  doneKey

    @_ctrl_left:
        cmp ch, 115
        jne @_ctrl_right
        call scrollWordLeft
        jmp doneKey

    @_ctrl_right:
        cmp ch, 116
        jne @_end
        call scrollWordRight
        jmp doneKey

    @_end:
        cmp  ch, 79
        jne  doneKey
        call jumpEnd
        jmp  doneKey

    asciiKey:

        mov al, cl

  ; Zuerst testen, ob noch Zeichen in den Stringpuffer passen

        movzx cx, [si]
        cmp   cl, es:[bufferSize]

        jae bufferFull


  ; Im Puffer ist noch Platz. Jetzt Platz schaffen fr das einzufgende Zeichen.
  ; Auerdem die Stringlnge erhhen

        push es
        inc  byte ptr [si]
        push si
        add  si, cx
        sub  cl, es:[startPos]
        sub  cl, es:[cursorPos]
        push ds
        pop  es
        mov  di, si
        inc  di
        std
        rep movsb
        cld

    ; Jetzt das einzufgende Zeichen einfgen

        stosb

        pop  si
        pop  es

        call scrollRight

  bufferFull:

  doneKey:
        call redrawAll
        pop es
        pop ds
        popa
        ret
insertCharacter endp












closeInputLine proc
        push es
        mov  es, bx
        mov  ah, 49h
        int  21h
        pop  es
        ret
closeInputLine endp













pos1 proc
    mov es:word ptr [startPos], 0
    ret
pos1 endp


















scrollRight proc

    ; Zuerst schauen, ob nach rechts noch Platz ist

        mov al, es:[cursorPos]
        add al, es:[startPos]
        cmp al, [si]
        jb rechtsIstPlatz
        ret

    rechtsIstPlatz:

    ; jetzt schauen, ob gescrollt werden mu

        mov al, es:[cursorPos]
        mov ah, es:[screenLength]
        dec ah
        cmp al, ah
        jb noRightScrollingNeeded

        inc byte ptr es:[startPos]
        ret

    noRightScrollingNeeded:
        inc byte ptr es:[cursorPos]
        ret
scrollRight endp


















jumpEnd proc

    ; Schauen, ob der String komplett in die Zeile passt
        mov al, [si]
        mov ah, es:[screenLength]
        cmp al, ah
        jb  passt

    ; Startpos auf Stringlnge-Zeilenlnge und cursorPos auf Maximum setzen
        sub al, ah
        inc al
        dec ah
        mov es:[startPos], al
        mov es:[cursorPos], ah
        ret

    passt:
        sub al, es:[startPos]
        mov es:[cursorPos], al
        ret
jumpEnd endp















; Die folgende Prozedur baut die gesamte Eingabezeile neu auf. Zustzlich posi-
; tioniert sie den Cursor an der richtigen Stelle.

redrawAll proc

    ; Startposition in BH laden
        mov   bh, es:[startPos]

    ; checken, wieviele Zeichen ausgegeben werden knnen

        movzx cx, byte ptr es:[screenLength]
        mov   al, [si]
        mov   bl, es:[bufferSize]
        cmp   al, bl
        jb    drawFullString
        mov   cl, [si]
      drawFullString:

        inc si

    ; Jetzt "SI" um die Startposition erhhen

        shr bx, 8
        add si, bx

    ; Jetzt den Text auf dem Bildschirm ausgeben

        mov  dx, es:[y]
        mov  al, 160
        mul  dl                         ; AX= AL*DL
        mov  di, ax
        shr  dx, 7
        add  di, dx

        mov  ah, es:[colour]
        push es
        push 0b800h
        pop  es

        or  cl, cl
        jz stringEmpty
    @drawLoop:
        lodsb
        stosw
        loop @drawLoop
    stringEmpty:

        pop  es


    ; jetzt den Cursor locaten
    ; Bildschirmspalte und -zeile in DX laden. DL=Y

        mov dx, es:[y]
        xchg dh, dl
        add  dl, es:[cursorPos]
        xor  bh, bh
        mov  ah, 2
        int  10h

        ret
redrawAll endp


.286c
