
; Install- und deInstall-Routinen fr Fabian's keyMan - Routinen
; incl. loading + destroying

keyManType  db  1     ; 1 = full - Handler  /  2 = small - Handler
keyManOfs   dw  0     ; offset immer 0
keyMan      dw  0     ; seg - Adresse des Exception - Managers
keyManFullName  db  'c:\shell\tsr\kfull.app', 0
keyManSmallName db  'c:\shell\tsr\klite.app', 0

dta         dw  0, 0  ; Adresse der dta
fileSize    dw  0     ; Dateigre des applets
fileNameOfs dw  0     ; ofs und seg des applet-file-namens
fileNameSeg dw  0
fileHandle  dw  0     ; temp. Handle fr appletFile
appletSeg   dw  0     ; res. seg des applets

; applet - lade - routine
; in:   es:di = pointer auf Dateinamen
; out:  ax    = code-segment des applets
;       cf gesetzt bei fehler (nicht geladen)

loadApplet      proc
      pusha
      push ds
      push es

      push cs
      pop  ds

      mov  fileNameOfs, di
      mov  fileNameSeg, es
      mov  appletSeg, 0
      clc

    ; 1. Datei anvisieren und Gre ermitteln
     ; findfirst
      mov   ah, 2fh ; get - dta - address
      int   21h
      mov   word ptr dta, bx
      mov   word ptr dta +2, es

      mov   ah, 4eh
      mov   cx, 1 + 2 + 4 ; normal - files
      push  ds
      mov   dx, cs:fileNameOfs
      mov   ds, cs:fileNameSeg
      int   21h
      pop   ds
      jnc   @noErr2
      ; call  errorHandling
      jmp   @loadEnding
     @noErr2:
     ; Daten auswerten, insbesondere Gre
      mov   si, word ptr cs:dta
      mov   ds, word ptr cs:dta +2
      mov   ax, word ptr ds:[si+26]  ; file - Gre
      push  cs
      pop   ds
      mov   fileSize, ax

     ; open
      mov   ax, 3d00h ; handle - file - open + flags
      mov   dx, fileNameOfs
      push  ds
      mov   ds, cs:fileNameSeg
      int   21h
      pop   ds
      jnc   @noErr1
      ; call  errorHandling
      jmp   @loadEnding
    @noErr1:
      mov   fileHandle, ax  ; handle

    ; 2. Speicher reservieren

      push  cs
      pop   ds
      mov   ah, 48h
      mov   bx, fileSize
      shr   bx, 4            ; paragraphen
      inc   bx
      int   21h
      jnc   @noErr3
      ; call errorHandling
      jmp   @loadEnding
     @noErr3:
      mov   appletSeg, ax    ; segment - Adresse des Bereichs

    ; 3. applet einladen und file schlieen

      mov   bx, fileHandle   ; handle einlesen
      mov   ah, 3fh
      mov   cx, fileSize
      xor   dx, dx
      mov   ds, cs:appletSeg ; allokiertes Segment
      int   21h
      jnc   @noErr4
      ; call errorHandling
      jmp   @loadEnding
    @noErr4:
      push  cs
      pop   ds
      cmp   fileSize, ax   ; tatschlich gelesene Bytes mssen! bereinstimmen
      je    @noErr5
      ; call errorHandling
      stc
      jmp   @loadEnding
    @noErr5:

      mov   ah, 3eh ; file - schlieen
      mov   bx, fileHandle
      int   21h

    @loadEnding:
      pop  es
      pop  ds
      popa

    ; code-segment des applets in bx als Rckgabewert
      mov   ax, appletSeg

      ret
loadApplet      endp


; installiert einen der beiden Exception - Handler
installkFull    proc
      push  cs
      pop   ds
      mov   word ptr keyMan, 0  ; segment zurcksetzen

   ; 1. gewnschten key-Handler oder keinen einladen / je nach install - flag
      push  cs
      pop   es
      cmp   byte ptr keyManType, 1
      je    @kManUseFull
      mov   di, offset keyManSmallName
      jmp   @kManLoad
    @kManUseFull:
      mov   di, offset keyManFullName
    @kManLoad:
      call  loadApplet
      jnc   @kManInstall
      ret

   ; 2. call auf entryPoint (cs:0)  /  Einsprungspunkt des applets
    @kManInstall:
      mov   keyMan, ax     ; rout. liefert segment in ax zurck
      mov   ds, ax ; segment setzen
      mov   es, ax
      call  dword ptr cs:keyManOfs

      push  cs
      pop   ds

      ret
installKFull    endp

deInstallKFull  proc
      cmp  word ptr cs:keyMan, 0
      jne  @installed
      ret            ; kein Speicher reserviert (not loaded), da pointer = nil
    @installed:
      mov  ds, cs:keyMan
      mov  es, cs:keyMan
      call dword ptr cs:keyManOfs

      push cs
      pop  ds
      mov  ah, 49h
      mov  es, keyMan
      int  21h

      ret
deInstallKFull  endp


