.286c
; loader.asm = shell-loader, der resident im Speicher verbleibt

code    segment byte use16
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

;include k.inc

eMsgG   db      80,'DOS-Fehler. Bitte Taste drcken.                                                '
errNo   db      '            '

shutDownAsk     db      54, 'Soll das shell.system herruntergefahren werden (J/N) ?'
shutDownTitel   db      23,'shell system beenden...'
endMsg          db      'shell - system - kernel ver 0.9    (c)1996 iCode ',13,10,36
verstr          db      0ch, 'shell system'

shellName       db      'c:\shell\main\shell.com',0   ; vorlufiger Dateiname -> mu evtl. aus ini-File gelesen werden
dummy1          db      150     dup (0)          ; fr lngere Dateinamen -> direkter patch
shellParam      dw      0       ; Environment-Block-Seg-Adresse:
                                ; hier kann man mit einem Verweis auf ein Segment
                                ; das Standard-env. einspeisen, da shell gewissermaen
                                ; das erste Programm darstellt / Anfang der Verknpfungsliste
                dw      offset commandLine ; offset der Kommandozeile fr Shell
                dw      0       ; segment      "
                dw      0ffffh  ; ofs 1. fcb - unused
                dw      0ffffh  ; seg "
                dw      0ffffh  ; ofs 2. fcb - unused
                dw      0ffffh  ; seg "
commandLine     db      0,0,13
intern          db      0       ; Flag, ob direktExec oder nach terminate
old32           dw      0,0     ; nimmt alten $32-Pointer auf
execDo          db      0       ; flag 0 oder 1, ob exec ausgefhrt werden soll
saveSP          dw      0       ; nimmt ss und sp bei Programmexec auf
saveSS          dw      0
progName        db      255     dup (0)
progParam       dw      0       ; Environment-Block-Seg-Adresse:
                dw      offset commandProg ; offset der Kommandozeile fr prog
                dw      0       ; segment      "
                dw      0ffffh  ; ofs 1. fcb - unused
                dw      0ffffh  ; seg "
                dw      0ffffh  ; ofs 2. fcb - unused
                dw      0ffffh  ; seg "
commandProg     db      128     dup (0)
environment     db      0       ;  ich wei noch nicht wie, mal sehen
                                ; wahrscheinlich reserviere ich ein extra-seg
linksOben       db      218
rechtsOben      db      191
linksUnten      db      192
rechtsUnten     db      217
waagerecht      db      196
senkrecht       db      179

freeparagraph   dw      0       ; Variablen fr Fensterverwaltung
lastwindow      dw      0
oCursor         dw      0       ; Speicher fr Cursorgre

t1      db      0
t2      db      0
t3      db      0
t4      db      0
t5      db      0
t6      db      0
t7      db      0

tw1     dw      0
tw2     dw      0
tw3     dw      0
tw4     dw      0
tw5     dw      0

buffer  dw      0h
buffer2 dw      0h

; hier mten dann die Proc's stehen, da ab begin stack anfngt
; eventuell mssen wir den Stack (aktuell = 500+done-begin) vergrern,
; da sonst in diesen Bereich hier geschrieben wird. mal sehen.

callTab dw      offset ver                ; 0
        dw      offset window
        dw      offset closeWindow
        dw      offset saveScreen
        dw      offset restoreScreen
        dw      offset drawButton         ; 5
        dw      offset centerText
        dw      offset getErrMsg
        dw      offset cursorOff
        dw      offset cursorOn
        dw      offset percent            ; 10
        dw      offset field
        dw      offset hex2dec
        dw      offset blink
        dw      offset initInputLine
        dw      offset closeInputLine     ; 15
        dw      offset insertCharacter
        dw      offset updateInputLine
        dw      offset readKey
        dw      offset clearKeyBuf
        dw      offset execProg           ; 20
        dw      offset storeParam
        dw      offset getParam
        dw      offset pause
        dw      offset resetCharacter
        dw      offset bin2hex            ; 25
        dw      offset errorHandler

int21   proc
	pushf
	db 09ah
  @oldvect:
	db 4 dup (90h)

        ; flags drfen natrlich nicht wiederhergestellt werden, sondern
        ; die von der 21h fkt, gesetzten mssen auf dem stack gepatcht werden.
	mov cs:buffer, bp
	mov cs:buffer2, ax
	pushf
	pop ax
	mov bp, sp
	mov ss:[bp+4], ax
	mov ax, cs:buffer2
	mov bp, cs:buffer
	iret
int21   endp

;int32-Prozedur, die die einzelnen Routinen aufruft
int32   proc
        sti
        cmp     ah, 64    ; mu an maximale, reale Funktionen angepat werden
        ja      @noFunc
        push    ax
        push    si
        push    di
        xor     al,al
        shr     ax,7    ; *2 und in al
        mov     di,offset callTab
        add     di,ax
        mov     word ptr cs:[@change+3],di        ; selbst patchen
        pop     di
        pop     si
        pop     ax
        jmp     @change
     @change:
        call    word ptr [cs:callTab]
     @noFunc:
        iret
int32   endp

include input.inc
include fastkey.inc
include timer.inc
include error.inc

; gibt versionsnummer in bh.bl zurck (1.0) -> ds:si string auf 'shell system'
ver     proc
        mov ax, cs
        mov ds, ax
        mov si, offset verStr
        mov bh, 1
        xor bl, bl
        ret
ver     endp

; routine zeichnet ein Textfenster mit und ohne schatten. Andere Zeichen
; sind, falls gewnscht, zu patchen
window  proc
        pusha
        push    ds
        push    es
        call    saveScreen      ; Hintergrund auf SaveStack sichern
        pop     es
        pop     ds
        push    ds
        push    es

          ;      - Eingabe: ch = oben / cl = unten
          ;                 dh = links / dl = rechts
          ;                 bl = color / bh = fensterStyle
          ;                 ds:si = #len'titel'
          ;      - Definition FensterStyle:
          ;        4 = Knopf an / aus
          ;        2 = doppelter Rahmen an / aus
          ;        1 = Schatten an / aus
     
        mov     cs:t1,ch    ; diese Segment - Adressierungen drften einiges kosten
        mov     cs:t2,cl
        mov     cs:t3,dh
        mov     cs:t4,dl
        mov     cs:t5,bh
        and     cs:t5,1     ; nur Schatten oder nicht
        mov     cs:t7,bh

        and     bh,2        ; doppelter Rahmen ja / nein
        je      @einfach    ; einfacher Rahmen
        jmp     @doppelt    ; doppelter Rahmen

        @einfach:
        mov     cs:linksOben,218
        mov     cs:rechtsOben,191
        mov     cs:linksUnten,192
        mov     cs:rechtsUnten,217
        mov     cs:waagerecht,196
        mov     cs:senkrecht,179
        jmp     @scrOfs
        @doppelt:
        mov     cs:linksOben,201
        mov     cs:rechtsOben,187
        mov     cs:linksUnten,200
        mov     cs:rechtsUnten,188
        mov     cs:waagerecht,205
        mov     cs:senkrecht,186

@scrOfs:mov     ax,0b800h   ; es auf bildschirm-seg
        mov     es,ax

        mov     al,160      ; ax = ch * 160  / scr-offset = 160 * y1 + x1
        xor     ah,ah
        mul     ch
        mov     di,ax
        mov     dl,cs:t3    ; dl <= links
        xor     dh,dh       ; dh lschen
        shl     dx,1        ; links * 2
        add     di,dx       ; zum offset dazu

        mov     al,cs:linksOben ;  218
        mov     ah,bl       ; ah mit attr fllen
        stosw               ; in Bildschirm
        cld

        mov     cl,cs:t4    ; lnge fr innen-Teil berechnen rechts-links-shadow-1
        sub     cl,cs:t3
        xor     ch,ch
        dec     cl
        sub     cl,cs:t5    ; Schatten
        mov     cs:t6,cl    ; Lnge in t6 abspeichern

        mov     al,cs:t7    ; style in al
        and     al,4
        je      @noKnopf        ; wenn kein Knopf [] erwnscht -> weiterspringen
        sub     cl,4            ; 3 weniger im oberen Balken wenn Knopf
        mov     ah,bl
        mov     al,cs:waagerecht ; knopf um eins nach rechts von der Ecke
        stosw
        mov     al,5bh          ;  5bh = [  /  5d = ]
        stosw
        mov     ah,bl
        and     ah,0f0h
        add     ah,0ah
        mov     al,254d
        stosw
        mov     ah,bl
        mov     al,5dh
        stosw
     @noKnopf:
        mov     al,cs:waagerecht
        mov     ah,bl
        stosw
        dec     cl

        or      byte ptr ds:[si],0
        je      @noTitle
        mov     ch,byte ptr ds:[si]
        inc     si
        sub     cl,6
        cmp     ch,cl
        jb      @okText
        mov     ch,cl
     @okText:
        sub     cl,ch
        add     cl,4

        push    cx
        shr     cx,8
        mov     ah,bl
        mov     al,32
        stosw

      @lp1t:
        lodsb
        stosw
        dec     cl
        jne     @lp1t

        pop     cx
        xor     ch,ch
        mov     al,32
        stosw
     @noTitle:
        mov     ax,cs
        mov     ds,ax

        mov     al,waagerecht
        mov     ah,bl
        rep     stosw

;        xor     ah, 8
        mov     al,rechtsOben
        stosw
;        xor     ah, 8

        xor     ah,ah
        mov     al,80
        sub     al,cs:t6
        sub     al,2
        sub     al,cs:t5
        shl     ax,1
        mov     cs:tw1,ax

        mov     al,cs:t5
        xor     ah,ah
        shl     al,1
        add     di,ax

        mov     dl,cs:t1        ; Fenster-Innen-Teil
        inc     dl
        add     dl,cs:t5
   @winLoop:
        add     di,cs:tw1
        mov     ah,bl           ; attribut
        mov     al,cs:senkrecht ; 
        stosw

        mov     cl,cs:t6        ;Lnge
        mov     al,32
        rep     stosw

;        xor     ah, 8
        mov     al,cs:senkrecht ; 
        stosw
;        xor     ah, 8

        or      cs:t5,0         ;Schatten wird erzeugt, indem Attribut auf 07h
        je      @noSchatten
        inc     di
        mov     byte ptr es:[di],07h
        inc     di
      @noSchatten:

        inc     dl
        cmp     dl,t2
        jb      @winLoop
        add     di,tw1

        mov     al,linksUnten
        mov     ah,bl
        stosw

        cld
        mov     cl,t6
        mov     al,waageRecht
        mov     ah,bl
;        xor     ah, 8
        rep     stosw

        mov     al,rechtsUnten
        stosw
;        xor     ah, 8

        or      t5,0            ;Schatten wird erzeugt, indem Attribut auf 07h
        je      @retW
        inc     di
        mov     byte ptr es:[di],07h
        inc     di

        add     di,tw1          ;Schatten unten
        add     di,3
        mov     cl,t6
        add     cl,2
 @winLoop2:
        mov     byte ptr es:[di],07h
        add     di,2
        dec     cl
        jne     @winLoop2

 @retW:
        pop     es
        pop     ds
        popa
        ret
window  endp

closeWindow     proc
        call    restoreScreen
        ret
closeWindow     endp

; procedure sichert Bildschirmhintergrund auf FensterStack
saveScreen proc
          ;      - Eingabe: ch = oben / cl = unten
          ;                 dh = links / dl = rechts
          ;      - Ausgabe: -

           pusha
           push ds
           push es

           mov  ax,cs
           mov  ds,ax

           cld
           mov  bl,cl
           sub  bl,ch
           inc  bl      ; delta-y
           mov  cl,bl

           mov  al,dl
           sub  al,dh
           inc  al      ; delta-x
           mov  dl,al
           xor  ah,ah

           push dx
           mul  bl      ; AX=Speicherbedarf
           shl  ax,1    ; *2, da Attribut und Zeichen gesichert werden mssen
           add  ax,6    ; 4 Bytes fr Fenstervariablen
           shr  ax,4    ; durch 4 Teilen, da Angabe in Paragraphen
           inc  ax      ; Speicherbedarf in Paragraphen / daher +1
           pop  dx

           mov  di,ax
           ;  in DI= Speicherbedarf in Paragraphen
           ;     CL= delta_y
           ;     CH= Oben
           ;     DL= delta_x
           ;     DH= Links

           xor  ah,ah
           mov  al,ch
           mov  bl,160d
           mul  bl
           mov  bl,dh
           xor  bh,bh
           shl  bl,1    ; *2 wegen attr+zeichen = 2Bytes
           add  ax,bx   ; Offset des Festerstarts in SI
           mov  si,ax
           mov  dh,cl

           ;  in DI= Speicherbedarf in Paragraphen
           ;     SI= Offset Fenster
           ;     DL= delta_x
           ;     DH= delta_y

           mov  bx,di
           mov  ah,48h
           int  21h               ; Speicher reservieren
           jc   @window_fehler    ; wenn kein Speicher da
           mov  freeparagraph,bx  ; interne Variable -> immer freier Speicher

           mov  es,ax             ; neuer Speicher -> hier kommt Bild rein
           xor  di,di
           mov  bx,cs:lastwindow
           mov  word ptr es:[di],bx  ; in erstem word des neuen Speichers wird
           mov  cs:lastwindow,ax     ; Segment des letzten Blockes abgelegt
           add  di,2                 ; hierdurch entsteht eine Liste

           mov  es:[di],si           ; Offset im screen in 2.word
           add  di,2

           mov  es:[di],dx           ; delta-x/y des Blockes im 3.word
           add  di,2                 ; dl = d(x) und dh = d(y)

           mov  bl,80
           sub  bl,dl
           xor  bh,bh
           shl  bx,1    ; y-Offset-Add

           push ds
           cld
           mov  ax,0B800h
           mov  ds,ax
           xor  ch,ch
@window_save:
           mov  cl,dl
           rep  movsw
           add  si,bx
           dec  dh
           jnz  @window_save

           pop  ds
           jmp  @endeSave

@window_fehler:
           pop  es
           pop  ds
           popa
           call errorCheck
           ret

           ;  Hier mu eine Fehlermeldung hin
@endeSave:
           pop  es
           pop  ds
           popa
           ret
saveScreen endp

; stellt den zuletzt gesicherten Bildschirminhalt wieder her -> keine Parameter
restoreScreen   proc
           ; lastWindow = seg des letzten Blockes
           ; Blockformat:
           ;   ofs 0 = seg des letzten Blockes
           ;       2 = si im Bildschirm
           ;       4 = d(x)/dl und d(y)/dh

           pusha
           push ds
           push es

           mov  ax,cs
           mov  ds,ax

           cld
           mov  ax,cs:lastWindow
           cmp  ax,0
           je   @window_fertig  ; keine Bildschirmbereiche gesichert

           ;push ds
           mov  ds,ax           ; es auf lastWindowBlock
           xor  si,si
           mov  ax,ds:[si]
           mov  cs:lastWindow,ax   ; lastwindow auf Vorgnger
           add  si,2
           mov  di,ds:[si]      ; offset Bildschirm holen
           mov  ax,0B800h
           mov  es,ax           ; es auf Screen
           add  si,2
           mov  dx,ds:[si]      ; deltaX holen
           add  si,2
           xor  ch,ch           ; ch killen

           mov  bl,80
           sub  bl,dl
           xor  bh,bh
           shl  bx,1    ; y-Offset-Add
@window_load:
           mov  cl,dl
           rep  movsw
           add  di,bx
           dec  dh
           jnz  @window_load

           mov  ax,ds
           mov  es,ax
           mov  ah,49h
           int  21h   ; Speicher freigeben
           jnc  @window_fertig
           ;pop  ds
@releaseErr:
           pop  es
           pop  ds
           popa
           call  errorCheck
           ret

@window_fertig:
           pop  es
           pop  ds
           popa
           ret
restoreScreen endp

include button.inc
include drawtext.inc

; Statusbalkenroutine
;                - Eingabe: ah = 0ah
;                           cl = Zeile / ch = percent (0-100)
;                           dh = rechts / dl = links
;                           bl = colour1 / bh = colour2
percent proc

pusha
push ds
push es
push di
push 0b800h
pop es                                  ; VGA Segment nun in ES
push dx
mov al, 160
mul cl                                  ; VGA Offset nun in AX
shl dl, 1
xor dh, dh
add ax, dx                              ; auf Offset addieren...
mov di, ax                              ; ... und in DI ablegen

pop dx
push dx
sub dh, dl
shr dx, 8

mov al, ch
mul dl                                  ; 'Lnge'*'percent' in AX
mov dl, 100
div dl                                  ; effektive Lnge jetzt in AL
xor ah, ah

pop dx

sub dh, al
sub dh, dl
shr dx, 8                               ; Restlnge jetzt in DL

mov cx, ax
mov al, 0b0h
mov ah, bl
xor ch, ch
rep stosw

mov cx, dx
mov ah, bh
rep stosw

pop di
pop es
pop ds
popa
ret
percent endp

; Schaltet den Cursor ab und speichert aktuelles Aussehen
cursorOff       proc
        mov     bh,0            ; alte Gre holen
        mov     ah,3h
        int     10h
        ; ch,cl = CursorForm
        mov     cs:oCursor,cx   ; alten Cursor abspeichern

        mov     ch,00100000b    ; auf setzen -> abschalten
        mov     cl,00000000b
        mov     ah,1
        int     10h
        ret
cursorOff       endp

; Schaltet den Cursor wieder mnit dem ursprnglichen Wert ein
; cx =  0 => wiederherstellen
; cx <> 0 => Cursor neue Form nach cx geben
cursorOn        proc
;        cmp     cx,0
;        jne     @chng
;        mov     cx,cs:oCursor
;    @chng:
        push    cx
        mov     cx, 0607h
        mov     ah,1
        int     10h
        pop     cx
        ret
cursorOn        endp

; procedure zeichnet quickstartLeiste
; ah = 11  /  al = Nummer des Knopfes, 1-10 (keine berprpfung)
; bl = textFarbe  /  bh = zifferFarbe
; ds:si = Zeiger auf Text, exakt (!) 6 Buchstaben, keine Terminierung
field   proc
    pusha
    push 0b800h
    pop es
    mov dl, al                          ; wird ja noch gebraucht
; 1. Schritt: X-Koordinate berechnen, in AX ablegen
    dec al
    mov dh, 8
    mul dh
; 2. Schritt: y-koordinate addieren, verdoppeln und in DI ablegen
    add ax, 24*80
    shl ax, 1
    mov di, ax
; 3. Schritt: Zahl schreiben
    mov ah, bh
    cmp dl, 10
    je @schreibe_zehn
      add dl, 30h
    @schreibe_zahl:
      mov al, dl
    stosw
    jmp @text_schreiben
    @schreibe_zehn:
      mov al, 31h
      stosw
      mov al, 30h
      stosw

; 4. Schritt: Text schreiben
    @text_schreiben:
    mov ah, bl
    mov cx, 6
    @loop_zeichen:
      lodsb
      stosw
    loop @loop_zeichen
; 5. Schritt: Leerzeichen schreiben
    mov al, 20h
    mov ah, bh
    stosw
    popa
    ret
field   endp

include hex2dec2.inc
hexTabS db  '0123456789ABCDEF'  ; fr hex - Darstellung

; prozedur konvertiert ein byte in einen hex-string
; in:  al = byte
; out: ax = hex-string
bin2hex proc
       push    ds
       push    bx
       push    si

        push    cs
        pop     ds

        push    ax
        xor     ah, ah
        shr     al, 4
        mov     si, offset hexTabS
        add     si, ax
        mov     bh, byte ptr ds:[si]
        pop     ax

        xor     ah, ah
        and     al, 0fh
        mov     si, offset hexTabS
        add     si, ax
        mov     bl, byte ptr ds:[si]
        mov     ax, bx
        xchg    ah, al

       pop     si
       pop     bx
       pop     ds
        ret
bin2hex endp

; schaltet blinken an b.z.w. aus, ganz brauchbar als api, denke ich
; Funktionsnummer ah = 13
; al=1 : blinken an, al=0: blinken aus
blink   proc
        pusha

  ; auf index umschalten
  push ax
  mov dx, 3dah
  in al, dx
  mov al, 30h
  mov dx, 3c0h
  out dx, al
  ; wert lesen und modifizieren
  mov dx, 3c1h
  in al, dx
  and al, 11110111b
  pop bx
  cmp bl, 0
  je @label_100
  add al, 1000b
  @label_100:
  push ax
  mov dx, 3dah
  in al, dx
  mov al, 30h
  mov dx, 3c0h
  out dx, al
  pop ax
  out dx, al

        popa
        ret
blink   endp

; procedure meldet dos-Fehler und fragt, ob fortgefahren werden soll
errorCheck      proc    ; dos-fehler-code in ax
        pusha
        push    ds
        push    es

        push    cs
        pop     ds

        xor     dx,dx
        mov     bx,ax
        push    cs
        pop     es
        mov     di,offset errNo
        mov     ah,12
        int     32h

        push    es
        pop     ds
        mov     si,offset cs:eMsgG

        mov     dx,0
        mov     bh,0
        mov     bl,4fh
        mov     ah,6
        int     32h

        mov     ax,1
        int     16h

        ; hier bitte noch Abfrage...

        ;mov     ah,9
        ;mov     dx,offset termStopped
        ;int     21h
        ;mov     ah,4ch
        ;int     21h

     @soFar:
        pop     es
        pop     ds
        popa
        ret
errorCheck      endp

getErrMsg       proc
        ;later!!!!!!!!
        ret
getErrMsg       endp

include loadexec.inc
include tsrman.inc

begin:
        ; 1. Aufgabe: Speicher anpassen
        ; - zunchst stack anpassen
        cli
        mov     ax,cs
        mov     ss,ax
@stk1:  mov     sp,(offset done) + 1024
        sti

        ; - und dann schnell Gre ndern
        mov     ax,cs
        mov     ds,ax
        mov     es,ax           ; Adresse des zu ndernden Blocks in es
@stk2:  mov     bx,(offset done) + 1100   ; neue Blocklnge < kleiner als alte(64k)
        shr     bx,4            ; durch 16 teilen => Angabe in Paragraphen
        inc     bx
        mov     ah,4ah          ; dos-resize-blocklen-call
        int     21h
        jnc     @weit1
        call    errorCheck      ; Fehlerbehandlung und Abfrage, ob fortfahren ernscht
@weit1:

; Hauptprogramm ( init / run / destroy )
laden:
;        mov     ax,cs:[2ch]     ; env-seg entfernen
;        mov     es,ax
;        mov     ah,49h
;        int     21h

     ; die Interupts initialisieren -> umleiten

        mov     ax,3521h        ; int21 auslesen
        int     21h
        mov     word ptr [@oldvect+2],es
        mov     word ptr [@oldvect],bx

        mov     ax,cs
        mov     ds,ax
        mov     dx,offset int21
        mov     ax,2521h
;        int     21h

      ; --> int 32h
        mov     ax,3532h        ; Alten auslesen
        int     21h
        mov     old32,bx
        mov     ax,es
        mov     old32+2,ax

        mov     ax,cs           ; umbiegen auf Neuen
        mov     ds,ax
        mov     dx,offset int32
        mov     ax,2532h
        cli
        int     21h
        sti

      ; --> int 8
        call    installTimer

      ; --> int 9
        call    installFastKey

      ; ***************
      ; --> kdrive.app installieren
        call    installkDrive
      ; ***************

      ; ***************
      ; --> Cache-Status-Anzeige installieren
        call    installCachStat
      ; ***************

      ; --> int 21h
      ; ***************
      ; --> fabian's k - manager Routinen installieren / incl. loading
        call    installKFull
      ; ***************

      ; --> Fehler-Behandlung installieren
        call    installErrMan

        ; aufgabe: shell.ini laden -> ini interpretieren
        ; mouse-Treiber / smartdrv laden / etc.

loadShell:
        ; 2. Aufgabe: shell laden ber dos-func-call
        clc
        mov     ax, word ptr cs:[2ch]
        mov     word ptr cs:shellParam,ax       ; env-Seg-Addr
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        mov     shellParam+4,ax                 ; segment der Kommandozeile
        mov     bx,offset shellParam
        mov     dx,offset shellName
        cli                     ; stack sichern
        mov     cs:saveSp,sp
        mov     cs:saveSs,ss
        sti
        mov     ax,4b00h        ; dos-exec-call
        int     21h
        cli
        mov     sp,cs:saveSp    ; stack wiederherstellen
        mov     ss,cs:saveSs
        sti

        jnc     @weit2          ; wenn fehlerfrei, dann weiter
        call    errorCheck
        jmp     closeLoader
@weit2:
        or      cs:execDo,0
        je      @closeSys       ; wenn execDo <> 0 then prog.execute

        mov     cs:execDo,0    ; hier sub-progi ausfhren
        mov     ax, word ptr cs:[2ch]
        mov     word ptr cs:progParam,ax   ; env-Seg auf Vorgnger setzen
        push    cs
        pop     ds
        push    cs
        pop     es

        mov     ax, cs
        mov     word ptr progParam +4, ax ; segment der Kommandozeile
        mov     bx,offset progParam
        mov     dx,offset progName

        pusha
        cli                     ; stack sichern bei exec
        mov     cs:saveSp,sp
        mov     cs:saveSs,ss
        sti
        mov     ax,4b00h        ; dos-exec-call
        int     21h
        cli                     ; stack wiederherstellen
        mov     sp,cs:saveSp
        mov     ss,cs:saveSs
        sti

        jnc     @weit3          ; wenn fehlerfrei, dann shell.load
        popa                    ; zurckschreiben
        call    errorCheck      ; bei Fehler -> errorhandler
        jmp     @reload

@weit3: popa
@reload:jmp     loadShell

 ; Abfrage am Ende, ob system heruntergefahren werden soll?!
@closeSys:
        mov     ax,cs   ; shutDown-Fenster asgeben
        mov     ds,ax
        mov     si,offset shutDownTitel
        mov     dh,10
        mov     dl,71
        mov     cx,070eh
        mov     bl,1fh
        mov     al,1
        mov     bh,1
        call    window

        push    cs
        pop     ds
        mov     bx,001fh
        mov     dx,0c09h
        mov     si,offset shutDownAsk
        call    centerText

        mov     dx,0943h
        mov     ah,2
        int     10h

        mov     ah,10h
        int     16h

        push    ax
        call    closeWindow
        pop     ax

        cmp     al,74 ;J
        je      closeLoader
        cmp     al,106 ;j
        je      closeLoader

        jmp     loadShell

closeLoader:    ; Ende
        mov     ax, 0b800h
        mov     es, ax
        cld
        xor     di, di
        mov     cx, 2000
        mov     ax, 0f20h
        rep     stosw

        xor     bh, bh
        mov     dx, 000h
        mov     ah, 2
        int     10h

        push    cs
        pop     ds
        mov     ah, 9
        mov     dx, offset endMsg
        int     21h

     ; interrupts wieder zurcksetzen

      ; --> Fehler-Behandlung installieren
        call    deInstallErrMan

      ; ***************
      ; --> fabian's k - manager Routinen
        call    deInstallKFull
      ; ***************

      ; ***************
      ; -->  installieren
        call    deInstallCachStat
      ; ***************

      ; ***************
      ; --> kdrive.app deInstallieren
        call    deInstallkDrive
      ; ***************

      ; --> int 9
        call    closeFastKey
      ; --> int 32h
        mov     ax, cs
        mov     ds, ax
        mov     dx, old32
        mov     ds, cs:word ptr [old32+2]
        mov     ax, 2532h
        int     21h
      ; --> int 21h
        mov     ds, cs:word ptr [@oldvect+2]
        mov     dx, cs:word ptr [@oldvect]
        mov     ax, 2521h
        int     21h
      ; --> int 8
        call    closeTimer

        mov     ah,4ch ; diese beiden Zeilen mssen spter gelscht werden
        int     21h    ; folgende beide Zeilen und shutdown-code wie
                       ; cache entleeren und hnliches ersetzt werden (bei einbinden in config.sys)

@here:  jmp     @here

done    equ     this byte       ; danach wird Stack angelegt.

code    ends
        end     entry

