EsdimaX QSort-Algorithmus coded by Thomas N.
---------------------------------------------
19. Mai 1996
written for the SHELL-Project
Werbung: CALL our WHQ in Bdingen! ARPL DS,CX
---------------------------------------------

An den, den es interessiert:
Diese Proc kann derzeit nur nach Name oder Erweiterung sortieren, jedoch
funktioniert dies nach relativ vielen nderungen und Optimierereien doch
erstaunlich gut. Eine Implementation von Dateigren- Namens- und Tagged-
Sortierung ist in den nchsten Tagen zu erwarten.
Der generelle Aufbau der Funktion sieht vor, da dem QSort-Algorithmus in
AL eine Unterfunktion bergeben wird. Dies stellt gewissermaen die Patch-
Anweisung dar. Ein Wert von 0 gibt an, da genau so sortiert wird, wie es
beim letzen Aufruf der Fall war - also sehr gut geeignet nach einem ein-
maligen Patchaufruf mit Unterfunktion 0 die Dateien immer zu sortieren.
Wird ein Wert von 1 oder 2 in AL bergeben, so werden zielich alle Jump-
Adressen gepatcht, was wohl sehr zeitaufwendig sein drfte, wenn es immer
aufgerufen werden wrde, da es vom vorigen Aufruf ja schon richtig gepatcht
wurde. Hier nun die vorlufige Registerbelegung:

  ah = ??        Sortier-Algorithmus fr die Datei-Struktur (25 Bytes)
                 - Eingabe: AH = Funktionsnummer: ??
                            AL = Unterfunktion:
                                 00h = Sortieren wie beim letzen Aufruf
                                 01h = Sortieren: nach 1.Name, 2.Erweiterung
                                 02h = Sortieren: nach 1.Erweiterung, 2.Name
                            SI = kleinster Index der Struktur
                            DI = grter Index der Struktur
                            BP = Offset der Struktur
                            ES = Segment der Struktur

Es ist lediglich die Proc QSORT aufzurufen. Alle anderen hier enthaltenen
Funktionen sind nur lokal fr die QSORT-Routine ntig. Der jeweilige Aufbau
dieser Funktionen steht bei den Funktionen selbst.
Und nun sei glcklich!
  Hasta la vista -> na wer schon ... ich!
    






-> Hier beginnt der Code!

; in SI und DI werden die Indizes auf die Struktur bergeben
; da ES von QSORT nicht verndert wird, sollte dieses Segment nach Mglichkeit
; zur Adressierung verwendet werden.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP, CR0, CR1,...DR1...,TR2, LDT
; nderbare Register: AX, BX, BP, DS, ES, FS, GS
; zuverlssige Register: DS, ES, AX, BP (BX  nur bis zum nchsten GETVALUE)
tausche proc
        push    si
        push    di
        push    cx
        mov     ax,si
        shl     ax,4
        add     ax,si
        shl     si,3
        add     si,ax   ; SI=SI*25 (Index->Offset)
        add     si,bp   ; +Startoffset der Struktur
        mov     ax,di
        shl     ax,4
        add     ax,di
        shl     di,3
        add     di,ax   ; DI=DI*25 (Index->Offset)
        add     di,bp   ; +Startoffset der Struktur

        mov     cl,12
@tausch_loop:
        mov     ax,es:[di]
        xchg    ax,es:[si]
        stosw                   ; mov es:[di],ax
        inc     si
        inc     si
        dec     cl
        jnz     @tausch_loop
        mov     al,byte ptr es:[di]
        xchg    al,byte ptr es:[si]
        stosb                   ; mov es:[di],al

        pop     cx
        pop     di
        pop     si
        jmp     @qsnachswap     ; ANTI-CALL-Technik
tausche endp

; in BX wird der Index auf die Struktur bergeben. Fr sptere Vergleiche sollte
; der Index entweder in einer Variablen abgelegt werden oder besser der Wert
; an dieser stelle selbst, um die Geschwindigkeit zu erhhen. ES ist fr die
; Adressierung der Struktur geeignet, da es von SORT nicht gendert wird.
; nicht nderbare Register: SI, DI, SS, SP
; nderbare Register: AX, BX, CX, DX, BP, DS, ES
getvalue proc
        mov     ax,bx
        shl     bx,3
        add     bx,ax
        shl     ax,4
        add     bx,ax   ; hier jetzt Offset des zu vergleichenden Entrys
        add     bx,bp   ; +Startoffset der Struktur
        jmp     @qsnachget      ; ANTI-CALL-Technik
getvalue endp

; Das ist der allgemeine Teil der beiden Compare-Procs, welcher berprft,
; ob es sich um die Volume-ID oder ein Directory handelt und den Vergleich
; weitergibt, sofern hier nicht bereits der hherrangige Wert gefunden wurde
compareallg proc
; Allgemeiner Teil (Volume-ID, Directory, '.', '..')
        mov     al,byte ptr es:[si]
        mov     ah,al                   ; Sichern fr Entscheidung SI/DI
        xor     al,byte ptr es:[di]     ; beide Directory oder nicht -> weiter
        test    al,16+8                 ; nur gesetzt, wenn 1 Directory oder Volume-ID
        jz      @cmpnext                ; jmp, wenn kein directory oder Volume-ID
        test    al,8                    ; Volume-ID?
        jz      @cmpdir                 ; -> Directory
        test    ah,8                    ; wenn Volume-ID, dann SI=Volume-ID?
        jz      @cmpstc                 ; Nein -> also grer
        pop     cx
        pop     di
        pop     si
        ret                             ; RET wenn kleiner
@cmpdir:
        test    ah,16                   ; wenn Directory, dann SI=Directory?
        jz      @cmpstc                 ; Schnell noch Carry setzen lassen
        pop     cx
        pop     di
        pop     si
        ret                             ; RET wenn kleiner
@cmpnext:
        mov     ax,word ptr es:[si+1]   ; Anschlieende Vergleichsreihenfolge
        mov     cx,word ptr es:[di+1]   ; unbedingt einhalten (Selbstvergleich!)
        cmp     cx,202eh                ; DI = '. '?
        je      @cmpstc                 ; ja -> grer
        cmp     ax,202eh                ; SI = '. '?
        je      @cmpclc                 ; JA -> kleiner
        cmp     cx,2e2eh                ; DI = '..'?
        je      @cmpstc                 ; ja -> grer
        cmp     ax,2e2eh                ; SI = '..'?
        je      @cmpclc                 ; ja -> kleiner
@cmpnachallg:                           ; wird fr Sortiertyp gepatcht
        db      0E9h                    ; JMP NEAR CMPNAME
        dw      offset cmpname-offset @cmpnachallg-3 ; Vorgabe: Namenssortierung
@cmpstc:
        pop     cx
        pop     di
        pop     si
        stc                             ; Rckgabewert fr grer
        ret
@cmpclc:
        pop     cx
        pop     di
        pop     si
        clc                             ; Rckgabewert fr kleiner
        ret
compareallg endp

cmpname proc
        push    si      ; Sichern, da gendert wird und nachfolgende Instanz
        push    di      ; diese Werte bentigt
        add     si,1    ; Name in Struktur an Position 1
        add     di,1    ; -"-
        mov     cx,8    ; Lnge 8 Byte
        repe    cmpsb   ; bis zur ersten Nichtbereinstimmung
        dec     si      ; ein Byte zu weit gezhlt
        dec     di      ; -"-
        mov     al,byte ptr es:[si]
        cmp     al,byte ptr es:[di]
        pop     di
        pop     si      ; fr nchste Instanz gerettet
        ja      @cmpstc
        jb      @cmpclc
@cmpnachname:
        db      0E9h    ; JMP NEAR CMPEXT
        dw      offset cmpext-offset @cmpnachname-3
cmpname endp

cmpext  proc
        push    si      ; wird undefiniert gendert
        push    di      ; wird undefiniert gendert
        add     si,10   ; Extension in Struktur an Position 10
        add     di,10   ; -"-
        mov     cx,3    ; Lnge 3 Byte
        repe    cmpsb   ; bis zur ersten Nichtbereinstimmung
        dec     si      ; ein Byte zu weit gezhlt
        dec     di      ; -"-
        mov     al,byte ptr es:[si]
        cmp     al,byte ptr es:[di]
        pop     di      ; restaurieren fr nchste Instanz
        pop     si      ; restaurieren fr nchste Instanz
        ja      @cmpstc
        jb      @cmpclc
@cmpnachext:
        db      0E9h    ; JMP NEAR @CMPSTC
        dw      offset @cmpstc-offset @cmpnachext-3
cmpext  endp

; in SI wird der Index auf die Struktur bergeben. Der Wert an dieser Stelle ist
; mit dem gespeicherten Wert von GETVALUE zu vergleichen. Sollte der dort
; vorgefundene Wert grer oder gleich dem Abgelegten ist, so ist das Carry-Flag
; zu setzen, ansonst zu lschen.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP
; nderbare Register: AX, BX, BP, DS, ES
compare1 proc
        push    si
        push    di
        push    cx
        mov     ax,si
        shl     si,4
        add     si,ax
        shl     ax,3
        add     si,ax
        add     si,bp                   ; +Startoffset der Struktur
        mov     di,bx                   ; Offset aus GETVALUE
        jmp     compareallg             ; allgemeines Vergleichen
compare1 endp                           ; RET bei angesprungener Routine

; in DI wird der Index auf die Struktur bergeben. Der Wert an dieser Stelle ist
; mit dem gespeicherten Wert von GETVALUE zu vergleichen. Sollte der dort
; vorgefundene Wert kleiner oder gleich dem Abgelegten ist, so ist das Carry-
; Flag zu setzen, ansonst zu lschen.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP
; nderbare Register: AX, BX, BP, DS, ES
compare2 proc
        push    si
        push    di
        push    cx
        mov     ax,di
        shl     di,4
        add     di,ax
        shl     ax,3
        add     di,ax
        add     di,bp                   ; +Startoffset der Struktur
        mov     si,bx                   ; Offset aus GETVALUE
        jmp     compareallg             ; allgemeines Vergleichen
compare2 endp                           ; RET bei angesprungener Routine

; Dies ist der Koordinator der Sortierung. Die ganze Drecksarbeit bernehmen
; die ganzen anderen Proc's (TAUSCHEN, 2x VERGLEICHEN, VERGLEICHSWERTHOLEN)
; Dieser Proc werden in SI der kleinste Index und in DI der grte Index
; der Struktur bergeben. Mit Selbstmodifikatiion der Sprungadressen der
; ganzen Nigger-Prozeduren kann die Sortierroutine sogar allgemein verwendet
; werden.
qsort   proc
        or      al,al
        jz      @qsbegin        ; Sortierung wie die Letzte -> kein patchen
        cmp     al,2            ; Standart-Sortierung?
        ja      @qsnostandart
        mov     byte ptr cs:@qspatcher0,0E9h    ; jmp (GETVALUE)
        mov     byte ptr cs:@qspatcher1,0E9h    ; jmp (TAUSCHE)
        mov     byte ptr cs:@qspatcher2,0E8h    ; call (COMPARE1)
        mov     byte ptr cs:@qspatcher3,0E8h    ; call (COMPARE2)
        ; Brutalo-Patch der Sprungaddressen:
        mov     word ptr cs:@qspatcher0+1,offset getvalue-offset @qspatcher0-3
        mov     word ptr cs:@qspatcher1+1,offset tausche-offset @qspatcher1-3
        mov     word ptr cs:@qspatcher2+1,offset compare1-offset @qspatcher2-3
        mov     word ptr cs:@qspatcher3+1,offset compare2-offset @qspatcher3-3
        cmp     al,1
        jne     @qsnoname
        mov     word ptr cs:@cmpnachallg+1,offset cmpname-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachname+1,offset cmpext-offset @cmpnachname-3
        mov     word ptr cs:@cmpnachext+1,offset @cmpstc-offset @cmpnachext-3
        jmp     @qsbegin
@qsnoname:
        cmp     al,2
        jne     @qsnoext
        mov     word ptr cs:@cmpnachallg+1,offset cmpext-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachext+1,offset cmpname-offset @cmpnachext-3
        mov     word ptr cs:@cmpnachname+1,offset @cmpstc-offset @cmpnachname-3
        jmp     @qsbegin
@qsnoext:
@qsnostandart:
        ret
@qsbegin:
        mov     word ptr cs:@qsort_patch1+2,di  ; globale Grenzen setzen
        mov     word ptr cs:@qsort_patch2+2,si
        mov     word ptr cs:links_fertig+2,sp
@qsort:
        mov     bx,si
        add     bx,di
        shr     bx,1            ; Mittelwert des Bereiches fr Vergleiche
@qspatcher0:                    ; sichern lassen
        jmp     getvalue        ; bei Bedarf patchen
@qsnachget:                     ; bei Standartsortierung ein CALL weniger!
        mov     cx,si           ; und die Bereichsgrenzen
        mov     dx,di           ; in CX und DX sichern

links_naeher:
@qspatcher2:
        call    compare1        ; bei Bedarf patchen
        jc      links_dran      ; Wert, der grer oder gleich ist gefunden?
@qsort_patch1:
        cmp     si,1234h        ; Test auf Bereichsberlauf!!! - wird gepatcht
        jae     links_dran
        inc     si              ; schrittweise nach oben wandern
        jmp     links_naeher

links_dran:
@qspatcher3:
        call    compare2        ; bei Bedarf patchen
@qsnachcmp2:
        jc      rechts_dran     ; Wert, der grer oder gleich ist gefunden?
@qsort_patch2:
        cmp     di,1234         ; Test auf Bereichsberlauf!!! - wird gepatcht
        jle     rechts_dran
        dec     di              ; schrittweise nach unten wandern
        jmp     links_dran
rechts_dran:
        cmp     si,di           ; Wenn dann auch noch SI kleiner ist als DI
        ja      end_schl
@qspatcher1:
        jmp     tausche         ; bei Bedarf patchen
@qsnachswap:                    ; und auch hier ein CALL weniger bei Standart-
        inc     si              ; sortierung
        dec     di
end_schl:
        cmp     cx,di
        jge     rechts_fertig
        push    si
        push    dx
        mov     si,cx
        jmp     @qsort
links_fertig:
        cmp     sp,1234h        ; etwas brutal - ich geb's zu - aber immerhin
        je      @qsendlichfertig  ; kein rekursiver CALL mehr in der PROC!!!
        pop     dx
        pop     si
rechts_fertig:
        mov     di,dx           ; und nach dem Restaurieren der zwei lokalen
        cmp     di,si           ; Variablen nun noch die andere Seite
        jle     links_fertig    ; und auch hier wieder ohne CALL!
        jmp     @qsort
@qsendlichfertig:
        ret
qsort   endp
