;
;  tsrman.inc - include file fr loader.asm/loadcom.asm
;   coded by iCode sep1996 [vic boone]
;
;  datei enthlt Install- und deInstall-Routinen fr verschiedene
;   shell-tsr-programme. zudem steht eine universale applet-lade-
;   routine zur Verfgung, die das allokierte code-seg. zurckgibt.
;


;  exception - Manager - Variablen und Zugrifspfade
keyManType  db  1     ; 1 = kein Handler  /  1 = full - Handler /  2 = small
keyManOfs   dw  0     ; offset immer 0
keyMan      dw  0     ; seg - Adresse des Exception - Managers
keyManFullName  db  'c:\shell\tsr\kfull.app', 0
keyManSmallName db  'c:\shell\tsr\klite.app', 0

;  Variablen fr den shell - internen gkd (kdrive.app)
kDriveOfs   dw  0     ; offset immer 0
kDriveSeg   dw  0     ; seg von kdrive.app
kDriveName  db  'c:\shell\tsr\kdrive.app',0

;  Variablen fr das Cache-Status-Applet (cachstat.app) / bisher nur smartdrv
cStatOfs    dw  0     ; offset immer 0
cStatSeg    dw  0     ; seg von kdrive.app
cStatName   db  'c:\shell\tsr\cachstat.app',0

;  Variablen fr das Fehler-Behandlungs-Applet
errManOfs   dw  0     ; bleibt 0, da entrypoint = cs:$0
errManSeg   dw  0     ; segment des error-handlers
errManName  db  'c:\shell\tsr\errman.app',0


;  applet - laderoutine
;   in:   es:di = pointer auf Dateinamen
;   out:  ax    = code-segment des applets
;         cf gesetzt bei fehler (nicht geladen)

 dta         dw  0, 0  ; Adresse der dta
 fileSize    dw  0     ; Dateigre des applets
 fileNameOfs dw  0     ; ofs und seg des applet-file-namens
 fileNameSeg dw  0
 fileHandle  dw  0     ; temp. Handle fr appletFile
 appletSeg   dw  0     ; res. seg des applets

loadApplet      proc
      pusha
      push ds
      push es

      push cs
      pop  ds

      mov  fileNameOfs, di
      mov  fileNameSeg, es
      mov  appletSeg, 0
      clc

    ; 1. Datei anvisieren und Gre ermitteln
     ; findfirst
      mov   ah, 2fh ; get - dta - address
      int   21h
      mov   word ptr dta, bx
      mov   word ptr dta +2, es

      mov   ah, 4eh
      mov   cx, 1 + 2 + 4 ; normal - files
      push  ds
      mov   dx, cs:fileNameOfs
      mov   ds, cs:fileNameSeg
      int   21h
      pop   ds
      jnc   @noErr2
      ; call  errorHandling
      jmp   @loadEnding
     @noErr2:
     ; Daten auswerten, insbesondere Gre
      mov   si, word ptr cs:dta
      mov   ds, word ptr cs:dta +2
      mov   ax, word ptr ds:[si+26]  ; file - Gre
      push  cs
      pop   ds
      mov   fileSize, ax

     ; open
      mov   ax, 3d00h ; handle - file - open + flags
      mov   dx, fileNameOfs
      push  ds
      mov   ds, cs:fileNameSeg
      int   21h
      pop   ds
      jnc   @noErr1
      ; call  errorHandling
      jmp   @loadEnding
    @noErr1:
      mov   fileHandle, ax  ; handle

    ; 2. Speicher reservieren

      push  cs
      pop   ds
      mov   ah, 48h
      mov   bx, fileSize
      shr   bx, 4            ; paragraphen
      inc   bx
      int   21h
      jnc   @noErr3
      ; call errorHandling
      jmp   @loadEnding
     @noErr3:
      mov   appletSeg, ax    ; segment - Adresse des Bereichs

    ; 3. applet einladen und file schlieen

      mov   bx, fileHandle   ; handle einlesen
      mov   ah, 3fh
      mov   cx, fileSize
      xor   dx, dx
      mov   ds, cs:appletSeg ; allokiertes Segment
      int   21h
      jnc   @noErr4
      ; call errorHandling
      jmp   @loadEnding
    @noErr4:
      push  cs
      pop   ds
      cmp   fileSize, ax   ; tatschlich gelesene Bytes mssen! bereinstimmen
      je    @noErr5
      ; call errorHandling
      stc
      jmp   @loadEnding
    @noErr5:

      mov   ah, 3eh ; file - schlieen
      mov   bx, fileHandle
      int   21h

    @loadEnding:
      pop  es
      pop  ds
      popa

    ; code-segment des applets in bx als Rckgabewert
      mov   ax, appletSeg

      ret
loadApplet      endp


;  exception - Handler install- und deInstall-Routinen
installkFull    proc
      push  cs
      pop   ds
      mov   word ptr keyMan, 0  ; segment zurcksetzen

   ; 1. gewnschten key-Handler oder keinen einladen / je nach install - flag
      push  cs
      pop   es
      cmp   byte ptr keyManType, 1
      je    @kManUseFull
      mov   di, offset keyManSmallName
      jmp   @kManLoad
    @kManUseFull:
      mov   di, offset keyManFullName
    @kManLoad:
      call  loadApplet
      jnc   @kManInstall
      ret

   ; 2. call auf entryPoint (cs:0)  /  Einsprungspunkt des applets
    @kManInstall:
      mov   keyMan, ax     ; rout. liefert segment in ax zurck
      mov   ds, ax ; segment setzen
      mov   es, ax
      call  dword ptr cs:keyManOfs

      push  cs
      pop   ds

      ret
installKFull    endp

deInstallKFull  proc
      cmp  word ptr cs:keyMan, 0
      jne  @installed
      ret            ; kein Speicher reserviert (not loaded), da pointer = nil
    @installed:
      mov  ds, cs:keyMan
      mov  es, cs:keyMan
      call dword ptr cs:keyManOfs

      push cs
      pop  ds
      mov  ah, 49h
      mov  es, keyMan
      int  21h

      ret
deInstallKFull  endp


;  Keyboard - Treiber install- und deInstall-Routinen
installkdrive   proc
      push  cs
      pop   ds
      mov   word ptr kDriveSeg, 0  ; segment zurcksetzen

   ; 1. gewnschten key-Handler oder keinen einladen / je nach install - flag
      push  cs
      pop   es
      mov   di, offset kDriveName
      call  loadApplet
      jnc   @kDriveInstall
      ret

   ; 2. call auf entryPoint (cs:0)  /  Einsprungspunkt des applets
    @kDriveInstall:
      mov   kDriveSeg, ax     ; rout. liefert segment in ax zurck
      mov   ds, ax ; segment setzen
      mov   es, ax
      call  dword ptr cs:kDriveOfs

      push  cs
      pop   ds

      ret
installKdrive   endp

deInstallKdrive proc
      cmp  word ptr cs:kDriveSeg, 0
      jne  @kDriveInstalled
      ret            ; kein Speicher reserviert (not loaded), da pointer = nil
    @kDriveInstalled:
      mov  ds, cs:kDriveSeg
      mov  es, cs:kDriveSeg
      call dword ptr cs:kDriveOfs

      push cs
      pop  ds
      mov  ah, 49h
      mov  es, kDriveSeg
      int  21h

      ret
deInstallKdrive endp


;  Cache-Status-Treiber applet - und deInstall-Routinen
installCachStat proc
      push  cs
      pop   ds
      mov   word ptr cStatSeg, 0  ; segment zurcksetzen

   ; 1. gewnschten key-Handler oder keinen einladen / je nach install - flag
      push  cs
      pop   es
      mov   di, offset cStatName
      call  loadApplet
      jnc   @cStatInstall
      ret

   ; 2. call auf entryPoint (cs:0)  /  Einsprungspunkt des applets
    @cStatInstall:
      mov   cStatSeg, ax     ; rout. liefert segment in ax zurck
      mov   ds, ax ; segment setzen
      mov   es, ax
      call  dword ptr cs:cStatOfs

      push  cs
      pop   ds
      ret
installCachStat endp

deInstallCachStat proc
      cmp  word ptr cs:cStatSeg, 0
      jne  @cStatInstalled
      ret            ; kein Speicher reserviert (not loaded), da pointer = nil
    @cStatInstalled:
      mov  ds, cs:cStatSeg
      mov  es, cs:cStatSeg
      call dword ptr cs:cStatOfs

      push cs
      pop  ds
      mov  ah, 49h
      mov  es, cStatSeg
      int  21h
      ret
deInstallCachStat endp


;  Fehler-Behandlungs-applet install- und deInstall-Routinen
installErrMan proc
      push  cs
      pop   ds
      mov   word ptr errManSeg, 0  ; segment zurcksetzen

   ; 1. gewnschten key-Handler oder keinen einladen / je nach install - flag
      push  cs
      pop   es
      mov   di, offset errManName
      call  loadApplet
      jnc   @errManInstall
      ret

   ; 2. call auf entryPoint (cs:0)  /  Einsprungspunkt des applets
    @errManInstall:
      mov   errManSeg, ax     ; rout. liefert segment in ax zurck
      ret
installErrMan endp

deInstallErrMan proc
      cmp  word ptr cs:errManSeg, 0
      jne  @errManInstalled
      ret            ; kein Speicher reserviert (not loaded), da pointer = nil
    @errManInstalled:
      push cs
      pop  ds
      mov  ah, 49h
      mov  es, errManSeg
      int  21h
      ret
deInstallErrMan endp



