
; enthlt die verschiedenen Behandlungsroutinen fr die Verzeichnisfenster

driveChange1Titel  db  22, 'Laufwerksauswahl links'
driveNum  db  5

; struktur fr Laufwerke / bisher nur Nummer
  driveInf    struc
              no   db   ?   ; 65 + no = A..Z
  driveInf    ends
  driveInfLen equ 1     ; Lnge der Struktur

  d0  driveInf  <0>     ; daten der untersttzten units
  d1  driveInf  <0>
  d2  driveInf  <0>
  d3  driveInf  <0>
  d4  driveInf  <0>
  d5  driveInf  <0>
  d6  driveInf  <0>
  d7  driveInf  <0>
  d8  driveInf  <0>
  d9  driveInf  <0>

  floppyNum   db 0       ; Anzahl der phys. Standard - Laufwerke
  hardDiskNum db 0
  logNum      db 0       ; Anzahl der log. DOS-Laufwerke

  driveButTrue      db  2fh ; Farbwerte fr Laufwerk - Auswahlfenster
  driveButFalse     db  70h
  driveRealButFalse db  28h

; ermittelt die Anzahl und Art der phys. Laufwerke
getBIOSDrives proc

    ; 1. ermitteln der Anzahl der physikalischen floppy-drives / BIOS
      push 40h
      pop  es
      mov  ax, word ptr es:[10h]  ; at-status-byte holen

      test ax, 1
      jne  @oneOrMoreDrives       ; wenn bit - 1 also gesetzt
      jmp  @hardDisks
    @oneOrMoreDrives:
      shr  ax, 6                  ; nur bit 6+7 interessant
      and  ax, 3          
      inc  ax                     ; ... Anzahl der Laufwerke
      mov  cs:floppyNum, al

    @hardDisks:
      mov  al, es:[75h]           ; Anzahl der Festplatten
      mov  cs:hardDiskNum, al

      ret
getBIOSDrives endp

dib   dw  0, 0      ; dos-info-block adresse

; ermittelt die Anzahl und Art der logischen DOS-Laufwerke
getDOSdrives  proc

    ; 1. Adresse auf dos-struktur holen
      mov   ah, 52h
      int   21h
      push  cs
      pop   ds
      mov   dib, bx
      mov   dib+2, es

      mov   ax, word ptr es:[bx+2]
      mov   dx, word ptr es:[bx]
      mov   es, ax
      mov   bx, dx

    ; 2. Tabellen auswerten / drive-parameter-table
      xor   cl, cl
      mov   si, offset d0

    @nextDrive:
      mov   al, es:[bx]      ; Nummer des log. Laufwerks (A=0, B=1, ...)
      mov   ds:[si], al      ; in eigener Struktur speichern
      inc   cl               ; ein neues Laufwerk mehr ...
      add   si, driveInfLen  ; auf nchste interne Struktur verzweigen
      mov   dx, es:[bx+19h]  ; offset des nchsten dpb holen
    ;!!! +18h laut pc-intern / +19h bei msdos7/win95
      mov   ax, es:[bx+1bh]  ; seg des ...
    ;!!! siehe vorherige Zeile
      cmp   dx, 0ffffh
      je    @noMoreDrives    ; bei $ffff keine dpb's mehr

      mov   es, ax
      mov   bx, dx
      jmp   @nextDrive
    @noMoreDrives:
      mov   logNum, cl

      ret
getDOSdrives  endp

; zeichnet den Laufwerkseintrag (auswahl-men)
; in:  al = no
;      ah = 0:=false; 1:=true

driveOutSt    db   3, ' A '
driveBut1     db   6, '~',0eh,'Konfig'
driveBut2     db   5, '~',0eh,'Hilfe'
rightCorner   db   26h
rightBut2     dw   0
actButton     db   2
maxButton     db   0

drawDriveBut  proc

      push cs
      pop  ds

      cmp  al, 1      ; button no 0 und 1 sind die Auswahl+Konfigschalter
      ja   @driveButs
      or   ah, 0
      je   @driveButFalseX
      mov  bl, driveButTrue
      jmp  @drawButX
    @driveButFalseX:
      mov  bl, driveRealButFalse
    @drawButX:
      or   al, 0
      jne  @ddxBut2

      mov  si, offset driveBut1
      mov  dx, 0612h
      jmp  @drawRBut

   @ddxBut2:
      mov  si, offset driveBut2
      mov  dx, rightBut2

   @drawRBut:
      mov  cl, 10
      mov  bh, 4
      mov  ah, 5
      int  32h
      ret
   @driveButs:
      sub  al, 2
      mov  si, offset driveOutSt
      mov  dx, ax

      xor  ah, ah              ; Buchstaben berechnen
      mov  bh, driveInfLen
      mul  bh
      add  ax, offset d0
      mov  di, ax
      mov  al, ds:[di]
      add  al, 65
      mov  ds:[si+2], al

      shl  dl, 2
      add  dl, 8  ; spalte
      xchg dl, dh

      or   dl, 0
      je   @driveButFalse
      mov  bl, driveButTrue
      jmp  @drawDriveBut
    @driveButFalse:
      mov  bl, driveButFalse
    @drawDriveBut:
      mov  bh, 0   ; style
      mov  dl, 7   ; Zeile
      mov  ah, 6
      int  32h     ; normaler Text

      ret
drawDriveBut  endp

; zeigt Laufwerks-Wechsel-Fenster an
changeLeftDrive proc

      call getDOSDrives

      mov  al, logNum
      mov  maxButton, al
      add  maxButton, 2

      shl  al, 2
      add  al, 11
      cmp  al, 26h
      jb   @drawDriveWindow
      mov  rightCorner, al
    @drawDriveWindow:

      mov  dl, rightCorner   ; spaltenberechnung
      sub  dl, 4
      mov  dh, dl
      sub  dh, 11
      mov  rightBut2, dx

    ; 1. Fenster einrichten
      push cs
      pop  ds
      mov  cx, 050dh
      mov  dh, 03h
      mov  dl, rightCorner
      mov  bx, 077fh
      mov  si, offset driveChange1Titel
      mov  ah, 1
      int  32h

    ; 2. Laufwerke und Buttons zeichnen
      mov  al, actButton
      mov  ah, 1
      call drawDriveBut
      mov  al, 0

    @drawOneMoreDrive:
      mov  ah, 0
      push ax
      cmp  al, actButton
      je   @nodd2
      call drawDriveBut
    @nodd2:
      pop  ax
      inc  al
      cmp  al, maxButton
      jb   @drawOneMoreDrive

    ; 3. user-loop
     @keyLoop1:
      mov  ah, 11h
      int  16h
      jz   @keyLoop1

      mov  ah, 10h
      int  16h

      cmp  al, 27    ; escape
      jne  @neK1
      mov  ah, 2     ; Fenster schlieen und ende
      int  32h
      ret
     @neK1:
      cmp  al, 13    ; enter
      jne  @neK2
      cmp  actButton, 2
      jb   @normalButton1
      jmp  goChangeLeftDrive
     @normalButton1:

     @neK2:
      cmp  al, 9     ; tab
      jne  @neK3
      jmp  @drawDDRight
     @neK3:

      cmp  al,0
      je   @neSk1
      cmp  al, 224
      je   @neSk1
      jmp  @keyLoop1
     @neSk1:
      cmp  ah, 75    ; pfeil links
      jne  @neSk2

     @drawDDLeft:
      mov  al, actButton
      xor  ah, ah
      call drawDriveBut

      or   actButton, 0
      jne  @okD1
      mov  al, maxButton
      mov  actButton, al
     @okD1:
      dec  actButton

      mov  al, actButton
      mov  ah, 1
      call drawDriveBut

      jmp  @keyLoop1
     @neSk2:
      cmp  ah, 77    ; pfeil rechts
      jne  @neSk3

     @drawDDRight:
      mov  al, actButton
      xor  ah, ah
      call drawDriveBut

      mov  al, maxButton
      inc  actButton
      cmp  actButton, al
      jb   @okD2
      mov  actButton, 0
     @okD2:

      mov  al, actButton
      mov  ah, 1
      call drawDriveBut

      jmp  @keyLoop1
     @neSk3:         ; shift - tab
      cmp  ah, 15
      jne  @neSk4
      jmp  @drawDDLeft
     @neSk4:         

      jmp  @keyLoop1
changeLeftDrive endp

goChangeLeftDrive proc
      push    cs
      pop     ds

      mov     al, actButton
      add     al, 63
      mov     si, offset dir1
      mov     ds:[si+1], al

      mov     byte ptr ds:[si], 2
      mov     word ptr ds:[si+3], '*\'
      mov     word ptr ds:[si+5], '*.'
      mov     byte ptr ds:[si+7], 0

      mov     ah,1            ; dir1 neu einlesen
      call    readDirectory
      mov     ah,29           ; alles zunchst redrawen -> automatisch
      call    reDrawScreen

      ret
goChangeLeftDrive endp

