; Overlay-Loader coded 1996 by fabian wleklinski / shell system association

; Proc LoadProc :   - Eingabe:
;                   Ldt Programm in Speicher, ohne es auszufhren. Ein Poin-
;                   ter auf den Pascal-Programmnamen mu in DS:SI bergeben wer-
;                   den.
;                   - Rckgabe:
;                   Wenn AX=0 ist, dann gibt LoadProc in DS die Segment-Adres-
;                   se der ausfhrbaren Routine zurck, anderenfalls steht in
;                   AX der Fehlercode > 0.
;                   Die Segment-Adresse muen gesichert werden, da sie logi-
;                   scherweise fr FreeProc wieder gebraucht werden.
; Proc FreeProc :   - Eingabe:
;                   Lscht Programm wieder aus dem Speicher.
;                   In ES wird ein Pointer auf die ausfhrbare Routine erwartet
;                   - Rckgabe:
;                   Wenn AX<>0 ist, dann enthlt es den FehlerCode...

; Errorcodes :      AX= 1 -> File wurde nicht gefunden
;                   AX= 2 -> Dateigre ist > 64kB
;                   AX= 3 -> Nicht gengend freier Speicher
;                   AX= 4 -> File konnte nicht geffnet werden
;                   AX= 5 -> File konnte nicht gelesen werden
;                   AX= 6 -> Zuwenige Bytes wurden gelesen...
;                   AX=10 -> Speicher wurde nicht freigegeben

FileSize            dw      0000h       ; Hlt die Dateigre
FileName            db      100 dup (0) ; Hlt ASCIIZ-Dateinamen
ExecSeg             dw      0000h       ; Hlt das Segment des Programms

FreeProc proc
        mov ah, 49h
        int 21h
        jnc MemFreed
        add sp, 2
        mov ax, 10
        jmp ErrorHandling
      MemFreed:
        xor ax, ax
        ret
FreeProc endp

LoadProc proc
        cld
        call ConvertFilename            ; Pascal -> ASCIIZ
        call GetFileSize                ; Gre bestimmen...
        call GetMem                     ; ...Speicher holen...
        call ReadFile                   ; ...und einlesen
        xor ax, ax
        mov cx, cs:FileSize
        mov ds, cs:ExecSeg
        ret
LoadProc endp

ConvertFilename proc
        push cs
        pop es
        mov di, offset Filename
        movzx cx, byte ptr ds:[si]
        inc si
        rep movsb
        xor al, al
        stosb
        ret
ConvertFilename endp

ReadFile proc
        mov dx, offset FileName
        mov ax, 3d00h
        int 21h
        jnc FileOpened
        add sp, 2
        mov ax, 4
        jmp ErrorHandling
      FileOpened:
        mov bx, ax
        mov cx, FileSize
        mov ah, 3fh
        mov ds, ExecSeg
        xor dx, dx
        int 21h
        jnc FileRead
        add sp, 2
        mov ax, 5
        jmp ErrorHandling
      FileRead:
        push cs
        pop ds
        cmp ax, FileSize
        je CompleteRead
        add sp, 2
        mov ax, 6
        jmp ErrorHandling
      CompleteRead:
        ret
ReadFile endp

GetMem proc
        mov bx, FileSize
        shr bx, 4
        inc bx
        mov ah, 48h
        int 21h
        jnc MemAvailable
        add sp, 2
        mov ax, 3
        jmp ErrorHandling
      MemAvailable:
        mov ExecSeg, ax
        ret
GetMem endp

GetFileSize proc
        push cs
        pop ds
        mov dx, offset FileName
        mov cx, 0ffh
        mov ah, 4eh
        int 21h
        jnc FileFound
        add sp, 2
        mov ax, 1
        jmp ErrorHandling
      FileFound:
        mov eax, ds:[09ah]
        cmp eax, 10000h
        jb ValidFileSize
        add sp, 2
        mov ax, 2
        jmp ErrorHandling
      ValidFileSize:
        mov filesize, ax
        ret
GetFileSize Endp

ErrorHandling:
        ret


