.386c

code    segment byte use16
        assume  cs:code
        org     100h

entry:  jmp     anfang
; Aufbau der Filename-Struktur:
; Offset:     0  Dos-Attribut
;                  1 = read only
;                  2 = hidden
;                  4 = sytem
;                  8 = Volume-ID
;                 16 = directory
;                 32 = archive
;                128 = tagged in list
;           1-8  Dateiname (8 Zeichen mit Space aufgefllt)
;             9  Space oder Alt+176 ('') bei hidden
;         10-12  Extension (3 Zeichen mit Space aufgefllt)
;         13-14  Datum der letzten nderung (DOS-Format)
;         15-16  Zeit der letzten nderung (DOS-Format)
;         17-20  Dateigre (DWord)
;         21-22  Pointer auf Dir-Liste fr Archiv-Viewer
;         23-24  Archiv-Attribute
    
sortiere:
        db     128,'dirinfo ',' ','com', 0,0, 0,0,  12h,34h, 0h, 0h,  0,0, 0,0
        db       0,'kk      ',' ','exe', 0,0, 0,0,  0ah,0ah,0ah, 0h,  0,0, 0,0
        db       0,'config  ',' ','sys', 0,0, 0,0,  43h,21h, 0h, 0h,  0,0, 0,0
        db       0,'shell   ',' ','asm', 0,0, 0,0,  90h, 0h,20h, 0h,  0,0, 0,0
        db       0,'autoexec',' ','bat', 0,0, 0,0,  12h, 3h, 0h, 0h,  0,0, 0,0
        db      16,'SHELL   ',' ','DIR', 0,0, 0,0,   0h, 0h, 0h, 0h,  0,0, 0,0
        db     128,'command ',' ','com', 0,0, 0,0,  99h,99h,99h, 0h,  0,0, 0,0
        db       0,'ra      ',' ','doc', 0,0, 0,0,  23h,08h,77h, 0h,  0,0, 0,0
        db     128,'loader  ',' ','com', 0,0, 0,0,   1h, 2h, 3h, 4h,  0,0, 0,0
        db     128,'shell   ','','com', 0,0, 0,0,  24h, 3h, 2h, 1h,  0,0, 0,0
        db     128,'raconfig',' ','exe', 0,0, 0,0,   1h,79h,61h, 0h,  0,0, 0,0
        db      16,'SYSTEM  ',' ','DIR', 0,0, 0,0,   0h, 0h, 0h, 0h,  0,0, 0,0
        db      16,'K_DRIVE ',' ','DIR', 0,0, 0,0,   0h, 0h, 0h, 0h,  0,0, 0,0
        db       0,'helpfile',' ','hlp', 0,0, 0,0,   3h, 1h, 2h, 0h,  0,0, 0,0
        db       0,'qsort   ',' ','inc', 0,0, 0,0,  55h, 5h,33h, 0h,  0,0, 0,0
        db     128,'zz      ','','exe', 0,0, 0,0,   6h,34h, 3h,11h,  0,0, 0,0
        db       0,'himem   ',' ','sys', 0,0, 0,0,  17h, 3h,54h, 0h,  0,0, 0,0
        db      16,'DATA    ','','DIR', 0,0, 0,0,   0h, 0h, 0h, 0h,  0,0, 0,0
        db       0,'intel   ',' ','txt', 0,0, 0,0,   9h, 3h,15h, 0h,  0,0, 0,0

bin2hex db      '0123456789ABCDEF'
write   db      '          '

ausgabe proc
        mov     bp,offset sortiere[1]
        push    cs
        pop     es
        xor     dx,dx
@ausgabeloop:
        xor     dl,dl
        mov     cx,12
        mov     ax,1300h
        mov     bx,0fh
        int     10h
        mov     bx,offset bin2hex
        mov     ecx,dword ptr es:[bp+16]
        mov     si,bp
        mov     al,cl
        and     al,0fh
        xlat
        mov     write[9],al
        mov     al,cl
        shr     al,4
        xlat
        mov     write[8],al
        mov     al,ch
        and     al,0fh
        xlat
        mov     write[7],al
        mov     al,ch
        shr     al,4
        xlat
        mov     write[6],al
        shr     ecx,16
        mov     al,cl
        and     al,0fh
        xlat
        mov     write[5],al
        mov     al,cl
        shr     al,4
        xlat
        mov     write[4],al
        mov     al,ch
        and     al,0fh
        xlat
        mov     write[3],al
        mov     al,ch
        shr     al,4
        xlat
        mov     write[2],al
        mov     bp,offset write
        mov     cx,10
        mov     ax,1300h
        mov     bx,0fh
        mov     dl,12
        int     10h
        mov     bp,si
        add     bp,25
        inc     dh
        cmp     dh,19
        jb      @ausgabeloop
        ret
ausgabe endp

; in SI und DI werden die Indizes auf die Struktur bergeben
; da ES von QSORT nicht verndert wird, sollte dieses Segment nach Mglichkeit
; zur Adressierung verwendet werden.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP, CR0, CR1,...DR1...,TR2, LDT
; nderbare Register: AX, BX, BP, DS, ES, FS, GS
; zuverlssige Register: DS, ES, AX, BP (BX  nur bis zum nchsten GETVALUE)
tausche proc
        push    si
        push    di
        push    cx
        mov     ax,si
        shl     ax,4
        add     ax,si
        shl     si,3
        add     si,ax   ; SI=SI*25 (Index->Offset)
        add     si,bp   ; +Startoffset der Struktur
        mov     ax,di
        shl     ax,4
        add     ax,di
        shl     di,3
        add     di,ax   ; DI=DI*25 (Index->Offset)
        add     di,bp   ; +Startoffset der Struktur

        mov     cl,12
@tausch_loop:
        mov     ax,es:[di]
        xchg    ax,es:[si]
        stosw                   ; mov es:[di],ax
        inc     si
        inc     si
        dec     cl
        jnz     @tausch_loop
        mov     al,byte ptr es:[di]
        xchg    al,byte ptr es:[si]
        stosb                   ; mov es:[di],al

        pop     cx
        pop     di
        pop     si
        jmp     @qsnachswap     ; ANTI-CALL-Technik
tausche endp

; in BX wird der Index auf die Struktur bergeben. Fr sptere Vergleiche sollte
; der Index entweder in einer Variablen abgelegt werden oder besser der Wert
; an dieser stelle selbst, um die Geschwindigkeit zu erhhen. ES ist fr die
; Adressierung der Struktur geeignet, da es von SORT nicht gendert wird.
; nicht nderbare Register: SI, DI, SS, SP
; nderbare Register: AX, BX, CX, DX, BP, DS, ES
getvalue proc
        mov     ax,bx
        shl     bx,3
        add     bx,ax
        shl     ax,4
        add     bx,ax   ; hier jetzt Offset des zu vergleichenden Entrys
        add     bx,bp   ; +Startoffset der Struktur
        jmp     @qsnachget      ; ANTI-CALL-Technik
getvalue endp

; Das ist der allgemeine Teil der beiden Compare-Procs, welcher berprft,
; ob es sich um ein Directory handelt und den Vergleich weitergibt, sofern
; hier nicht bereits der hherrangige Wert gefunden wurde
compareallg proc
; Allgemeiner Teil (Volume-ID, Directory, '.', '..')
        mov     al,byte ptr es:[si]
        mov     ah,al                   ; Sichern fr Entscheidung SI/DI
        xor     al,byte ptr es:[di]     ; beide Directory oder nicht -> weiter
        test    al,16                   ; nur gesetzt, wenn EIN Directory
        jz      @cmpnachallg            ; jmp, wenn kein directory
        test    ah,16                   ; wenn Directory, dann SI=Directory?
        jz      @cmpstc                 ; Schnell noch Carry setzen lassen
        pop     cx                      ; ansonst ist Carry ohnehin gelscht!
        pop     di
        pop     si
        ret                             ; RET wenn kleiner
@cmpnachallg:   ; Patch-bezogenes Label - nicht verndern!!!
        db      0E9h                    ; JMP NEAR CMPNAME
        dw      offset cmpname-offset @cmpnachallg-3 ; Vorgabe: Namenssortierung
@cmpstc:
        pop     cx
        pop     di
        pop     si
        stc                             ; Rckgabewert fr grer
        ret
@cmpclc:
        pop     cx
        pop     di
        pop     si
        clc                             ; Rckgabewert fr kleiner
        ret
compareallg endp

cmpname proc
        push    si      ; Sichern, da gendert wird und nachfolgende Instanz
        push    di      ; diese Werte bentigt
        add     si,1    ; Name in Struktur an Position 1
        add     di,1    ; -"-
        mov     cx,8    ; Lnge 8 Byte
        repe    cmpsb   ; bis zur ersten Nichtbereinstimmung
        dec     si      ; ein Byte zu weit gezhlt
        dec     di      ; -"-
        mov     al,byte ptr es:[si]
        cmp     al,byte ptr es:[di]
        pop     di
        pop     si      ; fr nchste Instanz gerettet
        ja      @cmpstc
        jb      @cmpclc
@cmpnachname:   ; Patch-bezogenes Label - nicht verndern!!!
        db      0E9h    ; JMP NEAR CMPEXT
        dw      offset cmpext-offset @cmpnachname-3
cmpname endp

cmpext  proc
        push    si      ; wird undefiniert gendert
        push    di      ; wird undefiniert gendert
        add     si,10   ; Extension in Struktur an Position 10
        add     di,10   ; -"-
        mov     cx,3    ; Lnge 3 Byte
        repe    cmpsb   ; bis zur ersten Nichtbereinstimmung
        dec     si      ; ein Byte zu weit gezhlt
        dec     di      ; -"-
        mov     al,byte ptr es:[si]
        cmp     al,byte ptr es:[di]
        pop     di      ; restaurieren fr nchste Instanz
        pop     si      ; restaurieren fr nchste Instanz
        ja      @cmpstc
        jb      @cmpclc
@cmpnachext:    ; Patch-bezogenes Label - nicht verndern!!!
        db      0E9h    ; JMP NEAR @CMPSTC
        dw      offset @cmpstc-offset @cmpnachext-3
cmpext  endp

; Dies ist eine duale Compare-Proc, die aus einem primren und einem sekundren
; Vergleich zweier Words besteht. Durch Patchen der Positionsadressen der
; Dateistruktur lassen sich dadurch beide Sortierungen (nach Datum/Zeit bzw.
; nach Dateigre) realisieren. Die nchste Instanz wird bei gleichen Werten
; automatisch angesprungen, sofern die entsprechende Sprungadresse nicht auf die
; Endinstanz zeigt (STC).
cmpword proc
@cmpwordpatch0: ; Patch-bezogenes Label - nicht verndern!!!
        mov     ax,es:[si+19]   ; Position patchen (ip+3)
@cmpwordpatch1: ; Patch-bezogenes Label - nicht verndern!!!
        cmp     ax,es:[di+19]   ; Position patchen (ip+3)
        ja      @cmpstc
        jb      @cmpclc
@cmpwordpatch2: ; Patch-bezogenes Label - nicht verndern!!!
        mov     ax,es:[si+17]   ; Position patchen (ip+3)
@cmpwordpatch3: ; Patch-bezogenes Label - nicht verndern!!!
        cmp     ax,es:[di+17]   ; Position patchen (ip+3)
        ja      @cmpstc
        jb      @cmpclc
        jmp     cmpname         ; derzeit kein Patch vorgesehen (da unntig!)
cmpword endp

; Diese Proc vergleicht wie normal nach Name und nach Erweiterung, setzt jedoch
; vorher noch die Prioritt auf die Eigenschaft TAGGED. Dadurch knnen alle
; markierten Files bequem an den Anfang der Dateiliste gestellt werden. Ein
; einfacher Service, den ich noch nirgens gefunden habe!
cmptag  proc
        mov     al,byte ptr es:[si]
        mov     ah,al
        xor     al,byte ptr es:[di]     ; Bit 7 nur 1 wenn EIN tagged File
        test    al,128
        jz      cmpname                 ; JMP wenn beide gleich
        test    ah,128
        jnz     @cmpclc
        jmp     @cmpstc
cmptag  endp

; in SI wird der Index auf die Struktur bergeben. Der Wert an dieser Stelle ist
; mit dem gespeicherten Wert von GETVALUE zu vergleichen. Sollte der dort
; vorgefundene Wert grer oder gleich dem Abgelegten ist, so ist das Carry-Flag
; zu setzen, ansonst zu lschen.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP
; nderbare Register: AX, BX, BP, DS, ES
compare1 proc
        push    si
        push    di
        push    cx
        mov     ax,si
        shl     si,4
        add     si,ax
        shl     ax,3
        add     si,ax
        add     si,bp                   ; +Startoffset der Struktur
        mov     di,bx                   ; Offset aus GETVALUE
        jmp     compareallg             ; allgemeines Vergleichen
compare1 endp                           ; RET bei angesprungener Routine

; in DI wird der Index auf die Struktur bergeben. Der Wert an dieser Stelle ist
; mit dem gespeicherten Wert von GETVALUE zu vergleichen. Sollte der dort
; vorgefundene Wert kleiner oder gleich dem Abgelegten ist, so ist das Carry-
; Flag zu setzen, ansonst zu lschen.
; nicht nderbare Register: CX, DX, SI, DI, SS, SP
; nderbare Register: AX, BX, BP, DS, ES
compare2 proc
        push    si
        push    di
        push    cx
        mov     ax,di
        shl     di,4
        add     di,ax
        shl     ax,3
        add     di,ax
        add     di,bp                   ; +Startoffset der Struktur
        mov     si,bx                   ; Offset aus GETVALUE
        jmp     compareallg             ; allgemeines Vergleichen
compare2 endp                           ; RET bei angesprungener Routine

; Dies ist der Koordinator der Sortierung. Die ganze Drecksarbeit bernehmen
; die ganzen anderen Proc's (TAUSCHEN, 2x VERGLEICHEN, VERGLEICHSWERTHOLEN)
; Dieser Proc werden in SI der kleinste Index und in DI der grte Index
; der Struktur bergeben. Mit Selbstmodifikatiion der Sprungadressen der
; ganzen Nigger-Prozeduren kann die Sortierroutine sogar allgemein verwendet
; werden.
qsort   proc
        or      al,al
        jz      @qsbegin        ; Sortierung wie die Letzte -> kein patchen
        cmp     al,5            ; Standart-Sortierung?
        ja      @qsnostandart
        mov     byte ptr cs:@qspatcher0,0E9h    ; jmp (GETVALUE)
        mov     byte ptr cs:@qspatcher1,0E9h    ; jmp (TAUSCHE)
        mov     byte ptr cs:@qspatcher2,0E8h    ; call (COMPARE1)
        mov     byte ptr cs:@qspatcher3,0E8h    ; call (COMPARE2)
        ; Brutalo-Patch der Sprungaddressen:
        mov     word ptr cs:@qspatcher0+1,offset getvalue-offset @qspatcher0-3
        mov     word ptr cs:@qspatcher1+1,offset tausche-offset @qspatcher1-3
        mov     word ptr cs:@qspatcher2+1,offset compare1-offset @qspatcher2-3
        mov     word ptr cs:@qspatcher3+1,offset compare2-offset @qspatcher3-3
        cmp     al,1
        jne     @qsnoname
        mov     word ptr cs:@cmpnachallg+1,offset cmpname-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachname+1,offset cmpext-offset @cmpnachname-3
        mov     word ptr cs:@cmpnachext+1,offset @cmpstc-offset @cmpnachext-3
        jmp     @qsbegin
@qsnoname:
        cmp     al,2
        jne     @qsnoext
        mov     word ptr cs:@cmpnachallg+1,offset cmpext-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachext+1,offset cmpname-offset @cmpnachext-3
        mov     word ptr cs:@cmpnachname+1,offset @cmpstc-offset @cmpnachname-3
        jmp     @qsbegin
@qsnoext:
        cmp     al,5
        jne     @qsnotag
        mov     word ptr cs:@cmpnachallg+1,offset cmptag-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachname+1,offset cmpext-offset @cmpnachname-3
        mov     word ptr cs:@cmpnachext+1,offset @cmpstc-offset @cmpnachext-3
        jmp     @qsbegin
@qsnotag:
        mov     word ptr cs:@cmpnachallg+1,offset cmpword-offset @cmpnachallg-3
        mov     word ptr cs:@cmpnachname+1,offset cmpext-offset @cmpnachname-3
        mov     word ptr cs:@cmpnachext+1,offset @cmpstc-offset @cmpnachext-3
        cmp     al,3
        jne     @qsdatetime
        mov     byte ptr cs:@cmpwordpatch0+3,19
        mov     byte ptr cs:@cmpwordpatch1+3,19
        mov     byte ptr cs:@cmpwordpatch2+3,17
        mov     byte ptr cs:@cmpwordpatch3+3,17
        jmp     @qsbegin
@qsdatetime:
        mov     byte ptr cs:@cmpwordpatch0+3,13
        mov     byte ptr cs:@cmpwordpatch1+3,13
        mov     byte ptr cs:@cmpwordpatch2+3,15
        mov     byte ptr cs:@cmpwordpatch3+3,15
        jmp     @qsbegin
@qsnostandart:
        ret
@qsbegin:
        mov     word ptr cs:@qsort_patch1+2,di  ; globale Grenzen setzen
        mov     word ptr cs:@qsort_patch2+2,si
        mov     word ptr cs:links_fertig+2,sp
@qsort:
        mov     bx,si
        add     bx,di
        shr     bx,1            ; Mittelwert des Bereiches fr Vergleiche sichern lassen
@qspatcher0:    ; Patch-bezogenes Label - nicht verndern!!!
        jmp     getvalue        ; bei Bedarf patchen
@qsnachget:     ; Rcksprunglabel - bei Standartsortierung ein CALL weniger!
        mov     cx,si           ; und die Bereichsgrenzen
        mov     dx,di           ; in CX und DX sichern

links_naeher:
@qspatcher2:    ; Patch-bezogenes Label - nicht verndern!!!
        call    compare1        ; bei Bedarf patchen
        jc      links_dran      ; Wert, der grer oder gleich ist gefunden?
@qsort_patch1:  ; Patch-bezogenes Label - nicht verndern!!!
        cmp     si,1234h        ; Test auf Bereichsberlauf!!! - wird gepatcht
        jae     links_dran
        inc     si              ; schrittweise nach oben wandern
        jmp     links_naeher

links_dran:
@qspatcher3:    ; Patch-bezogenes Label - nicht verndern!!!
        call    compare2        ; bei Bedarf patchen
@qsnachcmp2:
        jc      rechts_dran     ; Wert, der grer oder gleich ist gefunden?
@qsort_patch2:  ; Patch-bezogenes Label - nicht verndern!!!
        cmp     di,1234         ; Test auf Bereichsberlauf!!! - wird gepatcht
        jle     rechts_dran
        dec     di              ; schrittweise nach unten wandern
        jmp     links_dran
rechts_dran:
        cmp     si,di           ; Wenn dann auch noch SI kleiner ist als DI
        ja      end_schl
@qspatcher1:    ; Patch-bezogenes Label - nicht verndern!!!
        jmp     tausche         ; bei Bedarf patchen
@qsnachswap:    ; Rcksprunglabel - ein CALL weniger bei Standartsortierung
        inc     si
        dec     di
end_schl:
        cmp     cx,di           ; rekursive Bereiche auf deren vollstndige
        jge     rechts_fertig   ; Sortierung prfen und entsprechend weiter
        push    si              ; verzweigen oder Rekursion beenden
        push    dx
        mov     si,cx
        jmp     @qsort
links_fertig:   ; Patch-bezogenes Label - nicht verndern!!!
        cmp     sp,1234h        ; etwas brutal - ich geb's zu - aber immerhin
        je      @qsendlichfertig  ; kein rekursiver CALL mehr in der PROC!!!
        pop     dx
        pop     si
rechts_fertig:
        mov     di,dx           ; und nach dem Restaurieren der zwei lokalen
        cmp     di,si           ; Variablen nun noch die andere Seite
        jle     links_fertig    ; und auch hier wieder ohne CALL!
        jmp     @qsort
@qsendlichfertig:
        ret
qsort   endp

anfang:
        ; ganz gewhnliche Stack-Anpassung - sollte in keinem Programm fehlen
        cli                     ; Stack bereitstellen
        mov     ax,cs
        mov     ss,ax
        mov     sp,(offset done)+500 ; Stack erstellen
        sti

        ; berflssigen Speicher wie gewohnt freigeben
        mov     ah,4Ah          ; Speicher anpassen
        push    cs
        pop     es
        mov     bx,(offset done)+520 ; Sicherheitsbereich wegen Runden
        shr     bx,4            ; Angabe in Paragraphen
        int     21h             ; unbentigten Speicher freigeben
        jc      ende            ; Fehler!

        xor     si,si
        mov     di,18
        mov     bp,offset sortiere
        mov     al,5
        call    qsort
        push    cs
        pop     es
        call    ausgabe


ende:
        mov     ax,4C00h
        int     21h             ; beenden ohne Fehlercode

done:
code    ends
        end     entry
