
;ͻ
;                                                                             
;                KFULL.ASM   Overlay-Datei fr SHELL-SYSTEM             
;                                                                             
;                         beinhaltet Interrupt-Handler                        
;                                                                             
;                         Code : 1996 iCode [Falcon]                          
;                                                                             
;ͼ


; Aktivierung durch CTRL-ALT-ENTF, INT 0, INT 6 (optional INT 3)


; Anmerkungen: - DS sollte immer gleich mit CS sein
;              - 80386er Opcodes werden verwandt
;              - Eine farbige VGA-Karte ist erforderlich (wegen $B800 )



; Fr die Installation des Handlers (aus der Shell raus) mu Speicher allokiert
; werden (im Umfang der Filegre) und anschlieend der Programmcode dort hi-
; neingeladen werden (Offset 0, nicht 100h !). (Dafr knnte man den Overlay-
; loader benutzen, den ich irgendwann mal geschrieben habe.)
; Dann mu mit einem call-far auf diesen Punkt gesprungen werden.
; Wird ein zweites mal auf den gleichen entry-point (ofs 0) gesprungen, so wird
; die routine wieder deinstalliert...




.386p




code    segment use16
        assume  cs:code,ds:code,USE16
        org     100h
entry:  jmp     realStart


; Konstanten-Definition:

        timerConst equ 10 * 1000        ; = 10 Sekunden Count-Down
        filename   db 'c:\shell\system\int'
        CallingInt db '9'
                   db '.sys',0


; Variablen-Definition:

        countDown    dw   0             ; Count-Down-Zhlvariable
        protMode     db   0             ; 0 = Real-Mode, 1 = Protected Mode
        active       db   0             ; 1 = Men ist aktiv
        filehandle   dw   0             ; Handle fr verschiedenste Files
        startvalue   dw  -4             ; Startoffset fr den Memory-Parser
        grmode       db   0             ; Ursprnglicher Grafikmodus
        diskFlag     db   0             ; 1 = Interrupt 13h ist aktiv
        vect0        dd   0             ; hlt ursprnglichen Interrupt 0
        vect3        dd   0             ; hlt ursprnglichen Interrupt 3
        vect6        dd   0             ; hlt ursprnglichen Interrupt 6






; Die folgende Tabelle hlt die ursprnglichen Werte aller Register.
; FS, GS, SS und EBP mssen nicht abgelegt werden, da sie nicht modifiziert
; werden. Die Reihenfolge der Variablen darf nicht verndert werden, da auf sie
; beim Auslesen unindiziert, d.h. sequentiell, zugegriffen wird.

        _eax          dd 0              ; Alter Wert des EAX-Registers
        _ebx          dd 0              ; Alter Wert des EBX-Registers
        _ecx          dd 0              ; Alter Wert des ECX-Registers
        _edx          dd 0              ; Alter Wert des EDX-Registers
        _edi          dd 0              ; Alter Wert des EDI-Registers
        _esi          dd 0              ; Alter Wert des ESI-Registers
        _esp          dd 0              ; Alter Wert des ESP-Registers
        _cs           dw 0              ; Altes Code-Segment
        _ip           dw 0              ; Alter Instruction-Pointer
        _ds           dw 0              ; Altes Daten-Segment
        _es           dw 0              ; Altes Extra-Segment
        _flags        dw 0              ; Ursprngliches Flag-Word





; Diese folgende Tabelle beinhaltet Code-Sequenzen zum kopieren diverser Re-
; gister in das EAX-Register. Dies spart code bei den spter folgenden MOV-Befehlen, die dann
; einfach gepatcht werden. Jedem Word mu '0fh' vorangestellt werden, '0f20c0'
; zum Beispiel bedeutet "mov eax, cr0".
; Auch die Reihenfolge dieser konstanten darf nicht verndert werden, da auch
; auf sie sequentiell zugegriffen wird.

    patchTab:
        dw 0c020h                       ; CR0
        dw 0d020h                       ; CR2
        dw 0d820h                       ; CR3
        dw 0c021h                       ; DR0
        dw 0c821h                       ; DR1
        dw 0d021h                       ; DR2
        dw 0d821h                       ; DR3
        dw 0f021h                       ; DR6
        dw 0f821h                       ; DR7
        dw 0d821h                       ; TR3
        dw 0e024h                       ; TR4
        dw 0e824h                       ; TR5
        dw 0f024h                       ; TR6
        dw 0f824h                       ; TR7




; Die folgende Prozedur wird in den Interrupt 13h (Disk-Zugriff) eingeklinkt.
; Sie setzt bei jedem Aufruf des Interrupt 13h ein Flag, welches ber den
; Interrupt 8 (Timer) wieder dekrementiert wird. Solange dieses Flag ungleich
; 0 ist, kann der Interrupt-Handler nicht gestartet werden, um einen System-
; Hnger aufgrund einem doppelten Disk-Zugriff zu vermeiden.

int13   proc
        mov cs:byte ptr diskFlag-100h, 8
        db 0eah
        Vect13 dd 0
int13   endp






; Die folgende Prozedur wird in den Interrupt 8 (Timer) eingeklinkt. Sie hat
; zwei Funktionen. Einerseits dekrementiert sie das Flag, welches von der
; Interrupt-13h-Prozedur gesetzt wurde (erluterung siehe Prozedur int13).
; Andererseit dekrementiert sie die Count-Down-Variable, welche auf 10 Sec
; gesetzt wird, sobald das Men erscheint. Sollte die Variable auf Null de-
; krementiert werden, so wird zur Prozedur "endTask" verzweigt.


int8   proc
        cmp cs:word ptr countDown-100h, 0
        je noCountdwn
        dec cs:word ptr countDown-100h
        jnz noCountDwn
	mov al, 20h
	out 20h, al
        jmp endTask
      noCountDwn:
        dec cs:byte ptr diskFlag-100h
        jns leaveProc
        inc cs:byte ptr diskFlag-100h
      leaveProc:
        db 0eah
        vect8 dd 0
int8   endp






; Die folgende Prozedur wird vom Memory-Parser bentigt und gibt drei Zeilen a
; jeweils vier Bytes samt der zugehrigen ASCII-Zeichen aus. Die Byte-Werte
; mssen bei ds:si stehen.

drawDump proc
        mov dl, 3
    lineLoop:
        mov cx, 4
    rowLoop:
        lodsb
        call drawByte
        mov al, 20h
        stosb
        inc di
        loop rowLoop
        sub si, 4
        mov cx, 4
    rowLoop2:
        lodsb
        stosb
        inc di
        loop rowLoop2
        add di, 160-32
        dec dl
        jnz lineLoop
        ret
drawDump endp



; Die folgende Prozedur gibt den Wert der unteren 4 Bits des AL-Registers he-
; xadezimal aus.
; ES:DI mu auf das Video-Ram zeigen.

drawNibble proc
    and al, 0fh
    cmp al, 9
  ja @hex_wert
    add al, 30h
    jmp @fertig
  @hex_wert:
    add al, 37h
  @fertig:
    stosb
    inc di
    ret
drawNibble endp




; Die folgende Prozedur gibt den Wert des AL-Registers hexadezimal aus.
; ES:DI mu auf das Video-Ram zeigen.

drawByte proc
        push ax
        shr al, 4
        call drawNibble
        pop ax
        call drawNibble
        ret
drawByte endp





; Die folgende Prozedur gibt den Wert des AX-Registers hexadezimal aus.
; ES:DI mu auf das Video-Ram zeigen.

drawWord proc
        push ax
        shr ax, 8
        call drawByte
        pop ax
        call drawByte
        ret
drawWord endp





; Die folgende Prozedur gibt den Wert des EAX-Registers hexadezimal aus.
; ES:DI mu auf das Video-Ram zeigen.

drawDouble proc
        push eax
        shr eax, 16
        call drawWord
        pop eax
        call drawWord
        add di, 160-16
        ret
drawDouble endp





; Die folgende Prozedurt wird in den Interrupt 0 (Division durch 0) einge-
; klinkt. Sie ruft sofort das Men auf.

Int0 proc
        push ax
        mov al, '0'
        jmp initHandler
int0 endp




; Die folgende Prozedur wird in den Interrupt 3 (Breakpoint) eingeklinkt.
; Sie ruft sofort das Men auf.
        
  Int3:
        push ax
        mov al, '3'
        jmp InitHandler





; Die folgende Prozedur wird in den Interrupt 6 (Unbekannter Opcode) einge-
; klinkt. Sie ruft sofort das Men auf.

Int6 proc
        push ax
        mov al, '6'
int6 endp






; Die folgende Prozedur baut das Men auf und wertet die Tastatur-Eingaben aus.


InitHandler:

  ; Den Dateinamen fr das Screen-Pic patchen

        mov cs:byte ptr CallingInt-100h, al
        pop ax

  ; berprfen, ob ein Diskzugriff vorliegt. Wenn ja, den Menaufbau unterbre-
  ; chen und den Interrupt beenden.

        cmp cs:byte ptr DiskFlag-100h,0
        jne supress

  ; Die Register-Werte sichern und das Active-Flag auf 1 setzen, damit das Men
  ; nicht rekursiv aufgerufen werden kann. Die ursprngliche Werte fr CS, IP
  ; und Flags werden vom Stack gelesen.

        mov cs:word ptr _ds-100h, ds
        push cs
        pop  ds
        mov byte ptr active-100h, 1
        mov word ptr _es-100h, es
        mov dword ptr _eax-100h, eax
        mov dword ptr _ebx-100h, ebx
        mov dword ptr _ecx-100h, ecx
        mov dword ptr _edx-100h, edx
        mov dword ptr _edi-100h, edi
        mov dword ptr _esi-100h, esi
        mov dword ptr _esp-100h, esp
        pop word ptr _ip-100h
        pop word ptr _cs-100h
        pop word ptr _flags-100h
        sub sp, 6
        sti

  ; Alle Register pushen, geht beim Restaurieren dann schneller, als die Var-
  ; iablen alle einzeln zurckzuschreiben.

        pushad
        push word ptr _ds-100h
        push es

  ; Den Interrupt-Kontroller zurcksetzen

        mov al,20h
        out 20h,al

  ; Residente Software-Caches entleeren

        mov ax, 4a10h
        mov bx, 1
        int 2fh                         ; smartdrv
        mov ah, 21h
        int 13h                         ; quickcache
        mov ah, 0a1h
        mov si, 4358h
        int 13h                         ; super pc-kwik
        mov ax, 0ffa5h
        mov cx, 0ffffh
        int 16h                         ; pc-cache
        mov ax, 0fe03h
        mov di, 4e55h
        mov si, 4346h
        int 2fh                         ; nu-cache

  ; Grafikmodus abfragen, und, falls ntig, in den Textmodus schalten ohne da-
  ; bei das Video-Ram zu lschen. Wenn dann spter wieder in den Grafikmodus
  ; geschaltet wird, ist nmlich ein Groteil der grafik noch erhalten.

        mov ah, 0fh
        int 10h
        mov byte ptr grmode-100h, al
        cmp al, 4
        jb TextModus
        mov ax, 83h
        int 10h
      TextModus:


  ; Die Bilddaten direkt in die letzte Seite des Video-Rams lesen. Der Datei-
  ; name wurde bereits zuvor auf den richtigen Namen gepatcht (initHandler).

        mov dx, offset filename-100h
        mov ax, 3d02h
        int 21h
        mov word ptr filehandle-100h, ax
        mov bx, ax
        mov ah, 3fh
        mov cx, 4000
        push 0bf00h
        pop ds
        xor dx, dx
        int 21h
        push cs
        pop ds
        call closeFile

  ; Wenn die CPU im Protected-Mode ist, protMode auf 1 setzen und auf dem Bild-
  ; schirm die Option "[F2]" fr Fast-Boot in grau darstellen, weil sie im
  ; Protected-Mode deaktiviert ist.

        mov eax, cr0
        xor bl, bl
        test al, 1
        jz RealMode
        inc bl
        mov ax, 7846h
        push 0bf64h
        pop es
        mov di, 08h
        stosw
        mov al, '2'
        stosw
      RealMode:
        mov byte ptr protMode-100h, bl

  ; Die Werte der sieben 32-Bit-Register ausgeben, die in der Tabelle sequen-
  ; tielle abgelegt wurden.

        push 0bf00h
        pop  es
        mov di, 862+160
        mov si, offset _eax-100h
        mov cx, 7

      LoopReg32:
        lodsd
        call drawDouble
        loop LoopReg32

  ; Den Wert des EBP-Registers ausgeben, das ja nicht modifiziert wurde und von
  ; daher auch nicht in der Tabelle steht.

        mov eax, ebp
        call drawDouble

  ; Die Werte der vier 16-Bit-Register ausgeben, die in der Tabelle sequentiell
  ; abgelegt wurden.
                    
        mov bx, 160-8
        mov cx, 4
      LoopReg16:
        lodsw
        call drawWord
        add di, bx
        loop LoopReg16

  ; Den Wert des FS-Registers ausgeben, welches ja nicht modifiziert wurde und
  ; daher auch nicht in der Tabelle steht

        mov ax, fs
        call drawWord
        add di, bx

  ; Den Wert des GS-Registers ausgeben, welches ja nicht modifiziert wurde und
  ; daher auch nicht in der Tabelle steht

        mov ax, gs
        call drawWord
        add di, bx

  ; Den Wert des SS-Registers ausgeben, welches ja nicht modifiziert wurde und
  ; daher auch nicht in der Tabelle steht

        mov ax, ss
        call drawWord

  ; Wenn sich die CPU im Real-Modus befindet, die Werte aller CR-, DR- und TR-
  ; Register ausgeben (Im Protected-Mode hagelt es dann Schutzverletzungen).
  ; Die Register wurden ja nicht modifiziert, wurden daher auch nicht in ir-
  ; gendeiner Tabelle gesichert. Um aber Code zu sparen, sind die Instruktionen
  ; als Konstanten in der patchTab abgelegt (siehe patchTab).

        cmp byte ptr protMode-100h, 1
        je NoProtRegs
        mov di, 888+160
        mov si, offset patchTab-100h
        mov cx, 14
      LoopProtReg:
        lodsw
        mov word ptr modify-100h, ax
        jmp $+2
        db 0fh
        modify dw 0h
        call drawDouble
        loop LoopProtReg
      NoProtRegs:

  ; Die gesicherten Flags aus der Tabelle als Word ausgeben.

        mov ax, word ptr _flags-100h
        mov di, 3422+160
        call drawWord

  ; Den Start-Offset des Memory-Parsers als Word ausgeben.

        mov di, 1100
        mov ax, word ptr startvalue-100h
        add ax, 4
        call drawWord

  ; Den Extrakt aus dem Code-Segment (CS:IP) ausgeben.

        mov di, 1402
        mov si, word ptr _ip-100h
        add si, word ptr startvalue-100h
        mov ds, word ptr _cs-100h
        call drawDump

  ; Den Extrakt aus dem Daten-Segment (DS:SI) ausgeben.

        mov di, 2042
        mov ds, cs:word ptr _ds-100h
        mov si, cs:word ptr _esi-100h
        add si, cs:word ptr startvalue-100h
        call drawDump

  ; Den Extrakt aus dem Extra-Segment (ES:DI) ausgeben.

        mov di, 2682
        mov ds, cs:word ptr _es-100h
        mov si, cs:word ptr _edi-100h
        add si, cs:word ptr startvalue-100h
        call drawDump

  ; Den Extrakt aus dem Stack-Segment (SS:SP) ausgeben.

        mov di, 3322
        push ss
        pop ds
        mov si, cs:word ptr _esp
        add si, cs:word ptr startvalue
        call drawDump

  ; jetzt auf die letzte Bildschirmseite umschalten, damit der ganze Text auch
  ; sichtbar wird. Soll der Text-Bildschirm wiederhergestellt werden, so mu
  ; lediglich wieder auf die erste Bildschirmseite umgeschaltet werden.

        push cs
        pop ds
        mov ax, 0507h                   ;
        int 10h                         ; letzte Bildschirmseite aktivieren

  ; Die Count-Down-Variable auf ihren Startwert setzen. Solange sie nmlich
  ; den Wert 0 hat, wird sie auch nicht dekrementiert. Besitzt sie aber ei-
  ; nen Wert ungleich 0, so ist der Count-Down aktiv (Interrupt 8).

        mov word ptr countDown-100h, timerConst

  ; Die Tastatur auf Eingaben berprfen

      GetKey:
        xor ah, ah
        int 16h
        cmp ah, 50h                     ; Cursor Down ?
        jne NoDown
        add word ptr startvalue-100h, 4
        jmp NoProtRegs
      NoDown:
        cmp ah, 48h                     ; Cursor Up ?
        jne NoUp
        sub word ptr startvalue-100h, 4
        jmp NoProtRegs
      NoUp:
        cmp ah, 47h                     ; Pos1 ?
        jne NoPos1
        mov word ptr startvalue-100h, 0-4
        jmp NoProtRegs
      NoPos1:
        cmp ah, 4eh
        jne NoPlus
        inc cs:word ptr _ip-100h
        jmp NoProtRegs
      NoPlus:
        cmp ah, 4ah
        jne NoMinus
        dec cs:word ptr _ip-100h
        jmp NoProtRegs
      NoMinus:
        cmp ah, 01h
        je Back                         ; ESC ?
        cmp ah, 3bh
        je EndTask                      ; F1 ?
        cmp byte ptr protMode-100h, 1
        je NoFastBoot
        cmp ah, 3ch
        je FastBoot                     ; F2 ?
      NoFastBoot:
        cmp ah, 3dh
        je WarmBoot                     ; F3 ?
        cmp ah, 3eh
        je ColdBoot                     ; F4 ?
        cmp ah, 3fh
        je SaveRam                      ; F5 ?
        jmp GetKey





; Die folgende Prozedur startet den Rechner neu.

warmBoot proc
        mov bx, 1234h
        jmp $+4
coldBoot proc
        xor bx, bx
	push 0
	pop ds
        mov ds:[472h], bx
        Call Restore_screen
        db 0eah, 0, 0, 0ffh, 0ffh       ; JMP FAR FFFF:0000
coldBoot endp
warmBoot endp






; Die folgende Prozedur ldt das Betriebssystem neu, ohne da der Rechner neu
; gestartet wird. Damit das BS berhaupt geladen werden kann, wird zuvor al-
; ler allokierter Speicher freigegeben.
        
fastBoot proc
        call Restore_Screen
        push 0
        pop es
      ReleaseLoop:
        mov ah, 49h
        int 21h
        mov ax, es
        inc ax
        mov es, ax
        jnz ReleaseLoop
        int 19h
fastBoot endp






; Die folgende Prozedur beendet den Interrupt-Handler und springt in das auf-
; rufende Programm zurck, als seie nichts geschehen.

back proc
        call restore_screen
        mov byte ptr active-100h, 0
        pop es
        pop ds
        popad
        iret
back endp





; Die folgende Prozedur sichert den Inhalt des gesamten ersten MBs plus des HMA
; in die Datei 'c:\shell\system\int_.sys'. Die Registerwerte werden zwar nicht
; gesichert, sind aber logischerweise in dieser Datei ab 0bf000h enthalten, denn
; dort beginnt ja die letzte Seite des Video-Rams

saveRam proc
        mov byte ptr CallingInt-100h, '_'
        call create_file
        xor ax, ax
        xor dx, dx
        mov cx, 8000h
      SaveLoop:
        mov ds, ax
        pusha
        call save_file
        popa
        add ax, 800h
        or ax, ax
        jnz saveLoop
        mov cx, 0ffffh
        mov ds, cx
        call save_file
        push cs
        pop ds
        call closeFile
        jmp Back
saveRam endp




; Die folgende Prozedur beendet das momentan aktive Programm mittels der Dos-
; Funktion 4ch. Vorher werden alle Interrupts aus der Datei gelesen, die beim
; Starten des Interrupt-Handlers angelegt wurde.

endTask proc
	push cs
	pop ds
        mov byte ptr CallingInt-100h, 'x'
        mov dx, offset filename-100h
        mov ax, 3d00h
        int 21h
        mov bx, ax
        mov ah, 3fh
        mov cx, 1024
        xor dx, dx
	mov ds, dx
        cli
        int 21h
        sti
        push cs
        pop  ds
        mov ah, 3eh
        int 21h
	xor al, al
        mov byte ptr active-100h, al
;        out     21h,al                  ; port 21h, 8259-1 int comands
;        out     0A1h,al                 ; port 0A1h, 8259-2 int comands
;        in      al,61h                  ; port 61h, 8255 port B, read
;        or      al,80h
;        out     61h,al                  ; port 61h, 8255 B - spkr, etc
;        and     al,7Ch
;        out     61h,al                        ; port 61h, 8255 B - spkr, etc
                                                ;  al = 0, speaker off
;        mov   al,36h                  ; '6'
;        out   43h,al                  ; port 43h, 8253 timer control
;        jmp   short $+2               ; delay for I/O
;        jmp   short $+2               ; delay for I/O
;        mov   ax,0FFFFh
;        out   40h,al                  ; port 40h, 8253 timer 0 clock
;        jmp   short $+2               ; delay for I/O
;        jmp   short $+2               ; delay for I/O
;        out   40h,al                  ; port 40h, 8253 timer 0 clock
        call restore_screen
	cmp grMode-100h, 4
	jb noSwitch
	mov ax, 3
	int 10h
    noSwitch:
        mov   ax,4c00h
        int   21h                     ; DOS Services  ah=function 4Ch
endTask endp





; Die folgende Prozedur wird von initHandler aus aufgerufen, falls ein Disk-
; Zugriff vorliegt und das Men nicht gestartet werden darf. In diesem Fall
; wird der Interrupt wieder beendet.

supress proc
        push ax
        mov al, 20h
        out 20h, al
        pop ax
        iret
supress endp




; Die folgende Prozedur schaltet gegebenenfalls wieder in den Grafikmodus zur-
; ck, sofern dieser beim Start des Mens aktiviert war. Der Bildschirminhalt
; wird dabei nicht gelscht. Sollte aber ein Texmodus aktiviert gewesen sein,
; so wird wieder auf die erste Seite des Video-Speichers zurckgeschaltet.

Restore_screen proc
        mov al, byte ptr grmode-100h
        cmp al, 4
        jb noGraphMode
        or al, 10000000b
        xor ah, ah
        int 10h
        ret
    noGraphMode:
        mov ax, 0500h
        int 10h
        ret
Restore_screen endp




; Die folgende Prozedur ruft den ursprnglichen Interrupt 9 auf, und wird immer
; dann aufgerufen, wenn eine eingegebene Taste nicht Entf ist, oder nicht beide
; Tasten Ctrl und Alt gedrckt sind.

oldInt9 proc
    popf
    pop ds
    popa
    db 0eah
    Vect9 dd 0
oldInt9 endp







; Die folgende Prozedur wird in den Interrupt 9 (Tastatur) eingeklinkt. Wenn
; die Kombination Ctrl-Alt-Entf gedrckt wird, dann wird das Men gestartet,
; anderenfalls der ursprngliche Handler aufgerufen.

int9 proc
        pusha
        push ds
        pushf
        push 0
        pop ds

        in al, 60h
        test al, 80h
        jnz noPush
        mov cs:word ptr countDown-100h, 0
    noPush:
        cmp al, 53h
        jne oldInt9
        mov bl, ds:byte ptr [417h]
        and bl,0ch
        cmp bl,0ch
        jne oldInt9
        popf
        pop ds
        popa
        push ax
        cmp cs:byte ptr active-100h, 1
        je supress
        mov al, '9'
        jmp InitHandler
int9 endp







; Die folgende Prozedur erzeugt eine Datei mit dem in filename stehenden
; Dateinamen. Dieser mu gepatcht werden. Das Handle wird in fileHandle ge-
; sichert

create_file proc
        mov ah, 3ch
        xor cx, cx
        mov dx, offset filename-100h
        int 21h
        mov word ptr filehandle-100h, ax
        ret
create_file endp




; Die folgende Prozedur sichert CX Bytes ab DS:DX in dem in fileHandle ange-
; gebenen File.

save_file proc
        mov bx, cs:word ptr filehandle-100h
        mov ah, 40h
        int 21h
        ret
save_file endp





; Die folgende Prozedur schliet das in fileHandle angegebene File

closeFile proc
        mov ah, 3eh
        mov bx, word ptr filehandle-100h
        int 21h
        ret
closeFile endp




; Es folgt die Installationsroutine. In ihr wird die Install-Routine so ge-
; patcht, da beim zweiten CALL-FAR auf den gleichen Offset die Routine wieder
; deinstalliert wird.

realStart:
     push cs
     pop  ds
     push 0
     pop  es
   @patch:
     jmp install

   deinstall:
     mov eax, dword ptr vect0-100h      ; Interrupt 0 zurckschreiben
     mov es:dword ptr [0], eax

     mov eax, dword ptr vect3-100h      ; Interrupt 3 zurckschreiben
     mov es:dword ptr [12], eax

     mov eax, dword ptr vect6-100h      ; Interrupt 6 zurckschreiben
     mov es:dword ptr [24], eax

     mov eax, dword ptr vect8-100h      ; Interrupt 8 zurckschreiben
     mov es:dword ptr [32], eax

     mov eax, dword ptr vect9-100h      ; Interrupt 9 zurckschreiben
     mov es:dword ptr [36], eax

     mov eax, dword ptr vect13-100h     ; Interrupt 13h zurckschreiben
     mov es:dword ptr [76], eax

     retf

   install:
     ; die Routine im Speicher patchen, damit beim nchsten Aufruf deinstalliert
     ; wird...

     mov word ptr @patch-100h, 9090h
     mov byte ptr @patch+2-100h, 90h

     ; Verschiedene Interrupt-Vektoren sichern

     mov eax, es:dword ptr [0]          ; Interrupt 0 auslesen
     mov dword ptr Vect0-100h, eax

     mov eax, es:dword ptr [12]         ; Interrupt 3 auslesen
     mov dword ptr Vect3-100h, eax

     mov eax, es:dword ptr [24]         ; Interrupt 6 auslesen
     mov dword ptr Vect6-100h, eax

     mov eax, es:dword ptr [32d]        ; Interrupt 8 auslesen
     mov dword ptr Vect8-100h, eax

     mov eax, es:dword ptr [36d]        ; Interrupt 9 auslesen
     mov dword ptr Vect9-100h, eax


     mov eax, es:dword ptr [76d]        ; Interrupt 13h auslesen
     mov dword ptr vect13-100h, eax

     ; die Interrupt 0, 3, 6, 8, 9, 13h auf dieses Prog umlenken

     mov ax, cs
     shl eax, 16
     mov ax, offset Int0-100h
     mov es:dword ptr [0], eax          ; Interrupt 0 setzen

     mov ax, offset Int3-100h
     mov es:dword ptr [12d], eax        ; Interrupt 3 setzen

     mov ax, offset Int6-100h
     mov es:dword ptr [24d], eax        ; Interrupt 6 setzen

     mov ax, offset Int8-100h
     mov es:dword ptr [32d], eax        ; Interrupt 8 setzen

     mov ax, offset Int9-100h
     mov es:dword ptr [36d], eax        ; Interrupt 9 setzen

     mov ax, offset Int13-100h
     mov es:dword ptr [76d], eax        ; Interrupt 13h setzen

     ; jetzt die Interrupts sichern, damit sie mit [F1] wiederhergestellt
     ; werden knnen

     mov byte ptr CallingInt-100h, 'x'
     call create_file
     mov cx, 1024
     xor dx, dx
     mov ds, dx
     call save_file
     push cs
     pop ds
     call closeFile


     ; Speicherblock verkleinern, die Install-Routine kann raus !

     mov bx, offset install-100h
     shr bx, 4
     inc bx
     push cs
     pop  es
     mov ah, 4ah
     int 21h

     retf
endp

code    ends
        end     entry

