
;ͻ
;                                                                             
;               KLITE.ASM   Overlay-Datei fr Shell-System              
;                                                                             
;                  beinhaltet den abgespeckten Interrupthandler               
;                                                                             
;                          Code : 1996 iCode [Falcon]                         
;                                                                             
;ͼ

; Fr die Installation des Handlers (aus der Shell raus) mu Speicher allokiert
; werden (im Umfang der Filegre) und anschlieend der Programmcode dort hi-
; neingeladen werden (Offset 0, nicht 100h !). (Dafr knnte man den Overlay-
; loader benutzen, den ich irgendwann mal geschrieben habe.)
; Dann mu mit einem call-far auf diesen Punkt gesprungen werden.
; Wird ein zweites mal auf den gleichen entry-point (ofs 0) gesprungen, so wird
; die routine wieder deinstalliert...



.286c



code    segment byte use16
        assume  cs:code,ds:code,use16
        org     100h
entry:  jmp     realStart


  ; Konstanten-Definition:

        int0msg db 14,'Division by 0:'
        int6msg db 15,'Illegal Opcode:'
        int9msg db 14,'Ctrl-Alt-Entf:'
        option1 db 13,'1 : Kill Task'
        option2 db 13,'2 : Fast Boot'
        option3 db 13,'3 : Warm Boot'
        option4 db 13,'4 : Cold Boot'

  ; Variablen-Definition:

        grMode       db 0h              ; Ursprnglicher Grafik-Modus
        msgOffset    dw 0h              ; Offset der User-Nachricht
					; Abhngig vom aufrufenden Interrupt
        vect0        dd 0               ; Ursprnglicher Interrupt 0
        vect6        dd 0               ; Ursprnglicher Interrupt 6







; Es folgt der Handler fr den Interrupt 9. Sobald Ctrl-Alt-Entf gedrckt wird,
; startet er das Men mit den Optionen.

int9 proc
        pusha
        push ds
        push es

    ; berprfen, ob Ctrl-Alt-Entf gedrckt wird

        in al, 60h
        cmp al,83d                      ; Entf-Taste ?
        jne noReset
        push 40h
        pop es
        mov bl,byte ptr es:[17h]
        and bl,0ch
        cmp bl,0ch                      ; Ctrl und Alt gedrckt ?
        jne noReset
        mov ax, offset int9msg-100h
        jmp menu

    noReset:

  ; Kein Ctrl-Alt-Entf -> alten Interrupt 9 aufrufen

        pop es
        pop ds
        popa
        db 0eah
        vect9 dd 0
int9 endp





; Es folgt der Handler fr den Interrupt 6. Sobal ein unbekannter Opcode kommt,
; wird das Men mit den Optionen gestartet

int6 proc
        pusha
        push ds
        push es
        mov ax, offset int6msg-100h
        jmp menu
int6 endp




; Es folgt der Handler fr den Interrupt 0. Sobald ein Programm versucht, durch
; 0 zu dividieren, kommt das Men mit den Optionen.

int0 proc
        pusha
        push ds
        push es
        mov ax, offset int0msg-100h
int0 endp






; Es folgt die Prozedur, um das Men aufzubauen, mit allem was dazugehrt.
; Bildschirm-sichern etc, Tastatur abfragen u.s.w.


menu proc
        push cs
        pop  ds
        mov msgOffset-100h, ax
        mov al, 20h
        out 20h, al

  ; Eventuell in Textmodus schalten (, ohne VGA-RAM zu lschen)

        mov ah, 0fh
        int 10h
        mov byte ptr grmode-100h, al
        cmp al, 4
        jb TextModus
        mov ax, 83h
        int 10h
        jmp noTextSave
  TextModus:

  ; Text-Bildschirm sichern

        push 0b800h
        pop  ds
        push 0b800h+256
        pop es
        xor si, si
        xor di, di
        mov cx, 2000
        rep movsb
        push cs
        pop  ds

  noTextSave:

  ; Testen, ob sich der Rechner im Protected-Mode befindet

	xor bp, bp
	.386p
	mov eax, cr0
	.286c
	test al, 1
	jz $+3
	inc bp

  ; Men aufbauen:

        push 0b800h
        pop es
	mov bx, 160-34			; Konstante. (Spart Code)
        xor di, di
        mov ax, 1020h
        mov cx, 17
        rep stosw
        add di, bx
        mov ax, 071ddh
        stosw
        mov ax, 73dch
        mov cx, 15
        rep stosw
        mov ax, 18ddh
        stosw
        add di, bx
	mov dl, 4
    lineLoop:
  	mov ax, 071ddh
  	stosw
  	mov ax, 3020h
  	mov cx, 15
  	rep stosw
  	mov ax, 18ddh
  	stosw
	add di, bx
	dec dl
	jnz lineLoop
        mov ax, 017deh
        stosw
        mov ax, 38dch
        mov cx, 15
        rep stosw
        mov ax, 18ddh
        stosw
        add di, bx
        mov ax, 1020h
        mov cx, 17
        rep stosw

  ; Je nach Art des aufrufenden Interrupts, eine entsprechende Nachricht aus-
  ; geben, damit der User wei, warum das Menue berhaupt startet

        mov si, word ptr msgOffset-100h
        xor di, di
        mov ah, 1ch
        call drawString

  ; Die Strings fr die verschiedenen Optionen ausgeben

        mov si, offset option1-100h
        mov di, 324
        mov ah, 3eh
        call drawString

        mov di, 484
	or bp, bp
	jz $+4
	mov ah, 37h
        call drawString

        mov di, 644
        mov ah, 3eh
        call drawString

        mov di, 804
        call drawString

  ; Jetzt werden die Tastatur-Eingaben ausgewertet

    keyLoop:
        xor ah, ah
        int 16h

        cmp ah, 1			; Escape 
        je back

        cmp al, '1'			; '1'
        je endTask

        or bp, bp			; im Prot-Mode fastBoot deaktiviert
    	jnz noFastBoot
        cmp al, '2'			; '2'
        je fastBoot
    noFastBoot:

        cmp al, '3'			; '3'
        je warmBoot

        cmp al, '4'  			; '4'
    	je coldBoot

    	jmp keyLoop

menu endp



; Prozedur fr Warm- und Kaltstart. Residente Software-Caches werden entleert.

    coldBoot:
    	call clearCacheBuffers
    	xor ax, ax
    	jmp boot
    warmBoot:
    	call clearCacheBuffers
    	mov ax, 1234h
    boot:
    	push 40h
    	pop  ds
    	mov ds:word ptr [072h], ax
    	db 0eah, 0, 0, 0ffh, 0ffh	; JMP nach FFFF:0000 -> Neustart



; Prozedur, um Men wieder zu verlassen. (Escape)

    back:
  	call restoreScreen
  	pop es
  	pop ds
  	popa
  	iret



; Prozedur, um aktives Programm zu beenden

    endTask:
   	call restoreScreen
  	mov ax, 4c00h
  	int 21h




; Prozedur, um Betriebssystem neu zu laden
 
    fastBoot:
  	call clearCacheBuffers

  ; Allen konventionellen Speicher freigeben !!!

  	xor ax, ax
  	mov es, ax
  	mov cx, 10
      memLoop:
    	mov ah, 49h
    	int 21h
    	mov ax, es
    	add ax, 1000h
    	mov es, ax
        loop memLoop

  ; Boot-Sektor einlesen...

        mov dl, 80h
        mov dh, 0
        mov ch, 0
        mov cl, 0
        mov al, 1
        mov bx, 7c00h
        mov ah, 2
        push 0
        pop  es
        int 13h

        db 0eah, 0, 7ch, 0, 0






restoreScreen proc

    ; Eventuell in den Grafikmodus zurckschalten

    mov al, byte ptr grmode-100h
    cmp al, 4
    jb restoreText
    or al, 10000000b                    ; Bit 7 = VGA-Memory nicht lschen
    xor ah, ah
    int 10h
    ret

  ; Text-Bildschirm wiederherstellen

  restoreText:

    push 0b800h+256
    pop ds
    push 0b800h
    pop es
    mov cx, 2000
    xor si, si
    xor di, di
    rep movsb
    ret
restoreScreen endp




drawString proc
	.386c
        movzx cx, byte ptr [si]
	.286c
	inc si
      stringLoop:
        lodsb
        stosw
      loop stringLoop
        ret
drawString endp




clearCacheBuffers proc

  ; SMARTDRV leeren

  	mov ax, 4a10h
  	mov bx, 1
  	int 2fh

  ; QUICKCACHE leeren

  	mov ah, 21h
  	int 13h

  ; SUPER PC-KWIK leeren

  	mov ah, 0a1h
  	mov si, 4358h
  	int 13h

  ; PC-CACHE leeren

  	mov ax, 0ffa5h
  	mov cx, 0ffffh
  	int 16h

  ; NU-CACHE leeren

  	mov ax, 0fe03h
  	mov di, 4e55h
  	mov si, 4346h
  	int 2fh

  	ret
clearCacheBuffers endp




realStart:
     push cs
     pop  ds
     push 0
     pop  es
   @patch:
     jmp install

   deinstall:
     .386c
     mov eax, dword ptr vect0-100h      ; Interrupt 0 zurckschreiben
     mov es:dword ptr [0], eax

     mov eax, dword ptr vect6-100h      ; Interrupt 6 zurckschreiben
     mov es:dword ptr [24], eax

     mov eax, dword ptr vect9-100h      ; Interrupt 9 zurckschreiben
     mov es:dword ptr [36], eax
    .286c

     retf

   install:
     ; die Routine im Speicher patchen, damit beim nchsten Aufruf deinstalliert
     ; wird...

     mov word ptr @patch-100h, 9090h
     mov byte ptr @patch+2-100h, 90h

     ; Die Interrupt-Vektoren 0, 6 und 9 sichern

     .386c
     mov eax, es:dword ptr [0]
     mov dword ptr vect0-100h, eax
     mov eax, es:dword ptr [24d]
     mov dword ptr vect6-100h, eax
     mov eax, es:dword ptr [36d]
     mov dword ptr vect9-100h, eax
     .286c

     ; Jetzt die Vektoren 0, 6 und 9 auf das TSR verbiegen

     mov es:word ptr [0], offset int0-100h
     mov es:word ptr [2], cs

     mov es:word ptr [24d], offset int6-100h
     mov es:word ptr [26d], cs

     mov es:word ptr [36d], offset int9-100h
     mov es:word ptr [38d], cs

     ; Speicherblock verkleinern, die Install-Routine kann raus !

     mov bx, offset install-100h
     shr bx, 4
     inc bx
     push cs
     pop  es
     mov ah, 4ah
     int 21h

     retf

code    ends
        end     entry

